package com.hartmath.lib;

import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;

import org.kaffe.java.lang.*;
import java.io.*;
import java.net.*;
import java.lang.*;
import java.applet.*;
import java.awt.Label;
import java.util.Properties;

/**
 * Defines a lot of static constants
 *
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class C
{
   final static public Label             statusLine = new Label("Loading HartMath");
   final static public SymbolEvaluator   dummyFunction = new SymbolEvaluator();
   final static public FunctionEvaluator loadScript    = new ELoadScript();
   final static public FunctionEvaluator loadClass     = new ELoadClass();
   final static public boolean           DEBUG = false;

   final static public String           version =
      new String("HartMath Version 0.6");
   final static public int              BUILD = 114;
   static public boolean                initialized = false;
   static public URL                    codeBase = null;
   static public int                    count = 0;
   static public ResultOutput           resultOut;
//   static public ResultOutput           traceOut;
   static public ResultOutput           errorOut;
   static public ResultOutput           statusOut;

   static public boolean                showInOut = true;
   static public int                    timeConstrained = 0;
   static public boolean                numericFlag = false;

   static public boolean                traceEval = false;
   static public HFunction              traceList = null;

//   static public boolean                traceFlag = false;
//   static public boolean                traceExtendedFlag = false;
//   static public boolean                traceRuleFlag = false;
   //static public boolean                numericFlag = false;
   static public int                    recursionLimit = -1;
   static public int                    iterationLimit = -1;
   static public int                    recursionCounter;
   static public int                    iterationCounter;
   static public HArrayList             InArray = new HArrayList();
   static public HArrayList             OutArray = new HArrayList();

   /**
    * Constant: HDouble value -1.0
    */
   final static public HDouble          CDN1 = new HDouble(-1.0d);

   /**
    * Constant: HDouble value 0.0
    */
   final static public HDouble          CD0 = new HDouble(0.0d);

   /**
    * Constant: HDouble value 1.0
    */
   final static public HDouble          CD1 = new HDouble(1.0d);

   /**
    * Constant: HInteger value -5
    */
   final static public HInteger         CN5 = new HInteger(HInteger.IN5);

   /**
    * Constant: HInteger value -4
    */
   final static public HInteger         CN4 = new HInteger(HInteger.IN4);

   /**
    * Constant: HInteger value -3
    */
   final static public HInteger         CN3 = new HInteger(HInteger.IN3);

   /**
    * Constant: HInteger value -2
    */
   final static public HInteger         CN2 = new HInteger(HInteger.IN2);

   /**
    * Constant: HInteger value -1
    */
   final static public HInteger         CN1 = new HInteger(HInteger.IN1);

   /**
    * Constant: HInteger value 0
    */
   final static public HInteger         C0 = new HInteger(HInteger.I0);

   /**
    * Constant: HInteger value 1
    */
   final static public HInteger         C1 = new HInteger(HInteger.I1);

   /**
    * Constant: HInteger value 2
    */
   final static public HInteger         C2 = new HInteger(HInteger.I2);

   /**
    * Constant: HInteger value 3
    */
   final static public HInteger         C3 = new HInteger(HInteger.I3);

   /**
    * Constant: HInteger value 4
    */
   final static public HInteger         C4 = new HInteger(HInteger.I4);

   /**
    * Constant: HInteger value 5
    */
   final static public HInteger         C5 = new HInteger(HInteger.I5);

   /**
    * Constant: HInteger value 10
    */
   final static public HInteger         C10 = new HInteger(HInteger.I10);

   /**
    * Constant: HInteger value 100
    */
   final static public HInteger         C100 = new HInteger(HInteger.I100);
   /**
    * Constant: HFraction value 1/2
    */
   final static public HFraction        C1D2 = new HFraction(HInteger.I1, 
   HInteger.I2);

   /**
    * Constant: HFraction value 1/3
    */
   final static public HFraction        C1D3 = new HFraction(HInteger.I1, 
   HInteger.I3);

   /**
    * Constant: HFraction value 1/4
    */
   final static public HFraction        C1D4 = new HFraction(HInteger.I1, 
   HInteger.I4);

   /**
    * Constant: HFraction value 1/5
    */
   final static public HFraction        C1D5 = new HFraction(HInteger.I1, 
   HInteger.I5);

   /**
    * Constant: HFraction value 1/6
    */
   final static public HFraction        C1D6 = new HFraction(HInteger.I1, 
   HInteger.I6);

   /**
    * Constant: HFraction value 1/7
    */
   final static public HFraction        C1D7 = new HFraction(HInteger.I1, 
   HInteger.I7);

   /**
    * Constant: HFraction value 1/8
    */
   final static public HFraction        C1D8 = new HFraction(HInteger.I1, 
   HInteger.I8);

   /**
    * Constant: HFraction value 1/9
    */
   final static public HFraction        C1D9 = new HFraction(HInteger.I1, 
   HInteger.I9);

   /**
    * Constant: HFraction value 1/10
    */
   final static public HFraction        C1D10 = new HFraction(HInteger.I1, 
   HInteger.I10);

   /**
    * Constant: HFraction value 2/3
    */
   final static public HFraction        C2D3 = new HFraction(HInteger.I2, 
   HInteger.I3);

   /**
    * Constant: HFraction value 3/4
    */
   final static public HFraction        C3D4 = new HFraction(HInteger.I3, 
   HInteger.I4);

   /**
    * Constant: HFraction value 2/5
    */
   final static public HFraction        C2D5 = new HFraction(HInteger.I2, 
   HInteger.I5);

   /**
    * Constant: HFraction value 3/5
    */
   final static public HFraction        C3D5 = new HFraction(HInteger.I3, 
   HInteger.I5);

   /**
    * Constant: HFraction value 4/5
    */
   final static public HFraction        C4D5 = new HFraction(HInteger.I4, 
   HInteger.I5);

   /**
    * Constant: HFraction value 5/6
    */
   final static public HFraction        C5D6 = new HFraction(HInteger.I5, 
   HInteger.I6);

   /**
    * Constant: HFraction value 2/7
    */
   final static public HFraction        C2D7 = new HFraction(HInteger.I2, 
   HInteger.I7);

   /**
    * Constant: HFraction value 3/7
    */
   final static public HFraction        C3D7 = new HFraction(HInteger.I3, 
   HInteger.I7);

   /**
    * Constant: HFraction value 4/7
    */
   final static public HFraction        C4D7 = new HFraction(HInteger.I4, 
   HInteger.I7);

   /**
    * Constant: HFraction value 5/7
    */
   final static public HFraction        C5D7 = new HFraction(HInteger.I5, 
   HInteger.I7);

   /**
    * Constant: HFraction value 6/7
    */
   final static public HFraction        C6D7 = new HFraction(HInteger.I6, 
   HInteger.I7);

   /**
    * Constant: HFraction value -1/2
    */
   final static public HFraction        CN1D2 = new HFraction(HInteger.IN1, 
   HInteger.I2);

   /**
    * Constant: HFraction value -1/3
    */
   final static public HFraction        CN1D3 = new HFraction(HInteger.IN1, 
   HInteger.I3);

   /**
    * Constant: HFraction value -1/4
    */
   final static public HFraction        CN1D4 = new HFraction(HInteger.IN1, 
   HInteger.I4);

   /**
    * Constant: HFraction value -1/5
    */
   final static public HFraction        CN1D5 = new HFraction(HInteger.IN1, 
   HInteger.I5);

   /**
    * Constant: HFraction value -1/6
    */
   final static public HFraction        CN1D6 = new HFraction(HInteger.IN1, 
   HInteger.I6);

   /**
    * Constant: HFraction value -1/7
    */
   final static public HFraction        CN1D7 = new HFraction(HInteger.IN1, 
   HInteger.I7);

   /**
    * Constant: HFraction value -1/8
    */
   final static public HFraction        CN1D8 = new HFraction(HInteger.IN1, 
   HInteger.I8);

   /**
    * Constant: HFraction value -1/9
    */
   final static public HFraction        CN1D9 = new HFraction(HInteger.IN1, 
   HInteger.I9);

   /**
    * Constant: HFraction value -1/10
    */
   final static public HFraction        CN1D10 = new HFraction(HInteger.IN1, 
   HInteger.I10);

   /**
    * Constant: HFraction value -2/3
    */
   final static public HFraction        CN2D3 = new HFraction(HInteger.IN2, 
   HInteger.I3);

   /**
    * Constant: HFraction value -3/4
    */
   final static public HFraction        CN3D4 = new HFraction(HInteger.IN3, 
   HInteger.I4);

   /**
    * Constant: HFraction value -2/5
    */
   final static public HFraction        CN2D5 = new HFraction(HInteger.IN2, 
   HInteger.I5);

   /**
    * Constant: HFraction value -3/5
    */
   final static public HFraction        CN3D5 = new HFraction(HInteger.IN3, 
   HInteger.I5);

   /**
    * Constant: HFraction value -4/5
    */
   final static public HFraction        CN4D5 = new HFraction(HInteger.IN4, 
   HInteger.I5);

   /**
    * Constant: HFraction value -5/6
    */
   final static public HFraction        CN5D6 = new HFraction(HInteger.IN5, 
   HInteger.I6);

   /**
    * Constant: HFraction value -2/7
    */
   final static public HFraction        CN2D7 = new HFraction(HInteger.IN2, 
   HInteger.I7);

   /**
    * Constant: HFraction value -3/7
    */
   final static public HFraction        CN3D7 = new HFraction(HInteger.IN3, 
   HInteger.I7);

   /**
    * Constant: HFraction value -4/7
    */
   final static public HFraction        CN4D7 = new HFraction(HInteger.IN4, 
   HInteger.I7);

   /**
    * Constant: HFraction value -5/7
    */
   final static public HFraction        CN5D7 = new HFraction(HInteger.IN5, 
   HInteger.I7);

   /**
    * Constant: HFraction value -6/7
    */
   final static public HFraction        CN6D7 = new HFraction(HInteger.IN6, 
   HInteger.I7);

   /**
    * Constant: HSymbol "Error"
    */
   final static public HSymbol          Error = new HSymbol("Error", 
   HSymbol.HOLDALL);

   /**
    * Constant: HSymbol "ArithmeticError"
    */
   final static public HSymbol          ArithmeticError = 
      new HSymbol("ArithmeticError", HSymbol.HOLDALL);

   /**
    * Constant: HSymbol "SingularityError"
    */
   final static public HSymbol          SingularityError = 
      new HSymbol("SingularityError", HSymbol.HOLDALL);

   /**
    * Constant: HSymbol "NumberOfArgumentsError"
    */
   final static public HSymbol          NumberOfArgumentsError = 
      new HSymbol("NumberOfArgumentsError", HSymbol.HOLDALL);

   /**
    * Constant: HSymbol "UndefinedError"
    */
   final static public HSymbol          UndefinedError = 
      new HSymbol("UndefinedError", HSymbol.HOLDALL);

   /**
    * Constant: HSymbol "InfinityError"
    */
   final static public HSymbol          InfinityError = 
      new HSymbol("InfinityError", HSymbol.HOLDALL);

   /**
    * Constant: HSymbol "HeadFormatError"
    */
   final static public HSymbol          HeadFormatError = 
      new HSymbol("HeadFormatError", HSymbol.HOLDALL);

   /**
    * Constant: HSymbol "OutOfRangeError"
    */
   final static public HSymbol          OutOfRangeError = 
      new HSymbol("OutOfRangeError", HSymbol.HOLDALL);

   /**
    * Mathematical constant: HSymbol "Catalan"
    *
    * @see C.E
    * @see C.EulerGamma
    * @see C.Pi
    */
   final static public HSymbol          Catalan = new HSymbol("Catalan",
   new ConstantNumericEvaluator(new HDouble(HDouble.CATALAN)), HSymbol.CONSTANT);
   /**
    * Constant: HComplex "I" (imaginary unit)
    */
   final static public HComplex         CI = new HComplex(C.C0, C.C1);

   /**
    * Constant: HSymbol "Complex"
    * 
    * @see HComplex.head()
    */
   final static public HSymbol          Complex = new HSymbol("Complex");

  /**
    * Constant: HSymbol "DiagonalMatrix" (function-header)
    */
   final static public HSymbol          DiagonalMatrix = 
      new HSymbol("DiagonalMatrix", C.loadClass, HSymbol.NOATTRIBUTE);

   /**
    * Constant: HSymbol "Dimensions" (function-header)
    */
   final static public HSymbol          Dimensions = 
      new HSymbol("Dimensions", C.loadClass, HSymbol.NOATTRIBUTE);

   /**
    * Constant: HSymbol "Double"
    * 
    * @see HDouble.head()
    */
   final static public HSymbol          Double = new HSymbol("Double");

   /**
    * Constant: HSymbol "DoubleComplex"
    * 
    * @see HDoubleComplex.head()
    */
   final static public HSymbol          DoubleComplex = 
      new HSymbol("DoubleComplex");

   
   /**
    * Mathematical constant: HSymbol "E"
    * 
    * @see C.Pi
    */
   final static public HSymbol          E = new HSymbol("E", 
   new ConstantNumericEvaluator(new HDouble(Math.E)), HSymbol.CONSTANT);

   /**
    * Mathematical constant: HSymbol "EulerGamma"
    *
    * @see C.Pi
    * @see C.E
    */
   final static public HSymbol          EulerGamma = new HSymbol("EulerGamma",
   new ConstantNumericEvaluator(new HDouble(HDouble.EULERGAMMA)), HSymbol.CONSTANT);
   /**
    * Constant: HSymbol "False"  (boolean value)
    * 
    * @see C.True
    */
   final static public HSymbol          False = new HSymbol("False", 
   HSymbol.CONSTANT);

   /**
    * Constant: HSymbol "Fraction"
    * 
    * @see HFraction.head()
    */
   final static public HSymbol          Fraction = new HSymbol("Fraction");

   /**
    * Mathematical constant: HSymbol "I"
    * 
    * @see C.CI
    * @see C.Pi
    * @see C.E
    */
   final static public HSymbol          I = new HSymbol("I", 
   new ConstantEvaluator(new HDoubleComplex(0.0, 1.0), C.CI), HSymbol.CONSTANT);

   /**
    * Constant: HSymbol "Infinity"
    * 
    * @see HInteger.head()
    */
   final static public HSymbol          Infinity = new HSymbol("Infinity");

   /**
    * Constant: HSymbol "Integer"
    * 
    * @see HInteger.head()
    */
   final static public HSymbol          Integer = new HSymbol("Integer");

   /**
    * Constant: HSymbol "List" (function-header)
    * 
    * @see HSymbol.LISTABLE
    */
   final static public HSymbol          List = new HSymbol("List");

   /**
    * Constant: HSymbol "Dot" (function-header)
    * matrix-multiplication
    */
   final static public HSymbol          Dot = new HSymbol("Dot", C.loadClass, 
   HSymbol.OPERATOR | HSymbol.ONEIDENTITY | HSymbol.FLAT);

   /**
    * Constant: HSymbol "FactorInteger" (function-header)
    */
   final static public HSymbol          FactorInteger = 
      new HSymbol("FactorInteger", C.loadClass, HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "EigenvaluesHermitian" (function-header)
    */
   final static public HSymbol          EigenvaluesHermitian =
      new HSymbol("EigenvaluesHermitian", C.loadClass);

   /**
    * Constant: HSymbol "HermitianAdjoint" (function-header)
    */
   final static public HSymbol          HermitianAdjoint =
      new HSymbol("HermitianAdjoint", C.loadClass);
 
   /**
    * Constant: HSymbol "IsHermitian" (function-header)
    */
   final static public HSymbol          IsHermitian =
      new HSymbol("IsHermitian", C.loadClass);

   /**
    * Constant: HSymbol "IsUnitary" (function-header)
    */
   final static public HSymbol          IsUnitary =
      new HSymbol("IsUnitary", C.loadClass);

   /**
    * Constant: HSymbol "EigenvaluesSymmetric" (function-header)
    */
   final static public HSymbol          EigenvaluesSymmetric =
      new HSymbol("EigenvaluesSymmetric", C.loadClass);

   /**
    * Constant: HSymbol "NLinearSolve" (function-header)
    */
   final static public HSymbol          NLinearSolve =
      new HSymbol("NLinearSolve", C.loadClass);
 
   /**
    * Constant: HSymbol "Fit" (function-header)
    */
   final static public HSymbol          Fit =
      new HSymbol("Fit", C.loadClass);

   /**
    * Constant: HSymbol "IdentityMatrix" (function-header)
    */
   final static public HSymbol          IdentityMatrix =
      new HSymbol("IdentityMatrix", C.loadClass, HSymbol.NOATTRIBUTE);

   /**
    * Constant: HSymbol "MatrixPow" (function-header)
    */
   final static public HSymbol          MatrixPow = new HSymbol("MatrixPow", C.loadClass, 
   HSymbol.NOATTRIBUTE);

   /**
    * Constant: HSymbol "Max" (function-header)
    */
   final static public HSymbol          Max = new HSymbol("Max", C.loadClass,
   HSymbol.ORDERLESS | HSymbol.FLAT);

   /**
    * Constant: HSymbol "Min" (function-header)
    */
   final static public HSymbol          Min = new HSymbol("Min", C.loadClass,
   HSymbol.ORDERLESS | HSymbol.FLAT);

   /**
    * Constant: HSymbol "Null"
    * symbol for "no evaluation result"
    */
   final static public HSymbol          Null = new HSymbol("Null", 
   HSymbol.CONSTANT);

   /**
    * Constant: HSymbol "Pattern"
    * 
    * @see HPattern.head()
    */
   final static public HSymbol          Pattern = new HSymbol("Pattern");

   /**
    * Mathematical constant: HSymbol "Pi"
    * 
    * @see C.E
    * @see C.CI
    */
   final static public HSymbol          Pi = new HSymbol("Pi", 
      new ConstantNumericEvaluator(new HDouble(Math.PI)), HSymbol.CONSTANT);

   /**
    * Constant: HSymbol "String"
    * 
    * @see HString.head()
    */
   final static public HSymbol          String = new HSymbol("String");

   /**
    * Constant: HSymbol "Symbol"
    * 
    * @see HSymbol.head()
    */
   final static public HSymbol          Symbol = new HSymbol("Symbol");

   /**
    * Constant: HSymbol "True"  (boolean value)
    * 
    * @see C.False
    */
   final static public HSymbol          True = new HSymbol("True", 
   HSymbol.CONSTANT);

   /**
    * Constant: HSymbol "Break"  (function for flow-control)
    */
   final static public HSymbol          Break = new HSymbol("Break", C.loadClass, 
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Continue"  (function for flow-control)
    */
   final static public HSymbol          Continue = new HSymbol("Continue", C.loadClass,
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Catch"  (function for flow-control)
    * 
    */
   final static public HSymbol          Catch = new HSymbol("Catch", C.loadClass, 
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Check"  (function for flow-control in pattern-matching)
    */
   final static public HSymbol          Check = new HSymbol("Check", 
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Exec"  (function-header)
    */
   final static public HSymbol          Exec = new HSymbol("Exec", C.loadClass);

   /**
    * Constant: HSymbol "If"  (function for flow-control)
    */
   final static public HSymbol          If = new HSymbol("If", C.loadClass, 
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "FixedPoint"  (function for flow-control)
    * 
    */
   final static public HSymbol          FixedPoint = new HSymbol("FixedPoint", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "For"  (function for flow-control)
    * 
    */
   final static public HSymbol          For = new HSymbol("For", C.loadClass, 
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Function"
    */
   final static public HSymbol          Function = new HSymbol("Function");

   /**
    * Constant: HSymbol "InstanceList"  (function-header)
    */

   // final static public HSymbol	InstanceList = new HSymbol("InstanceList",
   // HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Hold"  (function for flow-control)
    * 
    */
   final static public HSymbol          Hold = new HSymbol("Hold", 
   HSymbol.HOLDALL);
   
   final static public HSymbol          HoldForm = new HSymbol("HoldForm",
   HSymbol.HOLDALL);
   /**
    * Constant: HSymbol "Lambda"  (function for flow-control in pattern-matching)
    */
   final static public HSymbol          Lambda = new HSymbol("Lambda", C.loadClass,
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Slot"  (function for flow-control in pattern-matching)
    */
   final static public HSymbol          Slot = new HSymbol("Slot");

   /**
    * Constant: HSymbol "Level"  (function-header)
    */
   final static public HSymbol          Level = new HSymbol("Level", C.loadClass);

   /**
    * Constant: HSymbol "LoadClass"  (function-header)
    */
   final static public HSymbol          LoadClassLibrary = new HSymbol("LoadClassLibrary", 
   new ELoadClassLibrary(), HSymbol.LISTABLE);
   // C.LoadClass.setEval(new ELoadClass());

   /**
    * Constant: HSymbol "Nest"  (function for flow-control)
    * 
    */
   final static public HSymbol          Nest = new HSymbol("Nest", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Part"  (function-header)
    */
   final static public HSymbol          Part = new HSymbol("Part", C.loadClass);

   // final static public HSymbol PowFun = new HSymbol("PowFun", new EPowFun(), HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "ReplaceAll"  (function-header)
    */
   final static public HSymbol          ReplaceAll = new HSymbol("ReplaceAll", C.loadClass, 
   HSymbol.OPERATOR);

   /**
    * Constant: HSymbol "Return"  (function for flow-control)
    * 
    * @see EReturn
    * @see HReturnException
    */
   final static public HSymbol          Return = new HSymbol("Return", C.loadClass, 
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Rule"  (function-header)
    */
   final static public HSymbol          Rule = new HSymbol("Rule", C.loadClass,
   HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "RuleDelayed"  (function-header)
    */
   final static public HSymbol          RuleDelayed = 
      new HSymbol("RuleDelayed", C.loadClass, 
                  HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Set"  (function-header)
    */
   final static public HSymbol          Set = new HSymbol("Set", 
   HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "SetDelayed"  (function-header)
    */
   final static public HSymbol          SetDelayed = new HSymbol("SetDelayed", 
   HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Sort"  (function-header)
    */
   final static public HSymbol          Sort = new HSymbol("Sort", C.loadClass);

   /**
    * Constant: HSymbol "Statement"  (function-header)
    */
   final static public HSymbol          Statement = new HSymbol("Statement", 
   HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Switch"  (function for flow-control)
    * 
    */
   final static public HSymbol          Switch = new HSymbol("Switch", C.loadClass, 
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Throw"  (function for flow-control)
    * 
    */
   final static public HSymbol          Throw = new HSymbol("Throw", C.loadClass, 
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "TimeConstrained"  
    * 
    * @see ETimeConstrained
    */
   final static public HSymbol          TimeConstrained = new HSymbol("TimeConstrained", C.loadClass,
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   final static public HSymbol          Interrupted = new HSymbol("$Interrupted");
   /**
    * Constant: HSymbol "Timing"
    */
   final static public HSymbol          Timing = new HSymbol("Timing", C.loadClass, 
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Together"  (function-header)
    */
   final static public HSymbol          Together = new HSymbol("Together", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Trace"  (function-header)
    */
   final static public HSymbol          Trace = new HSymbol("Trace", C.loadClass,
   HSymbol.HOLDALL);

   /**
    * Constant: HSymbol "TraceRule"  (function-header)
    */
   //final static public HSymbol          TraceRule = new HSymbol("TraceRule");

   /**
    * Constant: HSymbol "UpSet"  (function-header)
    */
   final static public HSymbol          UpSet = new HSymbol("UpSet", 
   HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "UpSetDelayed"  (function-header)
    */
   final static public HSymbol          UpSetDelayed = 
      new HSymbol("UpSetDelayed", 
                  HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "While"  (function for flow-control)
    * 
    * @see EWhile
    */
   final static public HSymbol          While = new HSymbol("While", C.loadClass, 
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "ACos"  (function-header)
    */
   final static public HSymbol          ACos = new HSymbol("ACos", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "And" <a href="../descript.htm#A-REF">(function-header)</a>
    */
   final static public HSymbol          And = new HSymbol("And", C.loadClass, 
   HSymbol.OPERATOR | HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "ASin"  (function-header)
    */
   final static public HSymbol          ASin = new HSymbol("ASin", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "ATan"  (function-header)
    */
   final static public HSymbol          ATan = new HSymbol("ATan", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Append"  (function-header)
    */
   final static public HSymbol          Append = new HSymbol("Append", C.loadClass);

   /**
    * Constant: HSymbol "AppendTo"  (function-header)
    */
   final static public HSymbol          AppendTo = new HSymbol("AppendTo", C.loadClass,
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Apply"  (function-header)
    */
   final static public HSymbol          Apply = new HSymbol("Apply", C.loadClass);

   /**
    * Constant: HSymbol "Array"  (function-header)
    */
   final static public HSymbol          Array = new HSymbol("Array", C.loadClass);

   /**
    * Constant: HSymbol "Block"  (function-header)
    */
   final static public HSymbol          Block = new HSymbol("Block", C.loadClass, 
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Cos" <a href="../descript.htm#C-REF">(function-header)</a>
    */
   final static public HSymbol          Cos = new HSymbol("Cos", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Cosh"  (function-header)
    */
   final static public HSymbol          Cosh = new HSymbol("Cosh", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "ACosh"  (function-header)
    */
   final static public HSymbol          ACosh = new HSymbol("ACosh", C.loadClass, 
   HSymbol.LISTABLE);

   final static public HSymbol          Cot = new HSymbol("Cot", C.loadClass,
   HSymbol.LISTABLE);
   final static public HSymbol          Coth = new HSymbol("Coth", C.loadClass,
   HSymbol.LISTABLE);
   final static public HSymbol          ACot = new HSymbol("ACot", C.loadClass,
   HSymbol.LISTABLE);
   final static public HSymbol          ACoth = new HSymbol("ACoth", C.loadClass,
   HSymbol.LISTABLE);
   // final static public HSymbol Cot = new HSymbol("Cot", HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Complement"  (function-header)
    */
  // final static public HSymbol          Complement =
  //    new HSymbol("Complement");

   /**
    * Constant: HSymbol "Delete"  (function-header)
    */
   final static public HSymbol          Delete = new HSymbol("Delete", C.loadClass);

   /**
    * Constant: HSymbol "Depth"  (function-header)
    */
   final static public HSymbol          Depth = new HSymbol("Depth", C.loadClass);

   /**
    * Constant: HSymbol "Do"  (function-header)
    */
   final static public HSymbol          Do = new HSymbol("Do", C.loadClass, 
   HSymbol.HOLDALL);

   /**
    * Constant: HSymbol "Exp"  (function-header)
    */
   final static public HSymbol          Exp = new HSymbol("Exp", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "First"  (function-header)
    */
   final static public HSymbol          First = new HSymbol("First", C.loadClass);

   /**
    * Constant: HSymbol "Head"  (function-header)
    */
   final static public HSymbol          Head = new HSymbol("Head", C.loadClass);

   /**
    * Constant: HSymbol "Insert"  (function-header)
    */
   final static public HSymbol          Insert = new HSymbol("Insert", C.loadClass);

   /**
    * Constant: HSymbol "Intersection"  (function-header)
    */
   //final static public HSymbol          Intersection =
   //   new HSymbol("Intersection");

   /**
    * Constant: HSymbol "Inverse"  (function-header)
    */
   final static public HSymbol          Inverse = new HSymbol("Inverse", C.loadClass);

   final static public HSymbol  CrossProduct = new HSymbol("CrossProduct", C.loadClass);
	 final static public HSymbol  Det = new HSymbol("Det", C.loadClass);
   final static public HSymbol  Spur = new HSymbol("Spur", C.loadClass);
	 final static public HSymbol  Transpose = new HSymbol("Transpose", C.loadClass);
   

   /**
    * Constant: HSymbol "Join"  (function-header)
    */
   final static public HSymbol          Join = new HSymbol("Join", C.loadClass);

   /**
    * Constant: HSymbol "Last"  (function-header)
    */
   final static public HSymbol          Last = new HSymbol("Last", C.loadClass);

   /**
    * Constant: HSymbol "Not"  (function-header)
    */
   final static public HSymbol          Not = new HSymbol("Not", C.loadClass,
   HSymbol.OPERATOR | HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Or"  (function-header)
    */
   final static public HSymbol          Or = new HSymbol("Or", C.loadClass, 
   HSymbol.OPERATOR | HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "KSubsets"  (function-header)
    */
   final static public HSymbol          KSubsets = new HSymbol("KSubsets", C.loadClass);

   /**
    * Constant: HSymbol "KPartitions"  (function-header)
    */
   final static public HSymbol          KPartitions = new HSymbol("KPartitions", C.loadClass);

   /**
    * Constant: HSymbol "NumberPartitions"  (function-header)
    */
   final static public HSymbol          NumberPartitions = new HSymbol("NumberPartitions", C.loadClass);

   /**
    * Constant: HSymbol "Partition"  (function-header)
    */
   final static public HSymbol          Partition = new HSymbol("Partition", C.loadClass);

   /**
    * Constant: HSymbol "Permutations"  (function-header)
    */
   final static public HSymbol          Permutations = new HSymbol("Permutations", C.loadClass);

   /**
    * Constant: HSymbol "Product"  (function-header)
    */
   final static public HSymbol          Product = new HSymbol("Product", C.loadClass, 
   HSymbol.HOLDALL);

   /**
    * Constant: HSymbol "Range"  (function-header)
    */
   final static public HSymbol          Range = new HSymbol("Range", C.loadClass);

   /**
    * Constant: HSymbol "Rest"  (function-header)
    */
   final static public HSymbol          Rest = new HSymbol("Rest", C.loadClass);

   /**
    * Constant: HSymbol "Log"  (function-header)
    */
   final static public HSymbol          Log = new HSymbol("Log", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Map"  (function-header)
    */
   final static public HSymbol          Map = new HSymbol("Map", C.loadClass);

   /**
    * Constant: HSymbol "Prepend"  (function-header)
    */
   final static public HSymbol          Prepend = new HSymbol("Prepend", C.loadClass);

   /**
    * Constant: HSymbol "PrependTo"  (function-header)
    */
   final static public HSymbol          PrependTo = new HSymbol("PrependTo", C.loadClass,
   HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Sin"  (function-header)
    */
   final static public HSymbol          Sin = new HSymbol("Sin", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Sinh"  (function-header)
    */
   final static public HSymbol          Sinh = new HSymbol("Sinh", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "ASinh"  (function-header)
    */
   final static public HSymbol          ASinh = new HSymbol("ASinh", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Sum"  (function-header)
    */
   final static public HSymbol          Sum = new HSymbol("Sum", C.loadClass,
   HSymbol.HOLDALL);

   /**
    * Constant: HSymbol "Table"  (function-header)
    */
   final static public HSymbol          Table = new HSymbol("Table", C.loadClass,
   HSymbol.HOLDALL);

   /**
    * Constant: HSymbol "Tan"  (function-header)
    */
   final static public HSymbol          Tan = new HSymbol("Tan", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Tanh"  (function-header)
    */
   final static public HSymbol          Tanh = new HSymbol("Tanh", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "ATanh"  (function-header)
    */
   final static public HSymbol          ATanh = new HSymbol("ATanh", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Add"  (function-header)
    */
   final static public HSymbol          Add = new HSymbol("Add", 
   HSymbol.OPERATOR | HSymbol.ONEIDENTITY | HSymbol.ORDERLESS | HSymbol.FLAT 
   | HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "AddTo"  (function-header)
    */
   final static public HSymbol          AddTo = new HSymbol("AddTo", 
   HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Equal"  (function-header)
    */
   final static public HSymbol          Equal = new HSymbol("Equal", C.loadClass, 
   HSymbol.OPERATOR | HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Greater"  (function-header)
    */
   final static public HSymbol          Greater = new HSymbol("Greater", C.loadClass,
   HSymbol.OPERATOR | HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "GreaterEqual"  (function-header)
    */
   final static public HSymbol          GreaterEqual = 
      new HSymbol("GreaterEqual", C.loadClass, HSymbol.OPERATOR | HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsAtom"  (function-header)
    */
   final static public HSymbol          IsAtom = new HSymbol("IsAtom", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsComplex"  (function-header)
    */
   final static public HSymbol          IsComplex = new HSymbol("IsComplex", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsFraction"  (function-header)
    */
   final static public HSymbol          IsFraction = new HSymbol("IsFraction", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsFunction"  (function-header)
    */
   final static public HSymbol          IsFunction = new HSymbol("IsFunction", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsInteger"  (function-header)
    */
   final static public HSymbol          IsInteger = new HSymbol("IsInteger", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsMatrix"  (function-header)
    */
   final static public HSymbol          IsMatrix = new HSymbol("IsMatrix", C.loadClass);

   /**
    * Constant: HSymbol "IsMember"  (function-header)
    */
   final static public HSymbol          IsMember = new HSymbol("IsMember", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsNegative"  (function-header)
    */
   final static public HSymbol          IsNegative = new HSymbol("IsNegative", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsNoMember"  (function-header)
    */
   final static public HSymbol          IsNoMember = new HSymbol("IsNoMember", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsNonNegative"  (function-header)
    */
   final static public HSymbol          IsNonNegative = 
      new HSymbol("IsNonNegative", C.loadClass, HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsNumber"  (function-header)
    */
   final static public HSymbol          IsNumber = new HSymbol("IsNumber", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsPositive"  (function-header)
    */
   final static public HSymbol          IsPositive = new HSymbol("IsPositive", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsProbablePrime"  (function-header)
    */
   final static public HSymbol          IsProbablePrime = 
      new HSymbol("IsProbablePrime", C.loadClass, HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsRational"  (function-header)
    */
   final static public HSymbol          IsRational = new HSymbol("IsRational", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsSame"  (function-header)
    */
   final static public HSymbol          IsSame = new HSymbol("IsSame", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsTrue"  (function-header)
    */
   final static public HSymbol          IsTrue = new HSymbol("IsTrue", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsReal"  (function-header)
    */
   final static public HSymbol          IsReal = new HSymbol("IsReal", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "IsVector"  (function-header)
    */
   final static public HSymbol          IsVector = new HSymbol("IsVector", C.loadClass);

   /**
    * Constant: HSymbol "Abs"  (function-header)
    */
   final static public HSymbol          Abs = new HSymbol("Abs", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "AiryAi"  (function-header)
    */
   final static public HSymbol          AiryAi = new HSymbol("AiryAi", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Ceil"  (function-header)
    */
   final static public HSymbol          Ceil = new HSymbol("Ceil", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Clear"  (function-header)
    */
   final static public HSymbol          Clear = new HSymbol("Clear", C.loadClass,
   HSymbol.HOLDALL);

   /**
    * Constant: HSymbol "Conjugate"  (function-header)
    */
   final static public HSymbol          Conjugate = new HSymbol("Conjugate", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "D" <a href="../descript.htm#D-REF">(function-header)</a>
    */
   final static public HSymbol          D = new HSymbol("D", C.loadClass,  
   HSymbol.BUILTINFIRST);

   /**
    * Constant: HSymbol "Decrement"  (function-header)
    */
   final static public HSymbol          Decrement = new HSymbol("Decrement", C.loadClass,
   HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Definition"  (function-header)
    */
   final static public HSymbol          Definition = new HSymbol("Definition", C.loadClass,
   HSymbol.HOLDALL);

   /**
    * Constant: HSymbol "Denominator"  (function-header)
    */
   final static public HSymbol          Denominator = 
      new HSymbol("Denominator", C.loadClass, HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Div"  (function-header)
    */
   final static public HSymbol          Div = new HSymbol("Div", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Divide"  (function-header)
    */
   final static public HSymbol          Divide = new HSymbol("Divide", C.loadClass);

   /**
    * Constant: HSymbol "DivideBy"  (function-header)
    */
   final static public HSymbol          DivideBy = new HSymbol("DivideBy", 
   HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Erf"  (function-header)
    */
   final static public HSymbol          Erf = new HSymbol("Erf", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Expand" <a href="../descript.htm#E-REF">(function-header)</a>
    */
   final static public HSymbol          Expand = new HSymbol("Expand", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "ExpandAll"  (function-header)
    */
   final static public HSymbol          ExpandAll = new HSymbol("ExpandAll", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Factorial"  (function-header)
    */
   final static public HSymbol          Factorial = new HSymbol("Factorial", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "FindStr"  (function-header)
    */
   final static public HSymbol          FindStr = new HSymbol("FindStr", C.loadClass);

   /**
    * Constant: HSymbol "Flat"  (attribute)
    */
   final static public HSymbol          Flat = new HSymbol("Flat");

   /**
    * Constant: HSymbol "Floor"  (function-header)
    */
   final static public HSymbol          Floor = new HSymbol("Floor", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "FullForm"  (function-header)
    */
   final static public HSymbol          FullForm = new HSymbol("FullForm", C.loadClass);

   /**
    * Constant: HSymbol "Gamma"  (function-header)
    */
   final static public HSymbol          Gamma = new HSymbol("Gamma", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "GCD"  (function-header)
    */
   final static public HSymbol          GCD = new HSymbol("GCD", C.loadClass, 
   HSymbol.ONEIDENTITY | HSymbol.ORDERLESS | HSymbol.FLAT | HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "GetFileStr"  (function-header)
    */
   final static public HSymbol          GetFileStr = new HSymbol("GetFileStr", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "HoldAll"  (attribute)
    */
   final static public HSymbol          HoldAll = new HSymbol("HoldAll");

   /**
    * Constant: HSymbol "HoldFirst"  (attribute)
    */
   final static public HSymbol          HoldFirst = new HSymbol("HoldFirst");

   /**
    * Constant: HSymbol "HoldRest"  (attribute)
    */
   final static public HSymbol          HoldRest = new HSymbol("HoldRest");

   /**
    * Constant: HSymbol "Im"  (function-header)
    */
   final static public HSymbol          Im = new HSymbol("Im", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Increment"  (function-header)
    */
   final static public HSymbol          Increment = new HSymbol("Increment", C.loadClass, 
   HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Int" <a href="../descript.htm#I-REF">(function-header)</a>
    */
   final static public HSymbol          Int = new HSymbol("Int", C.loadClass);

   final static public HSymbol          NInt = new HSymbol("NInt", C.loadClass);

   /**
    * Constant: HSymbol "InverseMod" <a href="../descript.htm#I-REF">(function-header)</a>
    */
   final static public HSymbol          InverseMod = new HSymbol("InverseMod", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Length"  (function-header)
    */
   final static public HSymbol          Length = new HSymbol("Length", C.loadClass);

   /**
    * Constant: HSymbol "LengthStr"  (function-header)
    */
   final static public HSymbol          LengthStr = new HSymbol("LengthStr", C.loadClass);

   /**
    * Constant: HSymbol "Less"  (function-header)
    */
   final static public HSymbol          Less = new HSymbol("Less", C.loadClass,
   HSymbol.OPERATOR | HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "LessEqual"  (function-header)
    */
   final static public HSymbol          LessEqual = new HSymbol("LessEqual", C.loadClass,
   HSymbol.OPERATOR | HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Listable"  (attribute)
    */
   final static public HSymbol          Listable = new HSymbol("Listable");

   /**
    * Constant: HSymbol "Mod"  (attribute)
    */
   final static public HSymbol          Mod = new HSymbol("Mod", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Multiply" <a href="../descript.htm#M-REF">(function-header)</a>
    */
   final static public HSymbol          Multiply = new HSymbol("Multiply", 
   HSymbol.OPERATOR | HSymbol.ONEIDENTITY | HSymbol.ORDERLESS | HSymbol.FLAT 
   | HSymbol.LISTABLE);

   // final static public HSymbol MultiplyFun = new HSymbol("MultiplyFun", new EMultiplyFun(), HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "N"  (function-header)
    * used for numeric evaluation
    */
   final static public HSymbol          N = new HSymbol("N", 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Neg" (function-header)
    */
   final static public HSymbol          Neg = new HSymbol("Neg", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Numerator"  (function-header)
    */
   final static public HSymbol          Numerator = new HSymbol("Numerator", C.loadClass, 
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "OneIdentity"  (attribute)
    */
   final static public HSymbol          OneIdentity = 
      new HSymbol("OneIdentity");

   /**
    * Constant: HSymbol "Orderless"  (attribute)
    */
   final static public HSymbol          Orderless = new HSymbol("Orderless");

   /**
    * Constant: HSymbol "Pow" <a href="../descript.htm#P-REF">(function-header)</a>
    */
   final static public HSymbol          Pow = new HSymbol("Pow", 
   HSymbol.OPERATOR | HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "PowMod" <a href="../descript.htm#P-REF">(function-header)</a>
    */
   final static public HSymbol          PowMod = new HSymbol("PowMod", C.loadClass, 
   HSymbol.LISTABLE);

   // final static public HSymbol PowFun = new HSymbol("PowFun", new EPowFun(), HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "PreDecrement"  (function-header)
    */
   final static public HSymbol          PreDecrement = 
      new HSymbol("PreDecrement", C.loadClass,
                  HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "PreIncrement"  (function-header)
    */
   final static public HSymbol          PreIncrement = 
      new HSymbol("PreIncrement", C.loadClass, 
                  HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Print" (function-header)
    */
   final static public HSymbol          Print = new HSymbol("Print", C.loadClass);

   /**
    * Constant: HSymbol "Re"  (function-header)
    */
   final static public HSymbol          Re = new HSymbol("Re", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "ReplaceStr" (function-header)
    */
   final static public HSymbol          ReplaceStr = 
      new HSymbol("ReplaceStr", C.loadClass);

   /**
    * Constant: HSymbol "ReadObject" (function-header)
    */
   final static public HSymbol          ReadObject = 
      new HSymbol("ReadObject", C.loadClass);

   /**
    * Constant: HSymbol "SetAttributes" (function-header)
    */
   final static public HSymbol          SetAttributes = 
      new HSymbol("SetAttributes", C.loadClass, HSymbol.HOLDFIRST);

   /**
    * Constant: HSymbol "Sign" (function-header)
    */
   final static public HSymbol          Sign = new HSymbol("Sign", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Signum" (function-header)
    */
   final static public HSymbol          Signum = new HSymbol("Signum", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "SignumCmp" (function-header)
    */
   final static public HSymbol          SignumCmp = new HSymbol("SignumCmp", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Sqrt" (function-header)
    */
   final static public HSymbol          Sqrt = new HSymbol("Sqrt");

   /**
    * Constant: HSymbol "Subtract" (function-header)
    */
   final static public HSymbol          Subtract = new HSymbol("Subtract", C.loadClass);

   /**
    * Constant: HSymbol "SubtractFrom"  (function-header)
    */
   final static public HSymbol          SubtractFrom = 
      new HSymbol("SubtractFrom", 
                  HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "Taylor" <a href="../descript.htm#T-REF">(function-header)</a>
    */
   final static public HSymbol          Taylor = new HSymbol("Taylor", C.loadClass);

   /**
    * Constant: HSymbol "TimesBy"  (function-header)
    */
   final static public HSymbol          TimesBy = new HSymbol("TimesBy", 
   HSymbol.OPERATOR | HSymbol.HOLDALL | HSymbol.FASTCALL);

   /**
    * Constant: HSymbol "ToLowerCaseStr" (function-header)
    */
   final static public HSymbol          ToLowerCaseStr = 
      new HSymbol("ToLowerCaseStr", C.loadClass);

   /**
    * Constant: HSymbol "ToUpperCaseStr" (function-header)
    */
   final static public HSymbol          ToUpperCaseStr = 
      new HSymbol("ToUpperCaseStr", C.loadClass);

   /**
    * Constant: HSymbol "Trunc"  (function-header)
    */
   final static public HSymbol          Trunc = new HSymbol("Trunc", C.loadClass,
   HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "UnEqual" (function-header)
    */
   final static public HSymbol          Unequal = new HSymbol("Unequal", C.loadClass,
   HSymbol.OPERATOR | HSymbol.LISTABLE);

   /**
    * Constant: HSymbol "Union"  (function-header)
    */
   final static public HSymbol          Union = new HSymbol("Union", C.loadClass);

   /**
    * Constant: HSymbol "WriteObject" (function-header)
    */
   final static public HSymbol          WriteObject = 
      new HSymbol("WriteObject", C.loadClass, HSymbol.HOLDREST);

   /**
    * Constant: HSymbol "Xor" (function-header)
    */
   final static public HSymbol          Xor = new HSymbol("Xor", C.loadClass, 
   HSymbol.LISTABLE);
   
   final static public HSymbol          Plot3D = new HSymbol("Plot3D", C.loadClass);

   final static public HSymbol          Plot3DPanel = new HSymbol("Plot3DPanel", C.loadClass);

   final static public HSymbol          ParametricPlotPanel = new HSymbol("ParametricPlotPanel", C.loadClass);

   /**
	 * Constant: HSymbol "ParametricPlot" <a href="descript.htm#B-REF">(function-header)</a>
	 */
	 final static public HSymbol ParametricPlot = new HSymbol("ParametricPlot", C.loadClass);
   /**
	  * Constant: HSymbol "Plot" <a href="descript.htm#B-REF">(function-header)</a>
	  */
	 final static public HSymbol Plot = new HSymbol("Plot", C.loadClass);
   final static public HSymbol ScatterGraph = new HSymbol("ScatterGraph", C.loadClass);
   final static public HSymbol BarGraph = new HSymbol("BarGraph", C.loadClass);
   final static public HSymbol PieChart = new HSymbol("PieChart", C.loadClass);

   /**
	 * Constant: HSymbol "Binomial" <a href="descript.htm#B-REF">(function-header)</a>
	 */
	final static public HSymbol Binomial = new HSymbol("Binomial", C.loadClass,
															  HSymbol.LISTABLE);
	/**
	 * Constant: HSymbol "CatalanNumber" <a href="descript.htm#C-REF">(function-header)</a>
	 */
	final static public HSymbol CatalanNumber = new HSymbol("CatalanNumber", C.loadClass,
															 HSymbol.LISTABLE);
	/**
	 * Constant: HSymbol "Factorial2" <a href="descript.htm#F-REF">(function-header)</a>
	 */
	final static public HSymbol Factorial2 = new HSymbol("Factorial2", C.loadClass,
			   HSymbol.LISTABLE);

	/**
	 * Constant: HSymbol "Fibonacci" <a href="descript.htm#F-REF">(function-header)</a>
	 */
	final static public HSymbol Fibonacci = new HSymbol("Fibonacci", C.loadClass,
			  HSymbol.LISTABLE);

  
	/**
	 * Constant: HSymbol "DivP" <a href="descript.htm#B-REF">(function-header)</a>
	 */
	final static public HSymbol DivP = new HSymbol("DivP", C.loadClass,
															 HSymbol.LISTABLE);

	/**
	 * Constant: HSymbol "GCDP" <a href="descript.htm#B-REF">(function-header)</a>
	 */
	final static public HSymbol GCDP = new HSymbol("GCDP", C.loadClass,
															 HSymbol.LISTABLE);

  /**
	 * Constant: HSymbol "LCMP" <a href="descript.htm#B-REF">(function-header)</a>
	 */
	final static public HSymbol LCMP = new HSymbol("LCMP", C.loadClass,
															 HSymbol.LISTABLE);

	/**
	 * Constant: HSymbol "PolynomialList" <a href="descript.htm#B-REF">(function-header)</a>
	 */
	final static public HSymbol PolynomialList = new HSymbol("PolynomialList", C.loadClass,
															  HSymbol.LISTABLE);

	/**
	 * Constant: HSymbol "ModP" <a href="descript.htm#B-REF">(function-header)</a>
	 */
	final static public HSymbol ModP = new HSymbol("ModP", C.loadClass,
															 HSymbol.LISTABLE);

  /**
	 * Constant: HSymbol "MultiplyP" <a href="descript.htm#B-REF">(function-header)</a>
	 */
	final static public HSymbol MultiplyP = new HSymbol("MultiplyP", C.loadClass,
															 HSymbol.LISTABLE);

	/**
	 * Constant: HSymbol "DegreeP" <a href="descript.htm#B-REF">(function-header)</a>
	 */
	final static public HSymbol DegreeP = new HSymbol("DegreeP", C.loadClass,
			  HSymbol.LISTABLE);

  /**
	 * Constant: HSymbol "SolveP" <a href="descript.htm#B-REF">(function-header)</a>
	 */
	final static public HSymbol SolveP = new HSymbol("SolveP", C.loadClass,
															 HSymbol.LISTABLE);

    final static public HSymbol ChiSquareCDF = new HSymbol("ChiSquareCDF");
    final static public HSymbol ChiSquareICDF = new HSymbol("ChiSquareICDF");
    final static public HSymbol ChiSquarePDF = new HSymbol("ChiSquarePDF");
    final static public HSymbol StudentTCDF = new HSymbol("StudentTCDF");
    final static public HSymbol StudentTICDF = new HSymbol("StudentTICDF");
    final static public HSymbol StudentTPDF = new HSymbol("StudentTPDF");
    final static public HSymbol NormalCDF = new HSymbol("NormalCDF");
    final static public HSymbol NormalICDF = new HSymbol("NormalICDF");
    final static public HSymbol NormalPDF = new HSymbol("NormalPDF");
    final static public HSymbol BetaCDF = new HSymbol("BetaCDF");
    final static public HSymbol BetaICDF = new HSymbol("BetaICDF");
    final static public HSymbol BetaPDF = new HSymbol("BetaPDF");
    final static public HSymbol FisherFCDF = new HSymbol("FisherFCDF");
    final static public HSymbol FisherFICDF = new HSymbol("FisherFICDF");
    final static public HSymbol FisherFPDF = new HSymbol("FisherFPDF");

    final static public HSymbol	Distribution = new HSymbol("Distribution", C.loadClass);
    final static public HSymbol ArithmeticMean = new HSymbol("ArithmeticMean", C.loadClass);
    final static public HSymbol GeometricMean = new HSymbol("GeometricMean", C.loadClass);
    final static public HSymbol HarmonicMean = new HSymbol("HarmonicMean", C.loadClass);
    final static public HSymbol StandardDeviation = new HSymbol("StandardDeviation", C.loadClass);
    final static public HSymbol Variance = new HSymbol("Variance", C.loadClass);

   final static public HSymbol Hilbert = new HSymbol("Hilbert", C.loadClass);
   final static public HSymbol Vandermonde = new HSymbol("Vandermonde", C.loadClass);

   /**
    * Constant: HSymbol "ConvertTemperature" <a href="descript.htm#C-REF">(function-header)</a>
    */
   final static public HSymbol ConvertTemperature = new HSymbol("ConvertTemperature", C.loadClass,
     HSymbol.LISTABLE);
     
   /**
    * Mathematical constant: HSymbol "Degree"
    * 
    */
   final static public HSymbol          Degree = new HSymbol("Degree", 
     new ConstantEvaluator(new HDouble(Math.PI/180.0d), 
     	                     C.Multiply.f(C.Pi, C.Pow.f(HInteger.valueOf(180),C.CN1))), 
   	 HSymbol.CONSTANT);

   /**
    * Mathematical constant: HSymbol "MaxIterations"
    * 
    */
   final static public HSymbol          MaxIterations = new HSymbol("MaxIterations",
   	 HSymbol.CONSTANT);


   static public HSymbol          RecursionLimit;
   // = new HSymbol("RecursionLimit",
   //  new ConstantEvaluator(new HDouble(-1.0),
   //  	                     C.CN1),
   //	 HSymbol.CONSTANT);
   static public HSymbol          IterationLimit;
   // = new HSymbol("IterationLimit",
   //  new ConstantEvaluator(new HDouble(-1.0),
   //  	                     C.CN1),
   //	 HSymbol.CONSTANT);
   // define exp(1)^i    ;i = ...-3,-2,-1,2,3,...

   /**
    * Constant: HFunction E^(-5)
    */
   final static public HFunction        CEPN5 = new HFunction(Pow, E, CN5);

   /**
    * Constant: HFunction E^(-4)
    */
   final static public HFunction        CEPN4 = new HFunction(Pow, E, CN4);

   /**
    * Constant: HFunction E^(-3)
    */
   final static public HFunction        CEPN3 = new HFunction(Pow, E, CN3);

   /**
    * Constant: HFunction E^(-2)
    */
   final static public HFunction        CEPN2 = new HFunction(Pow, E, CN2);

   /**
    * Constant: HFunction E^(-1)
    */
   final static public HFunction        CEPN1 = new HFunction(Pow, E, CN1);

   /**
    * Constant: HFunction E^(2)
    */
   final static public HFunction        CEP2 = new HFunction(Pow, E, C2);

   /**
    * Constant: HFunction E^3
    */
   final static public HFunction        CEP3 = new HFunction(Pow, E, C3);

   /**
    * Constant: HFunction E^(4)
    */
   final static public HFunction        CEP4 = new HFunction(Pow, E, C4);

   /**
    * Constant: HFunction E^(5)
    */
   final static public HFunction        CEP5 = new HFunction(Pow, E, C5);

   // define Pi^i        ;i = ...-3,-2,-1,2,3,...

   /**
    * Constant: HFunction Pi^(-5)
    */
   final static public HFunction        CPiPN5 = new HFunction(Pow, Pi, CN5);

   /**
    * Constant: HFunction Pi^(-4)
    */
   final static public HFunction        CPiPN4 = new HFunction(Pow, Pi, CN4);

   /**
    * Constant: HFunction Pi^(-3)
    */
   final static public HFunction        CPiPN3 = new HFunction(Pow, Pi, CN3);

   /**
    * Constant: HFunction Pi^(-2)
    */
   final static public HFunction        CPiPN2 = new HFunction(Pow, Pi, CN2);

   /**
    * Constant: HFunction Pi^(-1)
    */
   final static public HFunction        CPiPN1 = new HFunction(Pow, Pi, CN1);

   /**
    * Constant: HFunction Pi^2
    */
   final static public HFunction        CPiP2 = new HFunction(Pow, Pi, C2);

   /**
    * Constant: HFunction Pi^3
    */
   final static public HFunction        CPiP3 = new HFunction(Pow, Pi, C3);

   /**
    * Constant: HFunction Pi^4
    */
   final static public HFunction        CPiP4 = new HFunction(Pow, Pi, C4);

   /**
    * Constant: HFunction Pi^5
    */
   final static public HFunction        CPiP5 = new HFunction(Pow, Pi, C5);

   /**
    * predefined variable symbols
    */
   final static public HSymbol          a = new HSymbol("a");
   final static public HSymbol          b = new HSymbol("b");
   final static public HSymbol          c = new HSymbol("c");
   final static public HSymbol          d = new HSymbol("d");
   final static public HSymbol          e = new HSymbol("e");
   final static public HSymbol          f = new HSymbol("f");
   final static public HSymbol          g = new HSymbol("g");
   final static public HSymbol          h = new HSymbol("h");
   final static public HSymbol          i = new HSymbol("i");
   final static public HSymbol          j = new HSymbol("j");
   final static public HSymbol          k = new HSymbol("k");
   final static public HSymbol          l = new HSymbol("l");
   final static public HSymbol          m = new HSymbol("m");
   final static public HSymbol          n = new HSymbol("n");
   final static public HSymbol          o = new HSymbol("o");
   final static public HSymbol          p = new HSymbol("p");
   final static public HSymbol          q = new HSymbol("q");
   final static public HSymbol          r = new HSymbol("r");
   final static public HSymbol          s = new HSymbol("s");
   final static public HSymbol          t = new HSymbol("t");
   final static public HSymbol          u = new HSymbol("u");
   final static public HSymbol          v = new HSymbol("v");
   final static public HSymbol          w = new HSymbol("w");
   final static public HSymbol          x = new HSymbol("x");
   final static public HSymbol          y = new HSymbol("y");
   final static public HSymbol          z = new HSymbol("z");
   final static public HSymbol          RHS = new HSymbol("$__");
   final static public HPattern         RHS__ = new HPattern(C.RHS);
   final static public HPattern         a_ = new HPattern(C.a);
   final static public HPattern         b_ = new HPattern(C.b);
   final static public HPattern         c_ = new HPattern(C.c);
   final static public HPattern         d_ = new HPattern(C.d);
   final static public HPattern         e_ = new HPattern(C.e);
   final static public HPattern         f_ = new HPattern(C.f);
   final static public HPattern         g_ = new HPattern(C.g);
   final static public HPattern         h_ = new HPattern(C.h);
   final static public HPattern         i_ = new HPattern(C.i);
   final static public HPattern         j_ = new HPattern(C.j);
   final static public HPattern         k_ = new HPattern(C.k);
   final static public HPattern         l_ = new HPattern(C.l);
   final static public HPattern         m_ = new HPattern(C.m);
   final static public HPattern         n_ = new HPattern(C.n);
   final static public HPattern         o_ = new HPattern(C.o);
   final static public HPattern         p_ = new HPattern(C.p);
   final static public HPattern         q_ = new HPattern(C.q);
   final static public HPattern         r_ = new HPattern(C.r);
   final static public HPattern         s_ = new HPattern(C.s);
   final static public HPattern         t_ = new HPattern(C.t);
   final static public HPattern         u_ = new HPattern(C.u);
   final static public HPattern         v_ = new HPattern(C.v);
   final static public HPattern         w_ = new HPattern(C.w);
   final static public HPattern         x_ = new HPattern(C.x);
   final static public HPattern         y_ = new HPattern(C.y);
   final static public HPattern         z_ = new HPattern(C.z);
   final static public HObject          VarTable[] = 
   {
      a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w, x, 
      y, z, a_, b_, c_, d_, e_, f_, g_, h_, i_, j_, k_, l_, m_, n_, o_, p_, 
      q_, r_, s_, t_, u_, v_, w_, x_, y_, z_, C.CN5, C.CN4, C.CN3, C.CN2, 
      C.CN1, C.C0, C.C1, C.C2, C.C3, C.C4, C.C5, C.C1D2, C.C1D3, C.C1D4, 
      C.C1D5, C.C1D6, C.C1D7, C.C1D8, C.C1D9, C.C1D10
   };
   //final static public int              MAXIOSYMBOLS = 105;
   final static public HSymbol          IOSymbolTable[] = 
   {
      C.Abs, C.ACos, C.ASin, C.ATan, C.Add, C.And,
      C.Block, C.Break,
      C.Catch, C.Ceil, C.Check, C.Clear, C.Cos, C.Cosh, 
      C.D, C.Definition, C.Denominator, C.Div, C.Divide, C.Do, C.Dot,
      C.Equal, C.Exp, C.Expand, C.ExpandAll, 
      C.Factorial, C.Floor, C.For, C.FullForm, C.GCD,
      C.GetFileStr, C.Greater, C.GreaterEqual, C.Head, C.If, C.Im, C.Int, C.IsAtom, 
      C.IsComplex, C.IsFraction, C.IsFunction, C.IsInteger, C.IsMatrix, 
      C.IsMember, C.IsNegative, C.IsNoMember, C.IsNonNegative, C.IsNumber, 
      C.IsPositive, C.IsProbablePrime, C.IsRational, C.IsReal, C.IsSame, 
      C.IsTrue, C.Lambda, C.Length, C.LengthStr, C.Less, C.LessEqual, C.LoadClassLibrary,
      C.Log, C.Map, C.Mod, C.Multiply, C.N, C.Neg, C.Numerator, C.Or, C.Part, C.Pow,
      C.Print, C.Product, C.Re, C.ReadObject, C.ReplaceAll, C.ReplaceStr, 
      C.Return, C.Rule, C.RuleDelayed, C.Set, C.SetAttributes, C.SetDelayed, 
      C.Sign, C.Signum, C.SignumCmp, C.Sin, C.Sinh, C.Slot, C.Sort, C.Sqrt, 
      C.Statement, C.Subtract, C.Sum, C.Switch, C.Table, C.Tan, C.Tanh, 
      C.Throw, C.ToLowerCaseStr, C.ToUpperCaseStr, C.Trace, C.HoldForm, 
      C.Trunc, C.Unequal, C.UpSet, C.UpSetDelayed, C.While, C.WriteObject, 
      C.Xor
   };
   final static public HSymbol          IOConstantTable[] =
   {
      C.Complex,
      C.Degree, C.Double, C.DoubleComplex,
      C.E,
      C.False, C.Flat, C.Fraction, C.Function,
      C.HoldAll, C.HoldFirst, C.HoldRest,
      C.I, C.Infinity, C.InfinityError, C.Integer,
      C.Listable,
      C.Null,
      C.OneIdentity, C.Orderless,
      C.Pattern, C.Pi,
      C.SingularityError, C.String, C.Symbol,
      C.True,
      C.Catalan,
      C.EulerGamma,
   };
   final static public HSymbol          OtherSymbolsTable[] = 
   {
      ACot,
      ACoth,
      Cot,
      Coth,
      Error,
      ArithmeticError,
      NumberOfArgumentsError,
      SingularityError,
      UndefinedError,
      InfinityError,
      HeadFormatError,

      Continue,
      ConvertTemperature,
      Append,
      AppendTo,
      Apply,
      Array,

      //Complement,
      Delete,
      Depth,
      Exec,

      First,
      FixedPoint,
      Function,

      // InstanceList,
      Hold,
      Insert,
      Inverse,
      Join,
      Last,
      Level,
      Nest,
      KPartitions,
      KSubsets,
      NumberPartitions,
      Partition,
      Permutations,
      Prepend,
      PrependTo,
      Range,
      Rest,
      TimeConstrained,
      Timing,
      Interrupted,
      Together,

      Complex,
      Degree,
      DiagonalMatrix,
      Dimensions,
      Double,
      DoubleComplex,
      E,
      EulerGamma,
      False,
      Fraction,
      I,
      Infinity,
      Integer,
      List,
      MaxIterations,
      Null,
      Pattern,
      String,
      Symbol,
      True,
      Pi,
      IsVector,
      IdentityMatrix,
      MatrixPow,
      Max,
      Min,
      Not,
      AiryAi,
      ASinh,
      ATanh,
      AddTo,
      Conjugate,
      ACosh,

      NInt,
      Decrement,
      DivideBy,

      EigenvaluesHermitian,
      EigenvaluesSymmetric,
      HermitianAdjoint,
      IsHermitian,
      IsUnitary,
      NLinearSolve,
      
      CrossProduct,
      Det,
      Spur,
      Transpose,
      Hilbert,
      Vandermonde,

      Erf,
      FactorInteger,
      FindStr,
      Fit,
      Flat,
      Gamma,
      Increment,
      InverseMod,
      Listable,
      PowMod,
      PreDecrement,
      PreIncrement,

      OneIdentity,
      Orderless,
      Taylor,
      SubtractFrom,
      TimesBy,
      Union,

      Plot3D,
      Plot3DPanel,
      ParametricPlotPanel,

      ParametricPlot,
      Plot,
      ScatterGraph,
      BarGraph,
      PieChart,
      Binomial,
      Catalan,
      CatalanNumber,
      Factorial2,
      Fibonacci,

      DivP,
		  GCDP,
      LCMP,
		  PolynomialList,
		  ModP,
      MultiplyP,
		  DegreeP,
      SolveP,

      ChiSquareCDF,
	    ChiSquareICDF,
	    ChiSquarePDF,
	    StudentTCDF,
	    StudentTICDF,
	    StudentTPDF,
	    NormalCDF,
	    NormalICDF,
	    NormalPDF,
	    BetaCDF,
	    BetaICDF,
	    BetaPDF,
      FisherFCDF,
	    FisherFICDF,
	    FisherFPDF,
      // function symbols:
      Distribution,
      ArithmeticMean,
	    GeometricMean,
	    HarmonicMean,
      StandardDeviation,
      Variance
   };
   //public static int hierStat[];
   /**
    * Assign the symbols to the symbol hashtable
    *
    * @see HSymbol.HT
    */
   static public void init()
   {
    //  hierStat = new int[260];
    //  for (int i = 0; i < hierStat.length; i++)
    //  {
    //    hierStat[i]=0;
    //  }
      for (int i = 0; i < 26; i++)
      {
         ((HSymbol) VarTable[i]).putSymbol();
      }

      for (int i = 0; i < IOSymbolTable.length; i++)
      {
         ((HSymbol) IOSymbolTable[i]).putSymbol();
      }

      for (int i = 0; i < OtherSymbolsTable.length; i++)
      {
         ((HSymbol) OtherSymbolsTable[i]).putSymbol();
      }      

      I.putUpRule(HRule.SET, I, CI);

      try
      {            
         Properties        settings = new Properties();
         FileInputStream        sf = new FileInputStream("hartmath.ini");
         String property;
         int limit;
         settings.load(sf);
         property = settings.getProperty("RecursionLimit");
         if (property!=null) {
           if (property.charAt(0)=='-') {
             property = property.substring(1);
             limit = new Integer(property).intValue()*(-1);
           }
           else
           {
             limit = new Integer(property).intValue();
           }
           recursionLimit = limit;

         }
         property = settings.getProperty("IterationLimit");
         if (property!=null) {
           if (property.charAt(0)=='-') {
             property = property.substring(1);
             limit = new Integer(property).intValue()*(-1);
           }
           else
           {
             limit = new Integer(property).intValue();
           }
           iterationLimit = limit;

         }
         RecursionLimit = new HSymbol("RecursionLimit",
                                      new ConstantEvaluator(
                                        new HDouble(recursionLimit),
     	                                  HInteger.valueOf(recursionLimit)),
   	                                  HSymbol.CONSTANT);
         IterationLimit = new HSymbol("IterationLimit",
                                      new ConstantEvaluator(
                                        new HDouble(iterationLimit),
     	                                  HInteger.valueOf(iterationLimit)),
   	                                  HSymbol.CONSTANT);

      }
      catch (Throwable se)
      {
         if (C.DEBUG) {
           se.printStackTrace();
         }
         RecursionLimit = new HSymbol("RecursionLimit",
                                      new ConstantEvaluator(new HDouble(-1.0),
     	                                                      C.CN1),
   	                                  HSymbol.CONSTANT);
         IterationLimit = new HSymbol("IterationLimit",
                                      new ConstantEvaluator(new HDouble(-1.0),
     	                                                      C.CN1),
   	                                  HSymbol.CONSTANT);
      }
      RecursionLimit.putSymbol();
      IterationLimit.putSymbol();
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param obj
    * 
    * @return
    * 
    * @see
    */
   static public HObject ELoop(HObject obj)
   {
      HFunction localTrace = null;
      if (C.DEBUG) {
        if (obj==null) {
          C.resultOut.append("C.ELoop(): obj == null");
          throw new UnsupportedOperationException();
        }
      }
      if ( recursionLimit > 0 &&
           ++recursionCounter > recursionLimit ) {
        --recursionCounter;
        C.resultOut.append("RecursionLimit exceeded:");
        C.resultOut.append(obj.toString());
        C.resultOut.append("\n");
        throw new HThrowException(C.Error, C.Error);
        //return C.Hold.f( obj );
      }

      HObject   result = obj.evaluate();

      if (result == null)
      {
         --recursionCounter;

         return null;
      }

      if (C.traceEval)
      {
        localTrace = C.List.f();
        localTrace.add(C.HoldForm.f(obj));
        localTrace.add(C.HoldForm.f(result));
        traceList.add(localTrace);
      }

      HObject   temp = result.evaluate();
      iterationCounter = 0;
      while (temp != null)
      {
         if ( iterationLimit > 0 &&
           ++iterationCounter > iterationLimit ) {
           --iterationCounter;
           --recursionCounter;
           C.resultOut.append("IterationLimit exceeded:");
           C.resultOut.append(temp.toString());
           C.resultOut.append("\n");
           throw new HThrowException(C.Error, C.Error);
           //return C.Hold.f( temp );
         }
         if (C.traceEval)
         {
           localTrace.add(C.HoldForm.f(temp));
         }

         result = temp;
         temp = result.evaluate();
      }

      --recursionCounter;

      return result;
   }

   /**
    * initialize recursion- and iteration counter
    *
    * 
    * @see
    */
   public static void initLimits()
   {
      recursionCounter = 0;
      iterationCounter = 0;
   }

   /**
    * Symbolic evaluation
    * 
    * 
    * @param obj
    * 
    * @return
    * 
    * @see
    */
   final public static HObject EV(HObject obj)
   {
      HObject   result;
      if (C.DEBUG) {
        try {
          return ((result = ELoop(obj)) == null) ? obj : result;
        }
        catch (UnsupportedOperationException se)
        {
          se.printStackTrace();
          C.resultOut.append( obj.toString() );
        }
        return null;
      }
      else {
        return ((result = ELoop(obj)) == null) ? obj : result;
      }
   }

   /**
    * Numerical evaluation [sets numericFlag=true]
    * 
    * 
    * @param obj
    * 
    * @return
    * 
    * @see
    */
   final public static HObject NEV(HObject obj)
   {
     // Context ct = ((ContextThread) Thread.currentThread()).getContext();
      boolean   flag = C.numericFlag;

      C.numericFlag = true;

      HObject   temp = C.EV(obj);

      C.numericFlag = flag;

      return temp;
   }

}