package com.hartmath.combinatoric;

import com.hartmath.expression.*;
import com.hartmath.lib.*;

import java.util.*;

public class Compositions {
  KSubsets comb;
  int parts;
  int x[];
  int join[];
  int res[];
  public Compositions(int num, int prts)
  {
    comb = new KSubsets(num+prts-1, prts-1);
    parts = prts;
    join = new int[parts+1];
    res  = new int[parts];
    join[0] = 0;
    join[parts] = num+parts;   // n+k
  }
  public Object nextElement()
  {
    if ( (x = (int[])comb.nextElement()) != null)
    {
      for (int k=1; k<parts; k++) {  
        join[k] = x[k-1]+1;  
      }  
      for (int k = 1; k<join.length; k++)  
      {  
        res[k-1] = join[k]-join[k-1]-1;  
      }  
      return res;
    }
    return null;
  }     /*
  public static void main(String arg[]) throws Exception
   {

      HSymbol a = new HSymbol("a");
      HSymbol b = new HSymbol("b");
      HSymbol c = new HSymbol("b");
      HSymbol d = new HSymbol("d");
      HFunction f = C.List.f(a,b,c);
      f.add(d);
      int len = f.size();
      try {
        Compositions comb = new Compositions(6, 4);
        int j[];
        while( (j = (int[])comb.nextElement()) != null)
        {
            for (int k=0; k<j.length; k++) {
       //       System.out.print(f.get(j[k]));
              System.out.print(Integer.toString(j[k]));
            }
          System.out.print(" ");
        }
      }
      catch (Throwable se)
      {
        se.printStackTrace();
      }
      System.in.read();
      System.exit(0);
   }      */
}

