/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.lib;

import com.hartmath.expression.*;

import org.kaffe.java.util.*;

import java.lang.*;
import java.awt.*;

/**
 * Evaluates an expression 
 * 
 * @author Klaus Hartlage (khartlage@t-online.de)
 */
public class ContextThread extends Thread
{
 //  private Context context;
   private String inStr;
   private HObject outExpr;
   private OutputStringBuffer outBuf;
   private boolean evaluated = false;
   private HObject evalObject;
   /**
    * Constructor declaration
    *
    *
    * @param edi1
    * @param edi2
    * @param choice
    *
    * @see
    */
   public ContextThread()
   {
      inStr = null;
      outExpr = null;
      outBuf = null;
      evaluated = false;
      evalObject = null;
   }

   public ContextThread(HObject evalObj)
   {
      inStr = null;
      outExpr = null;
      outBuf = null;
      evaluated = false;
      evalObject = evalObj;
   }

   public void setInput(String iStr)
   {
      inStr = iStr;
      outExpr = null;
      outBuf = new OutputStringBuffer();
      evaluated = false;
   }

   public String getOutput( )
   {
      if (!evaluated) {
        outBuf.appendLine("maximum response-time exceeded!\n");
      }
      return outBuf.toString();
   }

   public HObject getResult( )
   {
      return outExpr;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @see
    */
   public void run()
   {
     try
      {
         outExpr = null;
         if (evalObject!=null) {
           outExpr = C.EV(evalObject);
         }
         else {
           C.count++;

           C.InArray.add(C.Null);
           C.OutArray.add(C.Null);

           Scanner        scan = new Scanner(inStr);
           HObject        obj = scan.start();

           C.recursionLimit = ((HSignedNumber) C.EV(C.RecursionLimit)).intValue();
           C.iterationLimit = ((HSignedNumber) C.EV(C.IterationLimit)).intValue();
           C.InArray.set(C.count - 1, obj);
           if (C.showInOut == true)
           {
             outBuf.append("In[" + java.lang.Integer.toString(C.count, 10)
                          + "]:\n");

             if (obj != null)
             {
               outBuf.appendLine(obj.toString());
             }
           }
           C.numericFlag = false;
           C.timeConstrained = 0;
           C.initLimits();

           outExpr = C.EV(obj);
           if (C.showInOut == true)
           {
             C.OutArray.set(C.count - 1, outExpr);
             outBuf.append("Out[" + java.lang.Integer.toString(C.count, 10)
                           + "]:\n");
           }
           outBuf.appendLine(outExpr.toString());
         }
      }
      catch (SyntaxError se)
      {
         outBuf.append("Syntax Error: " + se.getMessage());

         if (C.DEBUG)
         {
            se.printStackTrace();
         }
      }
      catch (HBreakException se)
      {
         outBuf.appendLine("Break() occured outside For, While, Switch");

         if (C.DEBUG)
         {
            se.printStackTrace();
         }
      }
      catch (HContinueException se)
      {
         outBuf.appendLine("Continue() occured outside For, While");

         if (C.DEBUG)
         {
            se.printStackTrace();
         }
      }
      catch (HReturnException se)
      {
         outBuf.appendLine("Return() occured");

         if (C.DEBUG)
         {
            se.printStackTrace();
         }
      }
      catch (HThrowException se)
      {
         outBuf.appendLine("Throw::" + se.why().toString());

         if (C.DEBUG)
         {
            se.printStackTrace();
         }
      }
      catch (Throwable se)
      {
         outBuf.appendLine("Unknown Exception occured: " + se.getMessage());

         if (C.DEBUG)
         {
            se.printStackTrace();
         }
      }
      evaluated = true;
   }

}


