/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.mapping;

import com.hartmath.expression.*;

/**
 * Evaluate functions with 1 argument
 * 
 * @see FunctionEvaluator
 * @see HSymbol
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class E1Arg implements FunctionEvaluator
{

   /**
    * @param vect   vector of the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 1)
      {
         HObject        result = e1ObjArg(vect.get(0));

         if (result != null)
         {
            return result;
         }
         int hier = vect.get(0).hierarchy();
         if (hier<=HObject.INTEGERID) {
           if (hier<=HObject.DOUBLECOMPLEXID) {
             if (hier==HObject.DOUBLEID) {
               return e1DblArg((HDouble) vect.get(0));
             }
             return e1DblComArg((HDoubleComplex) vect.get(0));
           }
           else {
           //  hier==HObject.INTEGERID
             return e1IntArg((HInteger) vect.get(0));
           }
         }
         else {
           if (hier<=HObject.COMPLEXID) {
             if (hier==HObject.FRACTIONID) {
               return e1FraArg((HFraction) vect.get(0));
             }
             return e1ComArg((HComplex) vect.get(0));
           }
           else {
             if (hier==HObject.FUNCTIONID) {
               return e1FunArg((HFunction) vect.get(0));
             }
           }
         }
      }

      return null;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param o
    * 
    * @return
    * 
    * @see
    */
   public HObject e1ObjArg(HObject o)
   {
      return null;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param d
    * 
    * @return
    * 
    * @see
    */
   public HObject e1DblArg(HDouble d)
   {
      return null;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param d
    * 
    * @return
    * 
    * @see
    */
   public HObject e1DblComArg(HDoubleComplex d)
   {
      return null;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param i
    * 
    * @return
    * 
    * @see
    */
   public HObject e1IntArg(HInteger i)
   {
      return null;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param f
    * 
    * @return
    * 
    * @see
    */
   public HObject e1FraArg(HFraction f)
   {
      return null;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param c
    * 
    * @return
    * 
    * @see
    */
   public HObject e1ComArg(HComplex c)
   {
      return null;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param f
    * 
    * @return
    * 
    * @see
    */
   public HObject e1FunArg(HFunction f)
   {
      return null;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param f0
    * @param i1
    * 
    * @return
    * 
    * @see
    */
   public HObject eFunIntArg(HFunction f0, HInteger i1)
   {
      return null;
   }

   /**
    * Method declaration
    * 
    * 
    * @param fun
    * @param str
    * @param prec
    * @param preOperator
    * 
    * @return
    * 
    * @see
    */
   static public String operatorString(HFunction fun, String str, int prec, 
                                       boolean preOperator)
   {
      StringBuffer      buf = new StringBuffer();
      HObject           temp;

      if (fun.size() == 1)
      {
         temp = fun.get(0);

         if (preOperator)
         {
            buf.append(str);
         }

         if (temp.precedence() < prec)
         {
            buf.append('(');
         }

         buf.append(temp.toString());

         if (temp.precedence() < prec)
         {
            buf.append(')');
         }

         if (!preOperator)
         {
            buf.append(str);
         }

         return buf.toString();
      }

      return fun.toFullForm();
   }

}



