package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;

public class EAppendTo  implements FunctionEvaluator
{
   public EAppendTo()
   {
   }
   public HObject evaluate(HFunction f)
   {
      if (f.size() == 2)
      {
         if (f.get(0) instanceof HSymbol)
         {
            HObject     v1 = C.EV(f.get(1));
            HSymbol     sym = (HSymbol) f.get(0);
            HObject     result;
            Object      temp;

            if (!sym.isEmptyBlockVariable())
            {
               result = sym.popBlockVariable();
               temp = execute(result, v1);

               if (temp != null)
               {
                  sym.pushBlockVariable((HObject) temp);

                  return (HObject) temp;
               }

               sym.pushBlockVariable(result);

               return null;
            }

            result = sym.getDownRule(sym);

            if (result != null)
            {
               temp = execute(result, v1);

               if (temp != null)
               {
                  sym.putDownRule(HRule.SET, sym, (HObject) temp);

                  return (HObject) temp;
               }
            }
         }
      }

      return null;
   }

   /**
    * Method declaration
    *
    *
    * @param first
    * @param second
    *
    * @return
    *
    * @see
    */
   public HObject execute(HObject first, HObject second)
   {
      if (first instanceof HFunction)
      {
         HFunction      f = (HFunction) ((HFunction) first).clone();

         //f.add(second);
         f.add(second);
         return f;
      }

      return null;
   }

}