/*--- formatted by Jindent 2.0b2, (www.c-lab.de/~jindent) ---*/

package com.hartmath.mapping;

import com.hartmath.expression.*;
import com.hartmath.lib.*;

/**
 * Evaluate predicate-functions with 1 argument
 * 
 * @see FunctionEvaluator
 * @see HSymbol
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class EB1Arg implements FunctionEvaluator {

	/**
	 * @param vect   vector of the function, which should be evaluated
	 * @return       <code>null</code> or the evaluated object
	 */
	public HObject evaluate(HFunction vect) {
		if (vect.size() == 1) {
			if (evalArg1((HObject) vect.get(0))) {
				return C.True;
			}
		}
		return C.False;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @param o0
	 *
	 * @return
	 *
	 * @see
	 */
	public boolean evalArg1(HObject o0) {

		// try specials object-instaces first

		if (o0 instanceof HInteger) {
			return (eBool1IntArg((HInteger) o0));
		}
		if (o0 instanceof HObject) {
			return eBool1ObjArg(o0);
		}

		return false;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @param o
	 *
	 * @return
	 *
	 * @see
	 */
	public boolean eBool1ObjArg(HObject o) {
		return false;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @param i
	 *
	 * @return
	 *
	 * @see
	 */
	public boolean eBool1IntArg(HInteger i) {
		return false;
	}

}



/*--- formatting done in "Sun Java Convention" style on 06-18-1999 ---*/

