package com.hartmath.mapping;

import com.hartmath.expression.*;
import com.hartmath.lib.*;
/**
 * Evaluate predicate-functions with 2 arguments
 * 
 * @see FunctionEvaluator
 * @see HSymbol
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class EB2Arg implements FunctionEvaluator {

	/**
	 * @param vect   vector of the function, which should be evaluated
	 * @return       <code>null</code> or the evaluated object
	 */
	public HObject evaluate(HFunction vect) {
		if (vect.size() == 2) {
			if (evalArg2((HObject) vect.get(0), 
							 (HObject) vect.get(1))) {
				return C.True;
			}
		}
		return C.False;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @param o0
	 * @param o1
	 *
	 * @return
	 *
	 * @see
	 */
	public boolean evalArg2(HObject o0, HObject o1) {
		if (o0 instanceof HObject) {
			return eBool2ObjArg(o0, o1);
		}

		return false;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @param o0
	 * @param o1
	 *
	 * @return
	 *
	 * @see
	 */
	public boolean eBool2ObjArg(HObject o0, HObject o1) {
		return false;
	}

}


