package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

/**
 * Binomial coefficient
 */
public class EBinomial extends E2Arg {
  public EBinomial()
  {
  }
		public HObject e2IntArg(HInteger n, HInteger k) {

			// k>n : by definition --> 0

			if (k.isGreater(n)) {
				return C.C0;
			}
			if (k.isZero() || k.isEqual(n)) {
				return C.C1;
			}

			HInteger bin = C.C1;
			HInteger i = C.C1;
			HInteger temp0 = n.shiftRight(1);
			HInteger temp1 = k;

			if (temp1.isGreater(temp0)) {
				temp1 = n.subtract(temp1);
			}

			while (i.isLessEqual(k)) {
				bin = bin.multiply(n.subtract(i).add(C.C1)).divide(i);
				i = i.add(C.C1);
			}

			return bin;
		}

}

