package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EBlock implements FunctionEvaluator
{
   public EBlock()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if ((vect.size() == 2) && ((HObject) vect.get(0)).isList())
      {
         HFunction      lst = (HFunction) vect.get(0);
         HArrayList          variables = new HArrayList();
         HObject        result;

         try
         {

            // remember which local variables we use:

            for (int i = 0; i < lst.size(); i++)
            {
               if (lst.get(i) instanceof HSymbol)
               {
                  variables.add(lst.get(i));
                  ((HSymbol) lst.get(i)).pushBlockVariable(null);
               }
               else
               {
                  if ((lst.get(i) instanceof HFunction) 
                      && (((HFunction) lst.get(i)).head() == C.Set) 
                      && (((HFunction) lst.get(i)).size() == 2))
                  {
                     HFunction  setFun = (HFunction) lst.get(i);

                     if (setFun.get(0) instanceof HSymbol)
                     {
                        variables.add(setFun.get(0));
                        ((HSymbol) setFun.get(0)).pushBlockVariable(C.EV(setFun.get(1)));
                     }
                  }
               }
            }

            // check for wrong local variable definitions:

            if (variables.size() != lst.size())
            {
               C.resultOut.append("local variable definition expected in block-list: ");
               C.resultOut.appendLine(lst.toString());
            }

            result = C.EV(vect.get(1));
         }
         finally
         {

            // pop all local variables from HSymbol.VStack:

            for (int i = 0; i < variables.size(); i++)
            {
               ((HSymbol) variables.get(i)).popBlockVariable();
            }
         }

         return result;
      }

      return null;
   }

}