package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EConvertTemperature implements FunctionEvaluator
{
   final static public HSymbol Celsius = new HSymbol("Celsius", HSymbol.CONSTANT);
   final static public HSymbol Fahrenheit = new HSymbol("Fahrenheit", HSymbol.CONSTANT);
   public EConvertTemperature()
   {

   }

   public HObject evaluate(HFunction f)
   {
     if (f.size()==3 &&
         (f.get(1) instanceof HSymbol) &&
         (f.get(2) instanceof HSymbol) )
     {
       if (f.get(1).equals( Celsius ) ) {
         if (f.get(2).equals( Fahrenheit ) ) {
           return C.Add.f( C.Multiply.f( HInteger.valueOf( 9 ), f.get(0), C.C1D5), HInteger.valueOf( 32 ) ); 
         }
       }
       if (f.get(1).equals( Fahrenheit ) ) {
         if (f.get(2).equals( Celsius ) ) {
           return C.Multiply.f( C.C5, C.C1D9, C.Add.f(HInteger.valueOf( -32 ), f.get(0) ) ); 
         }
       }
     }
     return null;
   }

}

