package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

/** CrossProduct of 2 3-dim. vectors
  * @return the cross-product of 2 vectors
  */
public class ECrossProduct extends E2Arg {
    public ECrossProduct()
    {
    }
    public HObject e2ObjArg(HObject o0, HObject o1) {
        if ((C.EV(C.IsVector.f(o0)) == C.True) && (C.EV(C.IsVector.f(o1)) == C.True)) {
            HFunction v0 = (HFunction)o0;
            HFunction v1 = (HFunction)o1;
            if (v0.size() == 3 || v1.size() == 3) {
                return C.List.f(C.Add.f(C.Multiply.f(v0.get(1), v1.get(2)), C.Multiply.f(C.CN1, v0.get(2), v1.get(1))),
                    C.Add.f(C.Multiply.f(v0.get(2), v1.get(0)), C.Multiply.f(C.CN1, v0.get(0), v1.get(2))),
                    C.Add.f(C.Multiply.f(v0.get(0), v1.get(1)), C.Multiply.f(C.CN1, v0.get(1), v1.get(0))));
            }
        }
        return null;
    }
}

