package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EDenominator extends E1Arg
{
   public EDenominator()
   {
   }
   /**
    * Method declaration
    * @param o
    * @return
    * @see
    */
   public HObject e1ObjArg(HObject o)
   {
      if (o instanceof HRational)
      {
         return ((HRational) o).denom();
      }

      if (o instanceof HFunction && o.head().equals(C.Multiply))
      {
         HFunction      f = (HFunction) o;

         if (f.size() == 0)
         {
            return f;
         }

         HFunction      result = C.Multiply.f();
         HObject        temp;

         for (int i = 0; i < f.size(); i++)
         {
            temp = C.EV(C.Denominator.f(f.get(i)));

            if (!temp.equals(C.C1))
            {
               result.add(temp);
            }
         }

         if (result.size() > 0)
         {
            return result;
         }

         return C.C1;
      }
      else
      {
         if (o instanceof HFunction && o.head().equals(C.Pow))
         {
            HFunction   f = (HFunction) o;

            if (f.size() != 2)
            {
               return C.C1;
            }

            if (f.get(1) instanceof HSignedNumber)
            {
               if (((HSignedNumber) f.get(1)).isNegative())
               {
                  return C.Pow.f(f.get(0), C.Multiply.f(C.CN1, f.get(1)));
               }
            }

            if (f.get(1) instanceof HFunction)
            {
               HFunction        exp = (HFunction) f.get(1);

               if (exp.size() > 0 && exp.head().equals(C.Multiply))
               {
                  if (exp.get(0) instanceof HSignedNumber)
                  {
                     if (((HSignedNumber) exp.get(0)).isNegative())
                     {
                        HFunction       g = (HFunction) exp.clone();

                        g.set(0, C.Multiply.f(C.CN1, exp.get(0)));

                        return C.Pow.f(f.get(0), g);
                     }
                  }
               }
            }
         }
      }

      return C.C1;
   }

}

