package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.JSci.maths.statistics.*;

public class EDistribution implements FunctionEvaluator {
  public EDistribution()
  {
  }
	public HObject evaluate(HFunction fun) {
	    if (fun.size() == 3 && fun.get(1) instanceof HDouble 
		    && fun.get(2) instanceof HDouble) {
		if (fun.get(0).equals(C.ChiSquareCDF)) {
		    ChiSqrDistribution cs = 
			new ChiSqrDistribution(((HDouble) fun.get(1)).doubleValue());

		    return new HDouble(cs.cumulative(((HDouble) fun.get(2)).doubleValue()));
		}

		if (fun.get(0).equals(C.ChiSquareICDF)) {
		    ChiSqrDistribution cs =
			new ChiSqrDistribution(((HDouble) fun.get(1)).doubleValue());

		    return new HDouble(cs.inverse(((HDouble) fun.get(2)).doubleValue()));
		}

		if (fun.get(0).equals(C.ChiSquarePDF)) {
		    ChiSqrDistribution cs =
			new ChiSqrDistribution(((HDouble) fun.get(1)).doubleValue());

		    return new HDouble(cs.probability(((HDouble) fun.get(2)).doubleValue()));
		}

		if (fun.get(0).equals(C.StudentTCDF)) {
		    TDistribution cs =
			new TDistribution(((HDouble) fun.get(1)).intValue());

		    return new HDouble(cs.cumulative(((HDouble) fun.get(2)).doubleValue()));
		}

		if (fun.get(0).equals(C.StudentTICDF)) {
		    TDistribution cs =
			new TDistribution(((HDouble) fun.get(1)).intValue());

		    return new HDouble(cs.inverse(((HDouble) fun.get(2)).doubleValue()));
		}

		if (fun.get(0).equals(C.StudentTPDF)) {
		    TDistribution cs =
			new TDistribution(((HDouble) fun.get(1)).intValue());

		    return new HDouble(cs.probability(((HDouble) fun.get(2)).doubleValue()));
		}
	    }

	    if (fun.size() == 4 && fun.get(1) instanceof HDouble
		    && fun.get(2) instanceof HDouble
		    && fun.get(3) instanceof HDouble) {
		if (fun.get(0).equals(C.NormalCDF)) {
		    NormalDistribution nd =
			new NormalDistribution(((HDouble) fun.get(1)).doubleValue(),
					       ((HDouble) fun.get(2)).doubleValue());

		    return new HDouble(nd.cumulative(((HDouble) fun.get(3)).doubleValue()));
		} 

		if (fun.get(0).equals(C.NormalICDF)) {
		    NormalDistribution nd = 
			new NormalDistribution(((HDouble) fun.get(1)).doubleValue(), 
					       ((HDouble) fun.get(2)).doubleValue());

		    return new HDouble(nd.inverse(((HDouble) fun.get(3)).doubleValue()));
		} 

		if (fun.get(0).equals(C.NormalPDF)) {
		    NormalDistribution nd = 
			new NormalDistribution(((HDouble) fun.get(1)).doubleValue(), 
					       ((HDouble) fun.get(2)).doubleValue());

		    return new HDouble(nd.probability(((HDouble) fun.get(3)).doubleValue()));
		} 

		if (fun.get(0).equals(C.BetaCDF)) {
		    BetaDistribution nd = 
			new BetaDistribution(((HDouble) fun.get(1)).doubleValue(), 
					     ((HDouble) fun.get(2)).doubleValue());

		    return new HDouble(nd.cumulative(((HDouble) fun.get(3)).doubleValue()));
		} 

		if (fun.get(0).equals(C.BetaICDF)) {
		    BetaDistribution nd = 
			new BetaDistribution(((HDouble) fun.get(1)).doubleValue(), 
					     ((HDouble) fun.get(2)).doubleValue());

		    return new HDouble(nd.inverse(((HDouble) fun.get(3)).doubleValue()));
		} 

		if (fun.get(0).equals(C.BetaPDF)) {
		    BetaDistribution nd = 
			new BetaDistribution(((HDouble) fun.get(1)).doubleValue(), 
					     ((HDouble) fun.get(2)).doubleValue());

		    return new HDouble(nd.probability(((HDouble) fun.get(3)).doubleValue()));
		}

    if (fun.get(0).equals(C.FisherFCDF)) {
		    FDistribution nd =
			new FDistribution(((HDouble) fun.get(1)).doubleValue(),
					     ((HDouble) fun.get(2)).doubleValue());

		    return new HDouble(nd.cumulative(((HDouble) fun.get(3)).doubleValue()));
		}

		if (fun.get(0).equals(C.FisherFICDF)) {
		    FDistribution nd =
			new FDistribution(((HDouble) fun.get(1)).doubleValue(),
					     ((HDouble) fun.get(2)).doubleValue());

		    return new HDouble(nd.inverse(((HDouble) fun.get(3)).doubleValue()));
		} 

		if (fun.get(0).equals(C.FisherFPDF)) {
		    FDistribution nd =
			new FDistribution(((HDouble) fun.get(1)).doubleValue(), 
					     ((HDouble) fun.get(2)).doubleValue());

		    return new HDouble(nd.probability(((HDouble) fun.get(3)).doubleValue()));
		}
	    } 

	    return null;
	} 

}


