package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.io.*;
import java.net.*;

public class EEigenvaluesHermitian implements FunctionEvaluator
{

   public EEigenvaluesHermitian()
   {
   }
   public HObject evaluate(HFunction vect)
   {
      if ( (vect.size() == 1) &&
           vect.get(0) instanceof HFunction) {
        HMatrix hm = new HMatrix((HFunction)vect.get(0));
        HDoubleComplex arr[][] = hm.toDoubleComplexMatrixArray();
        ComplexSquareMatrix cm = new ComplexSquareMatrix(arr);
        ComplexVector evec[]=new ComplexVector[cm.rows()];
     //   C.resultOut.append(csm.toString());
        double darr[] = LinearMath.eigenSolveHermitian( cm, evec );
        return new HFunction(C.List, darr);
      }

      return null;
   }

}

