package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.io.*;
import java.net.*;

public class EEigenvaluesSymmetric implements FunctionEvaluator
{
   public EEigenvaluesSymmetric()
   {
   }
   public HObject evaluate(HFunction vect)
   {
      if ( (vect.size() == 1) &&
           vect.get(0) instanceof HFunction) {
        HMatrix hm = new HMatrix((HFunction)vect.get(0));
        double arr[][] = hm.toDoubleMatrixArray();
        return new HFunction(C.List,LinearMath.eigenvalueSolveSymmetric( new DoubleSquareMatrix(arr) ));
      }

      return null;
   }

}

