package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EEqual extends E2Arg implements FunctionOpEvaluator
{
   public EEqual()
   {
   }

   public HObject e2ObjArg(HObject o0, HObject o1)
   {
      if (o0.equals(o1))
      {
         return C.True;
      }

      if ((o0 instanceof HSymbol) 
          && ((HSymbol.CONSTANT & ((HSymbol) o0).getAttributes()) == HSymbol.CONSTANT) 
          && (o1 instanceof HSymbol) 
          && ((HSymbol.CONSTANT & ((HSymbol) o1).getAttributes()) 
              == HSymbol.CONSTANT))
      {
         return C.False;
      }

      if (o0.isNumber() && o1.isNumber())
      {
         return C.False;
      }

      if (o0 instanceof HString && o1 instanceof HString)
      {

         // HSymbol extends HString !!!
         if (o0 instanceof HSymbol || o1 instanceof HSymbol)
         {
            return null;
         }

         return C.False;
      }

      return null;
   }

   /**
    * Method Declaration.
    * @param fun
    * @return
    * @see
    */
   public String toOpString(HFunction fun)
   {
      return E2Arg.operatorString(fun, "==", 200);
   }

   /**
    * Method Declaration.
    * @return
    * @see
    */
   public int precedence()
   {
      return 200;
   }

}

