/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.loadable;

import com.hartmath.combinatoric.*;
import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import org.kaffe.java.util.*;

import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;
/**
 * Class Declaration.
 * @see
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 * @version   %I%, %G%
 */
public class EExpand extends E1Arg {
    public EExpand()
    {
    }
    /**
     * Method Declaration.
     * @param o
     * @return
     * @see
     */
    public HObject e1ObjArg(HObject o) {
        if (o instanceof HFunction) {
            HFunction f = (HFunction)o;
            HObject temp;
            if (f.head().equals(C.Add)) {
                return mapExpand(f);
            }
            if (f.head().equals(C.Multiply) && (f.size() >= 2)) {
                temp = C.EV(mapExpand(f));
                if ((temp instanceof HFunction) && ((!((HFunction)temp).head().equals(C.Multiply)) ||
                    (((HFunction)temp).size() < 2))) {
                    return temp;
                }
                f = (HFunction)temp;
                for (int i = 0; i < f.size(); i++) {
                    if (f.get(i).head().equals(C.Add)) {
                        if (f.size() == 2) {
                            if (i == 0) {
                                return multiplyExpand(f.get(0), f.get(1));
                            }
                            else {
                                return multiplyExpand(f.get(1), f.get(0));
                            }
                        }
                        else {
                            return multiplyMultiExpand(f, i);
                        }
                    }
                }
            }
            if (f.head().equals(C.Pow) && (f.size() == 2)) {
                if (f.get(1) instanceof HInteger) {
                    HObject tmp = C.EV(C.Expand.f(f.get(0)));
                    if (tmp instanceof HFunction) {
                        HFunction fm = (HFunction)tmp;
                        if (fm.head().equals(C.Add)) {
                            return powExpand(fm, (HInteger)f.get(1));
                        }
                        if (fm.head().equals(C.Multiply)) {
                            HFunction result = new HFunction(C.Multiply);
                            for (int i = 0; i < fm.size(); i++) {
                                result.add(C.Expand.f(C.Pow.f(fm.get(i), f.get(1))));
                            }
                            return result;
                        }
                    }
                }
            }
        }
        return o;
    }

    /**
     * Method Declaration.
     * @param f
     * @param sym
     * @return
     * @see
     */
    public HObject mapExpand(HFunction f) {
        return f.map(C.Expand);
    }

    /**
     * Method Declaration.
     * @param f
     * @param i
     * @return
     * @see
     */
    public HObject multiplyMultiExpand(HFunction f, int i) {
        return multiplyExpand(f.get(i), new HFunction(f, C.Multiply, i, i + 1, false));
    }

    /**
     * Method Declaration.
     * @param o0
     * @param o1
     * @return
     * @see
     */
    public HObject multiplyExpand(HObject o0, HObject o1) {
        HObject temp;
        if (o0 instanceof HFunction) {
            HFunction f0 = (HFunction)o0;
            int lim0 = f0.size();
            if ((o1 instanceof HFunction) && (((HFunction)o1).head().equals(C.Multiply) ||
                ((HFunction)o1).head().equals(C.Add))) {
                HFunction f1 = (HFunction)o1;
                int lim1 = f1.size();
                if (f1.head().equals(C.Multiply)) {
                    HFunction m_expnd = new HFunction(C.Add, lim0);
                    HFunction f2;
                    for (int i = 0; i < lim0; i++) {
                        f2 = C.Multiply.f(f0.get(i));
                        for (int j = 0; j < lim1; j++) {
                            f2.add(f1.get(j));
                        }
                        m_expnd.set(i, C.Expand.f(f2));
                    }
                    return m_expnd;
                }
                if (f1.head().equals(C.Add)) {
                    HFunction a_expnd = new HFunction(C.Add, lim0 * lim1);
                    for (int i = 0; i < lim0; i++) {
                        temp = f0.get(i);
                        for (int j = 0; j < lim1; j++) {
                            a_expnd.set(i * lim1 + j, C.Multiply.f(temp, f1.get(j)));
                        }
                    }
                    return a_expnd;
                }
            }
            else {
                HFunction expnd = new HFunction(C.Add, lim0);
                for (int i = 0; i < lim0; i++) {
                    expnd.set(i, C.Multiply.f(f0.get(i), o1));
                }
                return expnd;
            }
        }
        return null;
    }

    /**
     * Method Declaration.
     * @param f0
     * @param i1
     * @return
     * @see
     */                                /*
    public HObject powerExpand(HFunction f0, HInteger i1) {
        if (f0.size() == 0) {
            return null;
        }
        if (i1.less(C.C0)) {
            return null;
        }
        if (i1.equals(C.C0)) {
            return C.C1;
        }
        if (i1.equals(C.C1)) {
            return f0;
        }
        HInteger tint = i1;
        HObject c = new HFunction(C.Add, C.C1);
        HObject square = f0;
        do {
            if (tint.isOdd()) {
                c = C.EV(multiplyExpand(square, c));
            }
            tint = tint.shiftRight(1);
            if (tint.isZero()) {
                return c; // interrupt moon-loop
            }
            square = C.EV(multiplyExpand(square, square));
        }
        while (true); // end do (moon-loop)
    }        */
    public HObject powExpand(HFunction f0, HInteger i1)
    {
      if (f0.size() == 0) {
          return null;  
      }  
      if (i1.less(C.C0)) {  
          return null;  
      }  
      if (i1.equals(C.C0)) {  
          return C.C1;  
      }  
      if (i1.equals(C.C1)) {  
          return f0;  
      }
      int len = i1.intValue();
      int flen = f0.size();
      EFactorial efac = new EFactorial();
      HInteger fac_len = efac.factorial(i1);
      HInteger multiNum = null;
      Compositions cp = new Compositions(len, flen);
      HFunction c = C.Add.f();
      HFunction temp;
      int j[];
      while( (j = (int[])cp.nextElement()) != null ){
        multiNum = multinomial( fac_len, j );
          temp = C.Multiply.f(multiNum);
          for (int i=0;i<flen;i++) {
            if (j[i]!=0) {
              temp.add(C.Pow.f(f0.get(i),HInteger.valueOf(j[i])));
            }
          }
          c.add(temp);
      }
      return c;
    }

    HInteger multinomial(HInteger fac_len, int j[])
    {
      HInteger res = fac_len;
      EFactorial efac = new EFactorial();
      for (int i=0;i<j.length;i++)
      {
        if ( j[i]!=0 ) {
          res = res.divide( efac.factorial( HInteger.valueOf(j[i]) ) );
        }
      }
      return res;
    }
}


