package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.io.*;
import java.net.*;

public class EFactorInteger extends E1Arg {
    public EFactorInteger()
    {
    }
    /**
     * Method declaration
     * @param big
     * @return
     * @see
     */
    public HObject e1IntArg(HInteger big) {
        int n[] =
            {
         3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67,
         71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139,
         149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211,
         223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281,
         283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367,
         373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439, 443,
         449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523,
         541, 547, 557, 563, 569, 571, 577, 587, 593, 599, 601, 607, 613,
         617, 619, 631, 641, 643, 647, 653, 659, 661, 673, 677, 683, 691,
         701, 709, 719, 727, 733, 739, 743, 751, 757, 761, 769, 773, 787,
         797, 809, 811, 821, 823, 827, 829, 839, 853, 857, 859, 863, 877,
         881, 883, 887, 907, 911, 919, 929, 937, 941, 947, 953, 967, 971,
         977, 983, 991, 997
      };
        HFunction lst = C.List.f();
        HInteger tmp = big;
        HInteger tst = null;
        if (tmp.isZero()) {
            lst.add(C.List.f(C.C0, C.C1));
            return lst;
        }
        if (tmp.isNegative()) {
            lst.add(C.List.f(C.CN1, C.C1));
            tmp = tmp.negate();
        }
        else {
            if (tmp.equals(C.C1)) {
                lst.add(C.List.f(C.C1, C.C1));
                return lst;
            }
        }
        int count = 0;
        while (tmp.isEven()) {
            tmp = tmp.shiftRight(1);
            count++;
        }
        if (count != 0) {
            lst.add(C.List.f(C.C2, HInteger.valueOf(count)));
            count = 0;
        }
        if (tmp.equals(C.C1)) {
            return lst;
        }
        if (!tmp.gcd(HInteger.valueOf(15015)).equals(C.C1)) {
            for (int i = 0; i < 5; i++) {
                tst = HInteger.valueOf(n[i]);
                while (tmp.mod(tst).equals(C.C0)) {
                    count++;
                    tmp = tmp.divide(tst);
                    if (tmp.equals(C.C1)) {
                        lst.add(C.List.f(HInteger.valueOf(n[i]), HInteger.valueOf(count)));
                        return lst;
                    }
                }
                if (count != 0) {
                    lst.add(C.List.f(HInteger.valueOf(n[i]), HInteger.valueOf(count)));
                    count = 0;
                }
            }
        }
        if (tmp.isProbablePrime(32)) {
            lst.add(C.List.f(tmp, C.C1));
            return lst;
        }
        for (int i = 5; i < n.length; i++) {
            tst = HInteger.valueOf(n[i]);
            while (tmp.mod(tst).equals(C.C0)) {
                count++;
                tmp = tmp.divide(tst);
                if (tmp.equals(C.C1)) {
                    lst.add(C.List.f(tst, HInteger.valueOf(count)));
                    return lst;
                }
            }
            if (count != 0) {
                lst.add(C.List.f(tst, HInteger.valueOf(count)));
                if (tmp.isProbablePrime(32)) {
                    lst.add(C.List.f(tmp, C.C1));
                    return lst;
                }
                count = 0;
            }
        }
        if (!tmp.equals(C.C1)) {
            tst = pollardRho(tmp, tmp.divide(C.C2), C.C1, 20);
            while (!tst.isZero()) {
                while (tmp.mod(tst).equals(C.C0)) {
                    count++;
                    tmp = tmp.divide(tst);
                    if (tmp.equals(C.C1)) {
                        lst.add(C.List.f(tst, HInteger.valueOf(count)));
                        return lst;
                    }
                }
                if (count != 0) {
                    lst.add(C.List.f(tst, HInteger.valueOf(count)));
                    if (tmp.isProbablePrime(32)) {
                        lst.add(C.List.f(tmp, C.C1));
                        return lst;
                    }
                    count = 0;
                }
                tst = pollardRho(tmp, tmp.divide(C.C2), C.C1, 20);
            }
        }
        if (!tmp.equals(C.C1)) {
            tst = pollardP1(tmp, 1000);
            while (!tst.isZero()) {
                while (tmp.mod(tst).equals(C.C0)) {
                    count++;
                    tmp = tmp.divide(tst);
                    if (tmp.equals(C.C1)) {
                        lst.add(C.List.f(tst, HInteger.valueOf(count)));
                        return lst;
                    }
                }
                if (count != 0) {
                    lst.add(C.List.f(tst, HInteger.valueOf(count)));
                    if (tmp.isProbablePrime(32)) {
                        lst.add(C.List.f(tmp, C.C1));
                        return lst;
                    }
                    count = 0;
                }
                tst = pollardP1(tmp, 1000);
            }
            if (!tmp.equals(C.C1)) {
                lst.add(C.List.f(tmp, C.C1));
                return lst;
            }
        }
        return lst;
    }

    /**
     * Method declaration
     * @param big
     * @param x0
     * @param c
     * @param max
     * @return
     * @see
     */
    HInteger pollardRho(HInteger big, HInteger x0, HInteger c, int max) {
        HInteger x1, x2, div;
        int count = 0, len = 1;
        x1 = x0.multiply(x0).add(c).mod(big);
        x2 = x1.multiply(x1).add(c).mod(big);
        while (count < max) {
            for (int j = 0; j < len; j++) {
                x2 = x2.multiply(x2).add(c).mod(big);
                count++;
                div = x1.subtract(x2).gcd(big);
                if (div.greater(C.C1)) {
                    return div;
                }
            }
            x1 = x2;
            len += len;
            for (int j = 0; j < len; j++) {
                x2 = x2.multiply(x2).add(c).mod(big);
            }
        }
        return C.C0;
    }

    /**
     * Method declaration
     * @param big
     * @param max
     * @return
     * @see
     */
    HInteger pollardP1(HInteger big, int max) {
        HInteger div;
        for (int j = 2; j < 6; j++) {
            HInteger m = HInteger.valueOf(j);
            for (int i = 1; i <= max; i++) {
                m = m.modPow(HInteger.valueOf(i), big);
                if (i % 10 == 0) {
                    div = m.subtract(C.C1).gcd(big);
                    if (div.greater(C.C1)) {
                        return div;
                    }
                }
            }
        }
        return C.C0;
    }
}

