package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;

public class EFindStr implements FunctionEvaluator
{

   public EFindStr()
   {
   }

   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if ((vect.size() == 3) && (vect.get(0) instanceof HString) 
          &&                                            // directory
      (vect.get(1) instanceof HString) &&         // filter
      (vect.get(2) instanceof HString))
      {                                                 // search-string
         StringBuffer   buffer = new StringBuffer();
         Enumeration    files = new HFileList(vect.get(0).toString(), 
                                              vect.get(1).toString()).files();

         while (files.hasMoreElements())
         {
            try
            {
               find(buffer, ((File) files.nextElement()).getCanonicalPath(), 
                    vect.get(2).toString());
            }
            catch (Exception e) {}
         }

         return new HString(buffer);
      }

      return null;
   }

   /**
    * Method declaration
    *
    *
    * @param buffer
    * @param filename
    * @param s
    *
    * @return
    *
    * @see
    */
   static boolean find(StringBuffer buffer, String filename, String s)
   {
      try
      {
         BufferedReader in = 
            new BufferedReader(new InputStreamReader(new FileInputStream(filename)));
         String         line;

         while (true)
         {
            line = in.readLine();

            if (line == null)
               break;

            if (line.indexOf(s) >= 0)
            {
               buffer.append(filename);
               buffer.append("\n");

               break;
            }
         }

         in.close();
      }
      catch (Exception e)
      {
         return false;
      }

      return true;
   }

}
