package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.io.*;
import java.net.*;


public class EFit implements FunctionEvaluator
{
   public EFit()
   {
    
   }
   public HObject evaluate(HFunction vect)
   {
      if ( (vect.size() == 3) &&
           vect.get(0) instanceof HFunction &&
           vect.get(2) instanceof HSymbol) {
        HSymbol sym = (HSymbol) vect.get(2);
        int n = vect.toInt(1);
        if (n<0) {
          return null;
        }
        HMatrix hm = new HMatrix((HFunction)vect.get(0));
        double arr[][] = hm.toDoubleMatrixArray();
        if (arr.length!=2) {
          return null;
        }
//public static DoubleVector leastSquaresFit(int n,final double data[][]) {
        DoubleVector dv = LinearMath.leastSquaresFit( n, arr );
        HFunction result = C.Add.f();
        for (int i=0; i<dv.dimension();i++) {
          result.add( C.Multiply.f( new HDouble(dv.getComponent(i)), C.Pow.f(sym, HInteger.valueOf(i) ) ));
        }
        return result;
      }

      return null;
   }

}
