package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

/**
 * Class Declaration.
 * 
 * 
 * @see
 *
 * @author
 * @version   %I%, %G%
 */
public class EHilbert implements FunctionEvaluator {
  public EHilbert()
  {
  }
	/**
	 * hilbert matrix, defined by Aij = 1/(i+j-x)
	 */
	public HObject evaluate(HFunction f) {
		if (f.size() > 0 && f.size() <= 2 && f.get(0) instanceof HInteger) {
			HObject  x = C.CN1;

			if (f.size() == 2) {
				x = C.EV(C.Expand.f(C.Multiply.f(C.CN1, f.get(1))));
			}

			HInteger hi = (HInteger) f.get(0);

			if (hi.checkRange(1L, Integer.MAX_VALUE)) {
				int			indx = hi.intValue();
				HFunction	m = new HFunction(C.List, C.List, indx, indx, 
														HFunction.MATRIXFORM);

				for (int i = 0; i < indx; i++) {
					for (int j = 0; j < indx; j++) {
						m.set(i, j, C.EV(C.Pow.f(C.Add.f(HInteger.valueOf(i+1), HInteger.valueOf(j+1), x), C.CN1)));
					}
				}

				return m;
			}
		}

		return null;
	}

}
