package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

/**
 * Class declaration
 * @author
 * @version %I%, %G%
 */
public class EIdentityMatrix implements FunctionEvaluator {
    public EIdentityMatrix()
    {
    }
    /**
     * Method declaration
     * @param fun
     * @return
     * @see
     */
    public HObject evaluate(HFunction fun) {
        if ((fun.size() == 1) && (fun.get(0) instanceof HInteger || fun.get(0) instanceof HDouble)) {
            int m = 0;
            if (fun.get(0) instanceof HInteger) {
                m = ((HInteger)fun.get(0)).intValue();
            }
            else {
                m = ((HDouble)fun.get(0)).intValue();
            }
            if (m <= 0) {
                return null;
            }
            return fInt(m);
        }
        return null;
    }

    /**
     * Method declaration
     * @param m
     * @return
     * @see
     */
    static public HObject fInt(int m) {
        HFunction mat = new HFunction(C.List, C.List, m, m, HFunction.MATRIXFORM);
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < m; j++) {
                if (i == j) {
                    mat.set(i, j, C.C1);
                }
                else {
                    mat.set(i, j, C.C0);
                }
            }
        }
        return mat;
    }
}

