package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EIf implements FunctionEvaluator
{
   public EIf()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if ((vect.size() <= 4) && (vect.size() >= 2))
      {
         HObject        temp = C.EV(vect.get(0));

         if (temp == C.False)
         {
            if (vect.size() >= 3)
            {
               return vect.get(2);
            }

            return C.Null;
         }

         if (temp == C.True)
         {
            return vect.get(1);
         }

         if (vect.size() == 4)
         {
            return vect.get(3);
         }
      }

      return C.Null;
   }

}