package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;

public class EIncrement implements FunctionOpEvaluator //, UnaryFunction
{

   public EIncrement()
   {
   }
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 1)
      {
         if (vect.get(0) instanceof HSymbol)
         {
            HSymbol     sym = (HSymbol) vect.get(0);
            HObject     result;
            Object      temp;

            if (!sym.isEmptyBlockVariable())
            {
               result = sym.popBlockVariable();
               temp = execute(result);

               if (temp != null)
               {
                  sym.pushBlockVariable((HObject) temp);

                  return result;
               }

               sym.pushBlockVariable(result);

               return null;
            }

            result = sym.getDownRule(sym);

            if (result != null)
            {
               temp = execute(result);

               if (temp != null)
               {
                  sym.putDownRule(HRule.SET, sym, (HObject) temp);

                  return result;
               }
            }
         }
      }

      return null;
   }

   /**
    * Method declaration
    *
    *
    * @param first
    *
    * @return
    *
    * @see
    */
   public Object execute(Object first)
   {
      return C.EV(C.Add.f((HObject) first, C.C1));
   }

   /**
    * Method declaration
    *
    *
    * @param fun
    *
    * @return
    *
    * @see
    */
   public String toOpString(HFunction fun)
   {
      return E1Arg.operatorString(fun, "++", 700, false);
   }

   /**
    * Method declaration
    *
    *
    * @return
    *
    * @see
    */
   public int precedence()
   {
      return 700;
   }

}