package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.io.*;
import java.net.*;

public class EIsHermitian implements FunctionEvaluator
{
   public EIsHermitian()
   {
   }
   public HObject evaluate(HFunction vect)
   {
      if ( (vect.size() == 1) &&
           vect.get(0) instanceof HFunction) {
        HMatrix hm = new HMatrix((HFunction)vect.get(0));
        HDoubleComplex arr[][] = hm.toDoubleComplexMatrixArray();
        if (( new ComplexSquareMatrix(arr) ).isHermitian() )
        {
        	return C.True;
        }
        else {
          return C.False;
        }
      }

      return null;
   }

}
