package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class ELambda implements FunctionEvaluator
{
   public ELambda()
   {
   }
   /**
    * Method Declaration.
    * 
    * 
    * @param vect
    * 
    * @return
    * 
    * @see
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() >= 3)
      {         // && vect.get(1) instanceof HFunction
         HObject        obj = vect.get(1);

         if (vect.get(0).equals(C.Null))
         {
            for (int i = 2; i < vect.size(); i++)
            {
               obj = substitute(obj, C.Slot.f(HInteger.valueOf(i - 1)),
                                    C.EV(vect.get(i)));
            }

            return C.EV(obj);
         }

         if (vect.get(0) instanceof HSymbol)
         {
//            HSymbol     sym = (HSymbol) vect.get(0);

            obj = substitute(obj, vect.get(0), C.EV(vect.get(2)));

            return C.EV(obj);
         }

         if (vect.get(0).isList())
         {
            HFunction   lst = (HFunction) vect.get(0);

            if (vect.size() - 2 >= lst.size())
            {
               for (int i = 0; i < lst.size(); i++)
               {
                  if (!(lst.get(i) instanceof HSymbol))
                  {
                     return null;
                  }
               }

               for (int i = 0; i < lst.size(); i++)
               {
                  obj = substitute(obj, (lst.get(i)),
                                       C.EV(vect.get(2 + i)));
               }

               return C.EV(obj);
            }
         }
      }

      return null;
   }

   public HObject substitute(HObject fun, HObject obj, HObject subst)
   {
      if (fun instanceof HFunction)
      {
        HFunction f = (HFunction) fun;
        // local variables are necessary:
        if (f.head().equals( C.Lambda ) )
        {
          return f;
        }
        //---
        boolean   evaled = false;

        if (f.equals(obj))
        {
           return subst;
        }
        HFunction temp;
        if (f.head().equals(obj) && (subst instanceof HSymbol))
        {
           temp = new HFunction((HSymbol) subst);
     //      temp.symbol = (HSymbol) subst;
           temp.addAll(0, f);
           evaled = true;
        }
        else {
          temp = (HFunction)((HFunction) f).clone();
        }

        HObject   tempi;

        for (int i = 0; i < f.size(); i++)
        {
           tempi = substitute(f.get(i), obj, subst);

           if (tempi !=  f.get(i))
           {
              temp.set(i, tempi);

              evaled = true;
           }
        }

        if (evaled)
        {
           return temp;
        }

        return f;
      }
      return fun.substitute(obj, subst);
   }
}