package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class ELessEqual extends E2Arg implements FunctionOpEvaluator
{
   public ELessEqual()
   {
   }
   /**
    * Method Declaration.
    * @param o0
    * @param o1
    * @return
    * @see
    */
   public HObject e2ObjArg(HObject o0, HObject o1)
   {
      if (o0.equals(o1))
      {
         return C.True;
      }

      if (o0.isRational() && o1.isRational())
      {
         if (o0.less(o1))
         {
            return C.True;
         }

         return C.False;
      }

      if (o0 instanceof HString && o1 instanceof HString)
      {

         // HSymbol extends HString
         if (o0 instanceof HSymbol || o1 instanceof HSymbol)
         {
            return null;
         }

         return (((HString) o0).compareTo((HString) o1) <= 0 ? C.True 
                 : C.False);
      }

      return null;
   }

   /**
    * Method Declaration.
    * @param fun
    * @return
    * @see
    */
   public String toOpString(HFunction fun)
   {
      return E2Arg.operatorString(fun, "<=", 200);
   }

   /**
    * Method Declaration.
    * @return
    * @see
    */
   public int precedence()
   {
      return 200;
   }

}
