package com.hartmath.lib;

import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.io.*;
import java.net.*;
/**
  * Load a single class into the system
  *
  */
public class ELoadClass implements FunctionEvaluator
{
   public HObject evaluate(HFunction f)
   {
      if (C.initialized==false) {
        return null;
      }
      String str = "com.hartmath.loadable.E"+f.head().toString();
      Class cls;
      FunctionEvaluator module;
      C.statusLine.setText("Loading: "+f.head().toString()+" - please wait a moment");
      try
      {
        cls = Class.forName(str);
      }
      catch (ClassNotFoundException e)
      {
        cls = null;
        f.head().setNewEval( C.dummyFunction );
        return f;
      }

      try
      {
            module = (FunctionEvaluator) cls.newInstance();
            f.head().setNewEval( module );
            C.statusLine.setText("Loading: "+f.head().toString()+" - Ok");
         //   C.resultOut.appendLine(f.toString());
            return f;
           // return module.evaluate( f );
      }
      catch (Throwable se)
      {
        f.head().setNewEval( C.dummyFunction );
      }

      return f;
   }
   static public boolean loadClass(HSymbol sym)
   {
      String str = "com.hartmath.loadable.E"+sym.toString();
      Class cls;
      FunctionEvaluator module;
      C.statusLine.setText("Loading: "+sym.toString()+" - please wait a moment");
      try
      {
        cls = Class.forName(str);
      }
      catch (ClassNotFoundException e)
      {
        cls = null;
        sym.setNewEval( C.dummyFunction );
        return false;
      }
      try
      {
            module = (FunctionEvaluator) cls.newInstance();
            sym.setNewEval( module );
            C.statusLine.setText("Loading: "+sym+" - Ok");
            return true;
      }
      catch (Throwable se)
      {
        sym.setNewEval( C.dummyFunction );
        return false;
      }
   }

}
