package com.hartmath.lib;

import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

/**
  * Load a class library into the system
  *
  */
public class ELoadClassLibrary extends E1Arg
{
   public HObject e1ObjArg(HObject o)
   {
      if ((o instanceof HSymbol) || (o instanceof HString))
      {
        loadClass(o.toString());
        return C.Null;
      }

      return null;
   }

   public void loadClass(String str)
   {
         FunctionEvaluator      module = null;
         Class                  cls = null;

         try
         {
            cls = Class.forName(str);
         }
         catch (ClassNotFoundException e)
         {
            C.errorOut.append("Class " + str + "not found!");

            cls = null;
         }

         try
         {
            module = (FunctionEvaluator) cls.newInstance();

            module.evaluate(null);
         }
         catch (InstantiationException e)
         {
            C.errorOut.append("Instantion failed!");
         }
         catch (IllegalAccessException e)
         {
            C.errorOut.append("Illegal access!");
         }
         catch (ClassCastException e)
         {
            C.errorOut.append("Class cast failed!");
         }
   }
}
