package com.hartmath.lib;

import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.io.*;
import java.net.*;
/**
  * Load a script into the system
  *
  */
public class ELoadScript implements FunctionEvaluator
{
   public HObject evaluate(HFunction f)
   {
      String str = f.head().toString();
      if (str.charAt(0)>='A' && str.charAt(0)<='Z')
      {
        try
        {
            HSymbol.IOCounter = 0;

            HSymbol.IOOut.clear();
            HSymbol.IOIn.clear();

            URL                 url;
            DataInputStream     in;

            if (C.codeBase == null)
            {                                         // "\\hmscripts\\"+
               FileInputStream  fin = new FileInputStream("hmscripts\\"+str+".hm");
               in = new DataInputStream(fin);
            }
            else
            {                          // "hmscripts/"+
               url = new URL(C.codeBase, "hmscripts/"+str+".hm");
               in = new DataInputStream(url.openStream());
            }

            HObject     obj = IOMapper.map(in);
            C.EV( obj );
            in.close();
        }
        catch (Throwable se)
        {
        }
        f.head().setNewEval( C.dummyFunction );
        return f;
      }
      return null;

   }


}
