package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.lib.*;

public class ELog extends E1Arg
{
/*
Log(-1)=I*Pi;
Log(0):=Throw(SingularityError,Log);
Log(1)=0;
Log(E)=1;
Log(E^x_IsReal):=x;
Log(Infinity)=Infinity;
Log(E^x_):=Check(Im(x)==0, x);
Log(x_IsRational):=Check((Numerator(x)==1)&&(x>0), -Log(Denominator(x)));
*/
   final static long larr[] =
   {4611686018563922514L,5715416228885897740L,2455959681009239634L,6999181111478865745L,4379124269508017186L,343771455772447301L,2451156562475214930L
    ,5715415519056760146L,5859530914230568142L,5911627712386296006L,-1706211899474843613L,3625971997379532113L,4821320357613454930L
   };

   final static byte barr[] =
   {63, -57, 81, 60, 81, 16, -24, };
  
   static boolean first = true;
   public ELog()
   {
     if (first) {
        first = false;
        C.EV( InitRules.init(larr, barr) );
     }
   }

   public HObject e1DblArg(HDouble dbl)
   {
     double d = dbl.doubleValue();
     if (d<0.0d) {
       return new HDoubleComplex(d).log();
     }
     return new HDouble(Math.log(d));
   }
   public HObject e1DblComArg(HDoubleComplex d)
   {
     return d.log();
   }

}




