package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

/**
 * Class declaration
 * @author
 * @version %I%, %G%
 */
public class EMatrixPow implements FunctionEvaluator {
    public EMatrixPow()
    {
    }
    /**
     * Method declaration
     * @param fun
     * @return
     * @see
     */
    public HObject evaluate(HFunction fun) {
        if ((fun.size() == 2) && (fun.get(0) instanceof HFunction) && (fun.get(1) instanceof HInteger ||
            fun.get(1) instanceof HDouble)) {
            HFunction mat = (HFunction)fun.get(0);
            int[] sz = mat.isMatrix();
            if (sz == null) {
                return null;
            }
            int len0 = sz[0];
            if (len0 != sz[1]) {
                return null;
            }
            if (len0 == 0) {
                return null;
            }
            int m = 0;
            if (fun.get(1) instanceof HInteger) {
                m = ((HInteger)fun.get(1)).intValue();
            }
            else {
                m = ((HDouble)fun.get(1)).intValue();
            }
            HObject result = EIdentityMatrix.fInt(len0);
            HObject baseToPow2;

         /* Perform exponentiation using repeated squaring trick */

            if (m < 0) {
                // negative exponent => take the inverse of a matrix
                baseToPow2 = C.EV(C.Inverse.f(mat));
            }
            else {
                baseToPow2 = mat;
            }
            while (m != 0) {
                if ((m & 1) == 1) {
                    result = C.EV(C.Dot.f(result, baseToPow2));
                }
                if ((m >>= 1) != 0) {
                    baseToPow2 = C.EV(C.Dot.f(baseToPow2, baseToPow2));
                }
            }
            return result;
        }
        return null;
    }
}
