/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.mapping;

import com.hartmath.expression.*;

/**
 * Evaluate functions with 1 argument
 * 
 * @see FunctionEvaluator
 * @see HSymbol
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class EMultiArg extends E2Arg
{
             /*
   public HObject binaryOperator(HObject o0, HObject o1)
   {
      HObject   result = null;
      int       hier0 = o0.hierarchy();

      if ( (hier0 <= HObject.COMPLEXID)&&
           (o1.hierarchy() <= HObject.COMPLEXID) )
      {
         if (hier0 <= HObject.INTEGERID)
         {
            if (hier0 <= HObject.DOUBLECOMPLEXID)
            {
               if (o0 instanceof HDouble)
               {
                  if (o1 instanceof HDouble)
                  {
                     return e2DblArg((HDouble) o0, (HDouble) o1);
                  }

                  if (o1 instanceof HDoubleComplex)
                  {
                     return e2DblComArg(new HDoubleComplex((HDouble) o0), 
                                        (HDoubleComplex) o1);
                  }

                  result = e2ObjArg(o0, o1);

                  if (result != null)
                  {
                     return result;
                  }

                  return null;
               }

               if (o1 instanceof HDouble)   
               {   
                  return e2DblComArg((HDoubleComplex) o0,    
                                     new HDoubleComplex((HDouble) o1));   
               }   

               if (o1 instanceof HDoubleComplex)   
               {   
                  return e2DblComArg((HDoubleComplex) o0,    
                                     (HDoubleComplex) o1);   
               }   

               result = e2ObjArg(o0, o1);   

               if (result != null)   
               {   
                  return result;   
               }   

               return null;
            }
            else
            {
               if (o1 instanceof HInteger)
               {
                  return e2IntArg((HInteger) o0, (HInteger) o1);
               }

               if (o1 instanceof HFraction)
               {
                  return e2FraArg(new HFraction((HInteger) o0, C.C1), 
                                  (HFraction) o1);
               }

               if (o1 instanceof HComplex)
               {
                  return e2ComArg(new HComplex((HInteger) o0, C.C0), 
                                  (HComplex) o1);
               }

               result = e2ObjArg(o0, o1);

               if (result != null)
               {
                  return result;
               }

               return null;
            }
         }
         else
         {
            if (hier0 == HObject.FRACTIONID)
            {
               if (o1 instanceof HInteger)
               {
                  return e2FraArg((HFraction) o0, 
                                  new HFraction((HInteger) o1, C.C1));
               }

               if (o1 instanceof HFraction)
               {
                  return e2FraArg((HFraction) o0, (HFraction) o1);
               }

               if (o1 instanceof HComplex)
               {
                  return e2ComArg(new HComplex((HFraction) o0, C.C0), 
                                  (HComplex) o1);
               }

               result = e2ObjArg(o0, o1);

               if (result != null)
               {
                  return result;
               }

               return null;
            }

            if (o1 instanceof HInteger)   
            {   
               return eComIntArg((HComplex) o0, (HInteger) o1);   
            }   

            if (o1 instanceof HComplex)   
            {   
               return e2ComArg((HComplex) o0, (HComplex) o1);   
            }
         }
      }

      result = e2ObjArg(o0, o1);

      if (result != null)
      {
         return result;
      }

      if (o0 instanceof HFunction)
      {
         if (o1 instanceof HInteger)
         {
            return eFunIntArg((HFunction) o0, (HInteger) o1);
         }

         if (o1 instanceof HFunction)
         {
            return e2FunArg((HFunction) o0, (HFunction) o1);
         }
      }

      return null;
   }
         */
   /**
    * Method Declaration.
    * @param vect
    * @return
    * @see
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 2)
      {
         return binaryOperator(vect.get(0), vect.get(1));
      }

      if (vect.size() > 2)
      {
         HSymbol        sym = vect.head();
         HFunction      result = new HFunction(sym);
         HObject        tres;
         HObject        temp = vect.get(0);
         boolean        evaled = false;
         int            i = 1;

         while (i < vect.size())
         {

            // for (int i = 1; i < vect.size(); i++) {
            tres = binaryOperator(temp, vect.get(i));

            /*
             * if (C.traceRuleFlag) {
             * C.traceOut.append("TRACE::EMultiArg.evaluate:");
             * C.traceOut.append(sym.toString() + "(" + temp.toString() + "," + vect.get(i) + ")");
             * C.traceOut.append(" -> ");
             * if (tres == null) {
             * C.traceOut.append("<NULL>");
             * }
             * else {
             * C.traceOut.append(tres.toString());
             * }
             * C.traceOut.append("\n");
             * }
             */
            if (tres == null)
            {

               // kh***
               for (int j = i + 1; j < vect.size(); j++)
               {
                  tres = binaryOperator(temp, vect.get(j));

                  if (tres != null)
                  {
                     evaled = true;
                     temp = tres;

                     vect.remove(j);

                     break;
                  }
               }

               if (tres == null)
               {

                  // kh***
                  result.add(temp);

                  if (i == vect.size() - 1)
                  {
                     result.add(vect.get(i));
                  }
                  else
                  {
                     temp = vect.get(i);
                  }

                  i++;
               }
            }
            else
            {
               evaled = true;
               temp = tres;

               if (i == (vect.size() - 1))
               {
                  result.add(temp);
               }

               i++;
            }
         }

         if (evaled)
         {
            if ((result.size() == 1) 
                && sym.checkAttributes(HSymbol.ONEIDENTITY))
            {
               return result.get(0);
            }

            return result;
         }
      }

      return null;
   }

}
