package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.io.*;
import java.net.*;

public class ENInt implements FunctionEvaluator
{
  public ENInt()
  {
  }
      /**
       * Method declaration
       *
       *
       * @param vect
       * 
       * @return
       *
       * @see
       */
      public HObject evaluate(HFunction vect)
      {
         if (vect.size() == 2 && vect.get(1).isList())
         {
            HFunction   lst = (HFunction) vect.get(1);

            if (lst.size() == 3)
            {
               HObject  a = C.NEV(lst.get(1));
               HObject  b = C.NEV(lst.get(2));

               if ((!(a instanceof HDouble)) || (!(b instanceof HDouble)))
               {
                  return null;
               }

               HUnaryNumerical  hun = new HUnaryNumerical(vect.get(0), 
                                                          lst.get(0));

               return new HDouble(simpson(50, hun,
                                          ((HDouble) a).doubleValue(), 
                                          ((HDouble) b).doubleValue()));
            }
         }

         return null;
      }

      /**
       * Numerical integration using Simpson's rule.
       * @param N the number of strip pairs to use
       * @param func a function
       * @param a the first ordinate
       * @param b the last ordinate
       */
      public double simpson(final int N, final HUnaryNumerical func,
                            final double a, final double b)
      {
         double         Ao = 0.0, Ae = 0.0, x = a;
         final double   h = (b - a) / (2 * N);

         for (int i = 0; i < N - 1; i++)
         {
            Ao += func.map(x + h);
            Ae += func.map(x + 2 * h);
            x += 2.0 * h;
         }

         Ao += func.map(x + h);

         return h / 3.0 * (func.map(a) + 4.0 * Ao + 2.0 * Ae + func.map(b));
      }

   }
