package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;

import java.io.*;
import java.net.*;

public class ENLinearSolve extends ERuleEvaluator
{

   public ENLinearSolve()
   {
     super( 2 );
   }

   public HObject evaluateOptions(HFunction fun)
   {
      if ( (fun.size() == 2) &&
           fun.get(0) instanceof HFunction &&
           fun.get(1) instanceof HFunction) {
        HMatrix hm = new HMatrix((HFunction)fun.get(0));
        double arr[][] = hm.toDoubleMatrixArray();
        DoubleMatrix dm = new DoubleMatrix(arr);
        HVector hv = new HVector((HFunction)fun.get(1));
        DoubleVector dv = new DoubleVector(hv.toDoubleArray());;

        int maxIterations = getIntOption(C.MaxIterations, C.C100);
        DoubleVector dvr = LinearMath.solveGMRes(dm, dv, maxIterations, MathNumber.ZERO_TOL);

        return dvr.toFunction();
      }

      return null;
   }

}
