package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

/**
 * Class declaration
 *
 *
 * @author
 * @version %I%, %G%
 */
public class ENest implements FunctionEvaluator
{
   public ENest()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if ((vect.size() == 3) 
          && (vect.get(2) instanceof HInteger || vect.get(2) instanceof HDouble) 
          && ((HSignedNumber) vect.get(2)).isPositive())
      {
         int    m = 0;

         if (vect.get(2) instanceof HInteger)
         {
            m = ((HInteger) vect.get(2)).intValue();
         }
         else
         {
            m = ((HDouble) vect.get(2)).intValue();
         }
         HObject        result = vect.get(1);

         for (int i = 0; i < m; i++)
         {
            result = C.EV(new HFunction(C.Null, 
                                        result).apply(vect.get(0)));
         }

         return result;
      }

      return null;
   }

}

