package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class ENot extends E1Arg implements FunctionOpEvaluator
{
   public ENot()
   {
   }
   /**
    * Method Declaration.
    * @param o0
    * @param o1
    * @return
    * @see
    */
   public HObject e1ObjArg(HObject o)
   {
      if (o.equals(C.True))
      {
         return C.False;
      }

      if (o.equals(C.False))
      {
         return C.True;
      }

      return null;
   }

   /**
    * Method Declaration.
    * @param fun
    * @return
    * @see
    */
   public String toOpString(HFunction fun)
   {
      StringBuffer      buf = new StringBuffer();
      HObject           temp;

      buf.append("!");

      if (fun.size() == 1)
      {
         temp = fun.get(0);

         if (temp.precedence() < precedence())
         {
            buf.append('(');
         }

         buf.append(temp.toString());

         if (temp.precedence() < precedence())
         {
            buf.append(')');
         }
      }
      else
      {
         buf.append("Not(");

         for (int i = 0; i < fun.size(); i++)
         {
            temp = fun.get(i);

            buf.append(temp.toString());

            if (i != (fun.size() - 1))
            {
               buf.append(",");
            }
         }

         buf.append(')');
      }

      return buf.toString();
   }

   /**
    * Method Declaration.
    * @return
    * @see
    */
   public int precedence()
   {
      return 150;
   }

}


