package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class ENumerator extends E1Arg
{
   public ENumerator()
   {
   }
   /**
    * Method Declaration.
    * @param o
    * @return
    * @see
    */
   public HObject e1ObjArg(HObject o)
   {
      if (o instanceof HRational)
      {
         return ((HRational) o).numer();
      }

      if (o instanceof HFunction && o.head().equals(C.Multiply))
      {
         HFunction      f = (HFunction) o;

         if (f.size() == 0)
         {
            return f;
         }

         HFunction      result = C.Multiply.f();
         HObject        temp;

         for (int i = 0; i < f.size(); i++)
         {
            temp = C.EV(C.Numerator.f(f.get(i)));

            if (!temp.equals(C.C1))
            {
               result.add(temp);
            }
         }

         if (result.size() > 0)
         {
            return result;
         }

         return C.C1;
      }
      else
      {
         if (o instanceof HFunction && o.head().equals(C.Pow))
         {
            HFunction   f = (HFunction) o;

            if (f.size() != 2)
            {
               return f;
            }

            if (f.get(1) instanceof HSignedNumber)
            {
               if (((HSignedNumber) f.get(1)).isNegative())
               {
                  return C.C1;
               }
            }

            if (f.get(1) instanceof HFunction)
            {
               HFunction        exp = (HFunction) f.get(1);

               if (exp.size() > 0 && exp.head().equals(C.Multiply))
               {
                  if (exp.get(0) instanceof HSignedNumber)
                  {
                     if (((HSignedNumber) exp.get(0)).isNegative())
                     {
                        return C.C1;
                     }
                  }
               }
            }

            return f;
         }
      }

      return o;
   }

}


