package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.awt.*;

import com.hartmath.JSci.awt.*;

import java.applet.*;
import java.awt.*;

import java.awt.*;

public class EParametricPlot implements FunctionEvaluator {
    private LineGraph graph;
    private final int N=100;
    private Frame f;
    public EParametricPlot()
    {
    }
		public HObject evaluate(HFunction vect) {
      if ( vect.size() == 2 &&
           vect.get(0).isList() &&
           vect.get(1).isList() ) {
        HFunction fncts = (HFunction) vect.get(0);
        HFunction lst = (HFunction) vect.get(1);
        if ( fncts.size()==2 &&
             lst.size()==3) {
          HObject a = C.EV( C.N.f( lst.get(1) ) );
          HObject b = C.EV( C.N.f( lst.get(2) ) );
          if ((! (a instanceof HDouble)) || (! (b instanceof HDouble)) ) {
            return null;
          }
          double ad = ((HDouble)a).doubleValue();
          double bd = ((HDouble)b).doubleValue();
          if (bd <= ad) {
            return null;
          }
          double step = (bd-ad) / N;
          double x;
          double y;
          HUnaryNumerical hunx = new HUnaryNumerical(fncts.get(0), lst.get(0));
          HUnaryNumerical huny = new HUnaryNumerical(fncts.get(1), lst.get(0));

          f = new EFrame(true);
          float data[][]=new float[2][N+1];
          double t=ad;
          for(int i=0;i<N+1;i++) {
            x=hunx.map(t);
            y=huny.map(t);
            data[0][i]=(float)x;      
            data[1][i]=(float)y;      
            t+=step;
          }
          DefaultGraph2DModel model=new DefaultGraph2DModel();
          model.setXAxis(data[0]);
          model.addSeries(data[1]);
          graph=new LineGraph(model);
          graph.setNumbering(true);
          f.setLayout(new BorderLayout());
          f.add(graph,"Center");
          f.show();
        }
      } 
      return C.Null;
    }
}
