package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EPart implements FunctionEvaluator
{
   public EPart()
   {
   }
   /**
    * @param vect   function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 2)
      {
         if (vect.get(0) instanceof HFunction)
         {
            HFunction   fun = (HFunction) vect.get(0);
            HObject     temp = (HObject) vect.get(1);

            if (temp instanceof HInteger)
            {
               return getIndex(fun, (HInteger) temp);
            }

            if (temp.isList())
            {
               HFunction        lst = (HFunction) temp;
               HFunction        result = new HFunction(C.List);

               for (int i = 0; i < lst.size(); i++)
               {
                  HObject       tmp = (HObject) lst.get(i);

                  if (tmp instanceof HInteger)
                  {
                     HObject    ires = getIndex(fun, (HInteger) tmp);

                     if (ires == null)
                     {
                        return null;
                     }

                     result.add(ires);
                  }
                  else
                  {
                     result.add(new HFunction(C.Part, tmp));
                  }
               }

               return result;
            }
         }
      }

      return null;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param fun
    * @param hi
    * 
    * @return
    * 
    * @see
    */
   HObject getIndex(HFunction fun, HInteger hi)
   {
      if (hi.checkRange(1L, fun.size()))
      {
         int    indx = hi.intValue();

         return (HObject) fun.get(indx - 1);
      }

      StringBuffer      buf = new StringBuffer("index ");

      buf.append(hi.toString());
      buf.append(" out of range [1..");
      buf.append(new Integer(fun.size()).toString());
      buf.append("] in expression: ");
      buf.append(fun.toString());

      throw new HThrowException(C.OutOfRangeError, C.Part, 
                                new HString(buf.toString()));
   }

}