package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.awt.*;

import com.hartmath.JSci.awt.*;

import java.applet.*;
import java.awt.*;

import java.awt.*;

public class EPlot implements FunctionEvaluator {
    private LineGraph graph;
    private final int N=100;
    private Frame f;
    public EPlot()
    {
    }
		public HObject evaluate(HFunction vect) {
      if (vect.size() >= 2 &&
          vect.size() <= 3 &&
          vect.get(1).isList() ) {
        HFunction lst = (HFunction) vect.get(1);
        if (lst.size()==3) {
          HObject a = C.EV( C.N.f( lst.get(1) ) );
          HObject b = C.EV( C.N.f( lst.get(2) ) );
          if ((! (a instanceof HDouble)) || (! (b instanceof HDouble)) ) {
            return null;
          }
          double ad = ((HDouble)a).doubleValue();
          double bd = ((HDouble)b).doubleValue();
          if (bd <= ad) {
            return null;
          }
          double step = (bd-ad) / N;
          double y;
          double y0d = 0.0f;
          double y1d = 0.0f;

          HUnaryNumerical hun = new HUnaryNumerical(vect.get(0), lst.get(0));
          if (vect.size() == 3 &&
              vect.get(2).isList() ) {
            HFunction lsty = (HFunction) vect.get(2);
            if (lsty.size()==2) {
              HObject y0 = C.EV( C.N.f( lsty.get(0) ) );
              HObject y1 = C.EV( C.N.f( lsty.get(1) ) );
              if (y0 instanceof HDouble &&
                  y1 instanceof HDouble) {
                y0d = ((HDouble)y0).doubleValue();
                y1d = ((HDouble)y1).doubleValue();
              }
            }
          }

          f = new EFrame(true);
          float data[][]=new float[2][N+1];
          double x=ad;
          for(int i=0;i<N+1;i++) {
            y=hun.map(x);
            if (y0d != 0.0 || y1d != 0.0) {
              if (y>=y0d && y<=y1d) {
                data[0][i]=(float)x;
                data[1][i]=(float)y;
              }
              else {
                if (y<y0d) {
                  data[0][i]=(float)x;
                  data[1][i]=(float)y0d;
                }
                else {
                  data[0][i]=(float)x;
                  data[1][i]=(float)y1d;
                }
              }
            }
            else {
              data[0][i]=(float)x;
              data[1][i]=(float)y;
            }
            x+=step;
          }
          DefaultGraph2DModel model=new DefaultGraph2DModel();
          model.setXAxis(data[0]);
          model.addSeries(data[1]);
          graph=new LineGraph(model);
          if (y0d < y1d) {
            graph.setYExtrema((float)y0d,(float)y1d);
          }
          graph.setNumbering(true);
          f.setLayout(new BorderLayout());
          f.add(graph,"Center");
          f.show();
        }
      } 
      return C.Null;
    }
}

