package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.awt.*;

import com.hartmath.xfunctions.*;
import com.hartmath.xfunctions.graphs.*;

import java.applet.*;
import java.awt.*;
//import java.net.*;


import java.awt.*;

public class EPlot3DPanel implements FunctionEvaluator {
    public EPlot3DPanel()
    {
    }
    private Graph3DPanel graph;
    private CoordinateRect coords;
    private final int N=20;
    private Frame f;
		public HObject evaluate(HFunction vect) {
      if (vect.size()==3&&
          vect.get(1).isList() &&
          vect.get(2).isList() ) {
        HFunction lst1 = (HFunction) vect.get(1);
        HFunction lst2 = (HFunction) vect.get(2);
        if (lst1.size()==3 &&
            lst2.size()==3 ) {
          HObject a = C.EV( C.N.f( lst1.get(1) ) );
          HObject b = C.EV( C.N.f( lst1.get(2) ) );
          HObject c = C.EV( C.N.f( lst2.get(1) ) );
          HObject d = C.EV( C.N.f( lst2.get(2) ) );
          if ( (! (a instanceof HDouble)) ||
               (! (b instanceof HDouble)) ||
               (! (c instanceof HDouble)) ||
               (! (d instanceof HDouble)) ) {
            return null;
          }
          double ad = ((HDouble)a).doubleValue();
          double bd = ((HDouble)b).doubleValue();
          double cd = ((HDouble)c).doubleValue();
          double dd = ((HDouble)d).doubleValue();
          if (bd <= ad) {
            return null;
          }
          if (dd <= cd) {
            return null;
          }
          //double params[] = {ad, bd, cd, dd, -10.0, 10.0};
          f = new EFrame(true);
          graph = new Graph3DPanel(vect.get(0).toString(),
                                   lst1.get(0).toString(),
                                   lst2.get(0).toString(),
                                   ad,bd,cd,dd);
          /*
          coords = new CoordinateRect();
          graph.setCoords(coords);
          graph.setStyle(Graph3DPanel.HIDDEN_LINES_REMOVED);
          graph.setRotation(-25,20);
          graph.setLimits(params);
          graph.setExpression(vect.get(0));
          */
          f.setLayout(new BorderLayout());
          f.add(graph,"Center");
          f.show();
          return C.Null;
        }
      }
      f = new EFrame(true);
      graph = new Graph3DPanel("Sin(x^2*y^2)",
                               "x",
                               "y",
                               -2,2,-2,2);
      f.setLayout(new BorderLayout());
      f.add(graph,"Center");    
      f.show();
      return C.Null;
    }
  }

