package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EPowMod implements FunctionEvaluator
{
   public EPowMod()
   {
   }
   /**
    * Method Declaration.
    * @param vect
    * @return
    * @see
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 3 && vect.get(0) instanceof HInteger 
          && vect.get(1) instanceof HInteger 
          && vect.get(2) instanceof HInteger)
      {
         HInteger       i0 = (HInteger) vect.get(0);
         HInteger       i1 = (HInteger) vect.get(1);
         HInteger       i2 = (HInteger) vect.get(2);

         if (i2.isNegative())
         {
            return i0.modPow(i1, i2.negate());
         }

         return i0.modPow(i1, i2);
      }

      return null;
   }

}
