package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.io.*;
import java.net.*;

/**
 * Class Declaration.
 * 
 * 
 * @see
 * 
 * @author
 * @version   %I%, %G%
 */
public class EReadObject implements FunctionEvaluator
{
   public EReadObject()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      boolean showBytes = false;
      if ((vect.size() >= 1) &&
          (vect.size() <= 2) &&
          (vect.get(0) instanceof HString))
      {
         StringBuffer buf =  new StringBuffer();
         int count = 0;
         if (vect.size()==2 && vect.get(1).equals(C.True))
         {
           showBytes = true;
         }
         try
         {
            HSymbol.IOCounter = 0;

            HSymbol.IOOut.clear();
            HSymbol.IOIn.clear();

            URL                 url;
            DataInputStream     in;

            if (C.codeBase == null)
            {
               FileInputStream  fin = 
                  new FileInputStream(vect.get(0).toString());

               in = new DataInputStream(fin);
            }
            else
            {
               url = new URL(C.codeBase, vect.get(0).toString());

               // C.errorOut.append( url.toString() );

               in = new DataInputStream(url.openStream());
            }

            if (showBytes)
            {

              int len = in.available()/8;
              int res = in.available()%8;
              long s;
              s = in.readLong();
              buf.append("{"+new Long(s).toString()+"L");
              for (int i=0;i<len-1;i++)
              {
                s = in.readLong();
                buf.append(","+new Long(s).toString()+"L");
                if (count++ == 5)
                {
                  buf.append("\n");
                  count=0;
                }
              }
              byte b;
              buf.append("};\n{");
              for (int i=0;i<res;i++)
              {
                b = in.readByte();
                buf.append(new Byte(b).toString()+", ");
              }
              buf.append("};\n");
              C.resultOut.append(buf.toString());
            }
            else {
              HObject     obj = IOMapper.map(in);
              in.close();

              // C.errorOut.append( obj.toString() );

              return obj;
            }

         }
         catch (Exception e)
         {
            if (showBytes)
            {
              buf.append("};\n");
              C.resultOut.append(buf.toString());
            }
            else {
              C.errorOut.append(e.toString());
            }
            return null;
         }
      }

      return null;
   }

}

