package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class ERuleDelayed implements FunctionEvaluator, FunctionOpEvaluator
{
   public ERuleDelayed()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 2)
      {
         HObject        a0 = (HObject) vect.get(0);
         HObject        arg2 = (HObject) vect.get(1);

         if (a0 instanceof HSymbol)
         {
            return C.Rule.f(a0, arg2);
         }

         if (a0 instanceof HFunction)
         {
            HObject     result = ((HFunction) a0).evaluateArgAttr();

            if (result != null)
            {
               a0 = result;
            }

            return C.Rule.f(a0, arg2);
         }
      }

      return null;
   }

   /**
    * Method Declaration.
    *
    *
    * @param fun
    *
    * @return
    *
    * @see
    */
   public String toOpString(HFunction fun)
   {
      return E2Arg.operatorString(fun, ":>", 35);
   }

   /**
    * Method Declaration.
    *
    *
    * @return
    *
    * @see
    */
   public int precedence()
   {
      return 35;
   }

}

