/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/
package com.hartmath.patternmatching;

import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.lib.*;


public class ERuleEvaluator implements FunctionEvaluator
{
   int len;
   HRuleSet rset;
   public ERuleEvaluator(int length)
   {
     len = length;
     rset = null;
   }
   
   public HObject evaluate(HFunction fun)
   {
      if (fun.size() < len) {
        return null;
      }
      if (fun.size() > len)
      {
        for (int i=len;i<fun.size();i++) {
          if (! (fun.get(i) instanceof HFunction) )
          {
           return null;
          }
          HFunction f = (HFunction) fun.get(i);
          if (f.size() == 2 && (f.head() == C.Rule || f.head() == C.RuleDelayed))
          {
            rset = new HRuleSet(f.get(0).head());
            if (f.head() == C.Rule)
            {
              rset.putDownRule(HRule.RULE, f.get(0), f.get(1));
            }
            else
            {
              rset.putDownRule(HRule.RULEDELAYED, f.get(0), f.get(1));
            }
          }

        }
      }
      return evaluateOptions(new HFunction(fun,fun.head(),0,len,true));
   }
   public HObject evaluateOptions(HFunction fun)
   {
     return null;
   }

   public HObject getOption(HSymbol sym, HObject defaultValue)
   {
     HObject temp = rset.getDownRule(sym);
     return (temp==null)?defaultValue:temp;
   }

   public int getIntOption(HSymbol sym, HInteger defaultValue)
   {
     if (rset!=null)
     {
      HObject temp = rset.getDownRule(sym);
      if (temp!=null)
      {
       if (temp instanceof HInteger || temp instanceof HDouble)
       {
         if (temp instanceof HInteger)
         {
            return ((HInteger) temp).intValue();
         }
         return ((HDouble) temp).intValue();
       }
      }
     }
     return defaultValue.intValue();
   }
}


