package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;
import com.hartmath.awt.*;

import com.hartmath.JSci.awt.*;

import java.applet.*;
import java.awt.*;

import java.awt.*;

public class EScatterGraph implements FunctionEvaluator {
    private ScatterGraph graph;
    private Frame f;
    public EScatterGraph()
    {
    }
		public HObject evaluate(HFunction vect) {
      if (vect.size() == 2 &&
          vect.get(0).isList() &&
          vect.get(1).isList() ) {
        HFunction lst0 = (HFunction) vect.get(0);
        HFunction lst1 = (HFunction) vect.get(1);
        if (lst0.size()!=lst1.size()||lst0.size()==0)
        {
          return null;
        }
        float data[][]=new float[2][lst0.size()];
        HObject a;
        HObject b;
        for (int i=0;i<lst0.size();i++)
        {
          a = C.EV( C.N.f( lst0.get(i) ) );
          b = C.EV( C.N.f( lst1.get(i) ) );
          if ((! (a instanceof HDouble)) || (! (b instanceof HDouble)) ) {
            return null;
          }
          data[0][i]=((HDouble)a).floatValue();
          data[1][i]=((HDouble)b).floatValue();
        }
        f = new EFrame(true);
        DefaultGraph2DModel model=new DefaultGraph2DModel();  
        model.setXAxis(data[0]);
        model.addSeries(data[1]);  
        graph=new ScatterGraph(model);
        graph.setNumbering(true);  
        f.setLayout(new BorderLayout());
        f.add(graph,"Center");  
        f.show();
      }
      return C.Null;
    }
}
