package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

/**
 * @return the spur of a matrix
 */
public class ESpur extends E1Arg {
    public ESpur()
    {
    }
    /**
     * Method Declaration.
     * @param f
     * @return
     * @see
     */
    public HObject e1FunArg(HFunction mat) {
        int[] sz = mat.isMatrix();
        if (sz == null) {
            return null;
        }
        int len0 = sz[0];
        int len1 = sz[1];
        if (len1 < len0) {
            len0 = len1;
        }
        if (len0 <= 1) {
            if (len0 == 1) {
                return mat.get(0, 0);
            }
            return C.C0;
        }
        HFunction result = new HFunction(C.Add, len0);
        for (int i = 0; i < len0; i++) {
            result.set(i, mat.get(i, i));
        }
        return result;
    }
}

