package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class ESwitch implements FunctionEvaluator
{
   public ESwitch()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() >= 2)
      {
         HObject        result = C.EV(vect.get(0));
         HObject        temp;
         HRuleSet       rset;

         try
         {
            for (int i = 1; i < vect.size(); i += 2)
            {
               temp = C.EV(vect.get(i));          // ???

               if (temp.equals(result))
               {
                  if (i + 1 < vect.size())
                  {
                     return C.EV(vect.get(i + 1));
                  }
                  else
                  {
                     break;
                  }
               }

               if (temp instanceof HFunction)
               {
                  rset = new HRuleSet(temp.head());

                  rset.putDownRule(HRule.RULE, temp, C.Null);

                  if (rset.matchDownRule(result))
                  {
                     if (i + 1 < vect.size())
                     {
                        return C.EV(vect.get(i + 1));
                     }
                     else
                     {
                        break;
                     }
                  }
               }
            }
         }
         catch (HBreakException e) {}

         return C.Null;
      }

      return null;
   }

}