package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EThrow implements FunctionEvaluator
{
   public EThrow()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 1 && vect.get(0) instanceof HSymbol)
      {
         throw new HThrowException(C.Error, (HSymbol) vect.get(0));
      }

      if (vect.size() == 2 && vect.get(0) instanceof HSymbol 
          && vect.get(1) instanceof HSymbol)
      {
         throw new HThrowException((HSymbol) vect.get(0), 
                                   (HSymbol) vect.get(1));
      }

      if (vect.size() == 3 && vect.get(0) instanceof HSymbol 
          && vect.get(1) instanceof HSymbol)
      {
         throw new HThrowException((HSymbol) vect.get(0), 
                                   (HSymbol) vect.get(1), 
                                   vect.get(2));
      }

      if (vect.size() == 4 && vect.get(0) instanceof HSymbol 
          && vect.get(1) instanceof HSymbol)
      {
         throw new HThrowException((HSymbol) vect.get(0), 
                                   (HSymbol) vect.get(1), 
                                   vect.get(2), vect.get(3));
      }

      if (vect.size() == 5 && vect.get(0) instanceof HSymbol 
          && vect.get(1) instanceof HSymbol)
      {
         throw new HThrowException((HSymbol) vect.get(0), 
                                   (HSymbol) vect.get(1), 
                                   vect.get(2), vect.get(3), 
                                   vect.get(4));
      }

      return null;
   }

}
