package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

/**
 * Compute the transpose of a matrix
 * @see
 * @author
 * @version   %I%, %G%
 */
public class ETranspose extends E1Arg {
    public ETranspose()
    {
    }
    /**
     * Method Declaration.
     * @param f
     * @return
     * @see
     */
    public HObject e1FunArg(HFunction mat) {
        int[] sz = mat.isMatrix();
        if (sz != null) {
            final int len0 = sz[0];
            final int len1 = sz[1];
            if (sz[2] == -1) {
                // complex numeric
                HMatrix cm = new HMatrix(mat);
                ComplexMatrix csm = new ComplexMatrix(cm.toDoubleComplexMatrixArray());
                csm = (ComplexMatrix)csm.transpose();
                return csm.toFunction();
            }
            if (sz[2] == 1) {
                HMatrix dm = new HMatrix(mat);
                DoubleMatrix dsm = new DoubleMatrix(dm.toDoubleMatrixArray());
                dsm = (DoubleMatrix)dsm.transpose();
                return dsm.toFunction();
            }
            HFunction m = new HFunction(C.List, C.List, len1, len0, HFunction.MATRIXFORM);
            HFunction row;
            for (int i = 0; i < len0; i++) {
                row = (HFunction)mat.get(i);
                for (int j = 0; j < len1; j++) {
                    m.set(j, i, row.get(j));
                }
            }
            return m;
        }
        return null;
    }
}


