package com.hartmath.loadable;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

public class EVandermonde implements FunctionEvaluator {
  public EVandermonde()
  {
  } 
	/**
	 * vandermonde matrix, defined by Aij = vector[i]^(j-1).
	 */
	public HObject evaluate(HFunction f) {
		if (f.size() == 1 && f.get(0).isList()) {
			HFunction lst = (HFunction)f.get(0);
			int len0 = lst.size();


				HFunction	m = new HFunction(C.List, C.List, len0, len0,
														HFunction.MATRIXFORM);

				for (int i = 0; i < len0; i++) {
					for (int j = 0; j < len0; j++) {
						m.set(i, j, C.EV(C.Pow.f(lst.get(i), HInteger.valueOf(j))));
					}
				}

				return m;

		}

		return null;
	}

}

