package com.hartmath.loadable;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

public class EWhile implements FunctionEvaluator
{
   public EWhile()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 2)
      {
         while (C.EV(vect.get(0)) == C.True)
         {
            try
            {
               C.EV(vect.get(1));
            }
            catch (HBreakException e)
            {           // if no loop defined: same effect as Check
               return C.Null;
            }
            catch (HContinueException e)
            {           // if no loop defined: same effect as Check
               continue;
            }
         }
      }

      return C.Null;
   }

}
