/*--- formatted by Jindent 2.0b2, (www.c-lab.de/~jindent) ---*/

package com.hartmath.mapping;

import com.hartmath.expression.*;

/**
 * Interface that represents a function evaluation object.
 * FunctionEvaluator is used as an interface for built-in functions,
 * which are associated with a symbol.
 * 
 * @see HSymbol
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 * @version   %I%, %G%
 */
public interface FunctionEvaluator {

	/**
	 * Evaluate the given function if possible.
	 * 
	 * @param fun function, which should be evaluated
	 * @return <c>null</c> if the function could not be evaluated; the evaluated object otherwise
	 */
	public HObject evaluate(HFunction fun);
	
}



/*--- formatting done in "Sun Java Convention" style on 06-18-1999 ---*/
