/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.expression;

import com.hartmath.lib.*;

import org.kaffe.java.util.*;
import org.kaffe.java.lang.UnsupportedOperationException;

import java.util.Enumeration;
import java.lang.*;
import java.lang.reflect.Array;

public class HArrayList implements Cloneable {

	private static final int DEFAULT_CAPACITY = 4;
	protected HObject[] a;
	protected int len;

	    /*
	public HArrayList(Collection c) {
		final Iterator i = c.iterator();
		a = new HObject[c.size()];
		int count;
		for (count = 0; i.hasNext(); count++) {
		      a[count] = i.next();
		}
		len = count;
	} */
  //khartlage modification
  public HArrayList() {
		this(DEFAULT_CAPACITY, false);
	}
  public HArrayList(int initialCapacity, boolean setLength) {
  	if (C.DEBUG) {
		  if (initialCapacity < 0) {
		    throw new IllegalArgumentException("initialCapacity < 0");
		  }
  	}
    a = new HObject[initialCapacity];
    if (setLength) {
      len = initialCapacity;
    }
    else {
		  len = 0;
    } 
	}
	// Used by Arrays.asList()
	protected HArrayList(HObject[] a) {
		a = a;
		len = a.length;
	}

  public HArrayList(HArrayList c) {
    len = c.len;
		a = new HObject[len];
    System.arraycopy(c.a, 0, a, 0, len);
	}
  
	public void trimToSize() {
		if (len != a.length) {
			HObject[] newa = new HObject[len];
			System.arraycopy(a, 0, newa, 0, len);
			a = newa;
		}
	}

	public void ensureCapacity(int minCapacity) {

		// Check current capacity
		if (a.length >= minCapacity) {
			return;
		}

		// Round up desired capacity to nearest power of 2 (- 12) to
		// avoid n^2 behavior when adding one element at a time. The
		// -12 part should be optimized from empirical tests.
		int bit, newSize;
		for (bit = 0x10; bit != 0x80000000; bit <<= 1) {
			if (bit - 12 >= minCapacity) {
				break;
			}
		}
		if (bit == 0x80000000) {
			throw new IllegalArgumentException("too big");
		}
		newSize = bit - 12;

		// Allocate new array
		HObject[] newa = new HObject[newSize];
		System.arraycopy(a, 0, newa, 0, len);
		a = newa;
	}

	final public int size() {
		return len;
	}

	final public boolean isEmpty() {
		return len == 0;
	}

	final public boolean contains(HObject elem) {
		return indexOf(elem) != -1;
	}

	public int indexOf(HObject elem) {
		for (int i = 0; i < len; i++) {
			if (elem == null ? a[i] == null : elem.equals(a[i])) {
				return i;
			}
		}
		return -1;
	}

	public int lastIndexOf(HObject elem) {
		for (int i = len - 1; i >= 0; i--) {
			if (elem == null ? a[i] == null : elem.equals(a[i])) {
				return i;
			}
		}
		return -1;
	}

	public Object clone() {
    HArrayList clone;
    try {
			clone = (HArrayList)super.clone();
		} catch (CloneNotSupportedException e) {
			throw new Error();
		}
    clone.a = new HObject[len];
		System.arraycopy(a, 0, clone.a, 0, len);
		return clone;
	}

	public HObject[] toArray() {
		HObject[] newa = new HObject[len];
		System.arraycopy(a, 0, newa, 0, len);
		return newa;
	}

	public HObject[] toArray(HObject[] ary) {
		if (ary.length < len) {
			ary = (HObject[])Array.newInstance(
				ary.getClass().getComponentType(), len);
		}
		System.arraycopy(a, 0, ary, 0, len);
		if (ary.length > len) {
			ary[len] = null;
		}
		return ary;
	}

	final public HObject get(int index) {
		if (C.DEBUG) {
		  if (index < 0 || index >= len) {
			  throw new IndexOutOfBoundsException();
		  }
		}
		return a[index];
	}

  final public HObject get(int index0, int index1) {
		if (C.DEBUG) {
		  if (index0 < 0 || index0 >= len) {
			  throw new IndexOutOfBoundsException();
		  }
		}
		return ((HArrayList)a[index0]).a[index1];
	}

  final public HObject get(int index0, int index1, int index2) {
		if (C.DEBUG) {
		  if (index0 < 0 || index0 >= len) {
			  throw new IndexOutOfBoundsException();
		  }
		}
		return ((HArrayList)((HArrayList)a[index0]).a[index1]).a[index2];
	}
  
	final public HObject set(int index, HObject element) {
		if (C.DEBUG) {
		  if (index < 0 || index >= len) {
			  throw new IndexOutOfBoundsException();
		  }
		}
    HObject old = a[index];
		a[index] = element;
		return old;
	}

  final public HObject set(int index0, int index1, HObject element) {
		if (C.DEBUG) {
		  if (index0 < 0 || index0 >= len) {
			  throw new IndexOutOfBoundsException();
		  }
		}
    HObject old = ((HArrayList)a[index0]).a[index1];
		((HArrayList)a[index0]).a[index1] = element;
		return old;
	}

  final public HObject set(int index0, int index1, int index2, HObject element) {
		if (C.DEBUG) {
		  if (index0 < 0 || index0 >= len) {
			  throw new IndexOutOfBoundsException();
		  }
		}
    HObject old = ((HArrayList)((HArrayList)a[index0]).a[index1]).a[index2];
		((HArrayList)((HArrayList)a[index0]).a[index1]).a[index2] = element;
		return old;
	}
  
	final public void add(HObject element) {
		add(len, element);
//		return true;
	}

	public void add(int index, HObject element) {
		if (C.DEBUG) {
		  if (index < 0 || index > len) {
			  throw new IndexOutOfBoundsException();
		  }
		}
		ensureCapacity(len + 1);
		System.arraycopy(a, index,
			a, index + 1, len - index);
		a[index] = element;
		len++;
	}

	public HObject remove(int index) {
		HObject old = a[index];	// exception here is OK
		removeRange(index, index + 1);
		return old;
	}

	final public void clear() {
		len = 0;
	}
  /*
	public boolean addAll(Collection c) {
		addAll(len, c);
		return true;
	}

	public boolean addAll(int index, Collection c) {
		if (C.DEBUG) {
		  if (index < 0 || index > len) {
			  throw new IndexOutOfBoundsException();
		  }
		}
		final Iterator i = c.iterator();
		final int increase = c.size();
    if (increase==0)
    {
      return true;
    }
		ensureCapacity(len + increase);
		System.arraycopy(a, index,
			a, index + increase, len - index);

		for (int index2 = index; i.hasNext(); index2++) {
			a[index2] = i.next();
		}
		len += increase;
		return true;
	}
    */
	final public boolean addAll(HArrayList c) {
		return addAll(len, c);
	}

  public boolean addAll(int index, HArrayList c) {
		if (C.DEBUG) {
		  if (index < 0 || index > len) {
			  throw new IndexOutOfBoundsException();
		  }
		}
		final int increase = c.len;
    if (increase==0)
    {
      return true;
    }
 	  ensureCapacity(len + increase);
		System.arraycopy(a, index,
			a, index + increase, len - index);
		System.arraycopy(c.a, 0,
			a, index, increase);
		
		len += increase;
		return true;
	}

	protected void removeRange(int fromIndex, int toIndex) {
		if (C.DEBUG) {
		  if (fromIndex < 0 || toIndex > len) {
			  throw new IndexOutOfBoundsException();
		  }
		}
		final int decrease = toIndex - fromIndex;
		if (decrease <= 0) {
			return;
		}
		System.arraycopy(a, toIndex,
			a, fromIndex, len - toIndex);
		len -= decrease;
	}

  
  //public void put(int i, HObject obj) {
  //  set(i, obj);
  //}
  //public HObject at(int i) {
  //  return get(i);
  //}
  //public void pushBack(HObject obj) {
  //  add(obj);
  //}
  //public HObject popBack() {
  //  return remove(size()-1);
  //}
  public void sort()
   {

      // HLess test = new HLess();
      //Sorting.sort(this, new HLessThan());

      // return test.isEvaled();
      // a simple shakerSort:

     HObject s1, s2;
     boolean evaled = false;
     int  j, k, l, r;
     if (size() > 1) {
     l = 1;
     r = size() - 1;
     k = r;
     do {
     for(j=r;j>=l;j--) {
     s1 = get(j-1);
     s2 = get(j);
     if ( ((HObject)s2).less( (HObject)s1 ) ) {
     evaled = true;
     set(j-1, s2);
     set(j, s1);
     k = j;
     }
     }                        // for
     l = k + 1;
     for(j=l;j<=r;j++) {
     s1 = get(j-1);
     s2 = get(j);
     if ( ((HObject)s2).less( (HObject)s1 ) ) {
     evaled = true;
     set(j-1, s2);
     set(j, s1);
     k = j;
     }
     }                               // for
     r = k - 1;
     } while (l <= r);                 // do .. while
     }                                   // if
  //   return evaled;
   }
}