package com.hartmath.mapping;

import com.hartmath.expression.*;
import com.hartmath.lib.*;

//import com.objectspace.jgl.BinaryFunction;


public class HBinaryNumerical // implements BinaryFunction
{
    HObject   fun;
    HObject   variable1;
    HObject   variable2;
    public HBinaryNumerical(HObject fn, HObject v1, HObject v2) {
      variable1 = v1;
      variable2 = v2;
      fun  = fn;
    }

    public HBinaryNumerical(HObject fn, String ident1, String ident2)
    {
      variable1 = new HSymbol(ident1).addSymbol();
      variable2 = new HSymbol(ident2).addSymbol();
      fun  = fn;
    }

    public Object execute( Object first, Object second ) {
 	    return C.NEV( fun.substitute(variable1, (HObject)first).substitute(variable2, (HObject)second) );
    }

    /**
      * A user-defined function.
      */
    public double map(double x, double y) {
      Object temp = execute( new HDouble(x), new HDouble(y) );
      if (temp instanceof HDouble) {
        return ((HDouble)temp).doubleValue();
      }
      throw new HThrowException(C.ArithmeticError,
                                C.N, new HString("double value expected"));
    }
    /**
      * A user-defined complex function.
      */
    public HDoubleComplex map(HDoubleComplex z1, HDoubleComplex z2) {
      Object temp = execute( z1, z2 );
      if (temp instanceof HDoubleComplex) {
        return (HDoubleComplex)temp;
      }
      if (temp instanceof HDouble) {
        return new HDoubleComplex( (HDouble)temp );
      }
      throw new HThrowException(C.ArithmeticError,
                                C.N, new HString("numerical complex value expected"));
    }
	
}