package com.hartmath.lib;

import java.io.*;
import java.util.*;

/**
This class parses a subtree for files that match a pattern.
The pattern may contain one or more * and ? as usual.
The class delivers an enumerator for the files, or may be subclassed
to handle the files directly. The routines directory and file can
be used to return, if more scanning is necessary.
*/

public class HFileList
{	Vector V=new Vector();
	boolean Stop;
	public HFileList (String dir, String filter)
	{	Stop=false;
		char f[]=filter.toCharArray();
		File file=new File(dir);
		if (file.isDirectory()) find(file,f);
  }
	public HFileList (String dir)
	{	Stop=false;
		File file=new File(dir);
		if (file.isDirectory()) find(file,null);
	}
	void find (File dir, char filter[])
	{	if (!directory(dir)) return;
		String list[]=dir.list();
		for (int i=0; i<list.length; i++)
		{	File file=new File(dir,list[i]);
			if (file.isDirectory()) find(file,filter);
			else if (match(file.getName().toCharArray(),0,filter,0))
			{	Stop=!file(file);
				if (Stop) break;
				V.addElement(file);
			}
			if (Stop) break;
		}
		parsed(dir);
	}
	boolean match (char filename[], int n, char filter[], int m)
	{	if (filter==null) return true;
		if (m>=filter.length) return n>=filename.length;
		if (n>=filename.length) return m==filter.length-1 && filter[m]=='*';
		if (filter[m]=='?')
		{	return match(filename,n+1,filter,m+1);
		}
		if (filter[m]=='*')
		{	if (m==filter.length-1) return true;
			for (int i=n; i<filename.length; i++)
			{	if (match(filename,i,filter,m+1)) return true;
			}
			return false;
		}
		if (filter[m]==filename[n])	return match(filename,n+1,filter,m+1);
		return false;
	}
	public Enumeration files ()
	{	return V.elements();
	}
	/**
	@param file The directory that has been found.
	@return false if recursion should stop here.
	(i.e. that directory needs not be parsed).
	*/
	public boolean directory (File dir)
	{	return true;
	}
	/**
	@param file The file that has been found.
	@return false if you need no more file at all.
	*/
	public boolean file (File file)
	{	return true;
	}
	/**
	@param parsed The directory that has been parsed.
	*/
	public void parsed (File dir)
	{
	}
}

