/*--- formatted by Jindent 2.0b2, (www.c-lab.de/~jindent) ---*/

package com.hartmath.lib;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.patternmatching.*;


import java.lang.*;
import java.util.Enumeration;

/**
 * Class Declaration.
 * 
 * 
 * @see
 * 
 * @author
 * @version   %I%, %G%
 */
public class HIterator implements Enumeration {
	HObject			count;
  boolean illegalIterator;
	final HObject  maxCount;
	final HObject  step;
	final HSymbol  variable;

	/**
	 * Class Constructor.
	 * 
	 * 
	 * @param lst
	 * 
	 * @see
	 */
	public HIterator(HFunction lst) {
    illegalIterator = false;
		switch (lst.size()) {

		case 1: 
			count = C.C1;
			maxCount = C.EV(lst.get(0));
			step = C.C1;
			variable = null;

			break;

		case 2: 
			count = C.C1;
			maxCount = C.EV(lst.get(1));
			step = C.C1;

			if (lst.get(0) instanceof HSymbol) {
				variable = (HSymbol) lst.get(0);

				variable.putDownRule(HRule.SET, variable, count);
			} else {
				variable = null;
			}

			break;

		case 3: 
			count = C.EV(lst.get(1));
			maxCount = C.EV(lst.get(2));
			step = C.C1;

			if (C.EV(new HFunction(C.LessEqual, count, maxCount)) != C.True) {
				illegalIterator = true;
			}
			if (lst.get(0) instanceof HSymbol) {
				variable = (HSymbol) lst.get(0);

				variable.putDownRule(HRule.SET, variable, count);
			} else {
				variable = null;
			}

			break;

		case 4: 
			count = C.EV(lst.get(1));
			maxCount = C.EV(lst.get(2));
			step = C.EV(lst.get(3));
      if (!(step instanceof HSignedNumber)) {
        illegalIterator = true;
      }
      if ( ((HSignedNumber) step).isNegative() ) {
        if ((C.EV(new HFunction(C.Less, maxCount, count)) != C.True)) {
          illegalIterator = true;
			  }
      }
      else {
        if ((C.EV(new HFunction(C.LessEqual, count, maxCount)) != C.True)) {
          illegalIterator = true;
			  }
      }
			if (lst.get(0) instanceof HSymbol) {
				variable = (HSymbol) lst.get(0);

				variable.putDownRule(HRule.SET, variable, count);
			} else {
				variable = null;
			}

			break;

		default: 
			maxCount = null;
			step = null;
			variable = null;

		// throw new NoIteratorException();

		}
			//{{INIT_CONTROLS
		//}}
}

	/**
	 * Tests if this enumeration contains more elements.
	 * 
	 * @return  <code>true</code> if this enumeration contains more elements;
	 * <code>false</code> otherwise.
	 */
	public boolean hasMoreElements() {
		if ( (maxCount == null) ||
         (illegalIterator) ) {
			return false;
		}
		if (C.EV(new HFunction(C.LessEqual, count, maxCount)) == C.True) {
			return true;
		}

		return false;
	}

	/**
	 * Returns the next element of this enumeration.
	 * 
	 * @return     the next element of this enumeration.
	 * @exception  returns no exception; hasMoreElements() must be called before this method!
	 */
	public Object nextElement() {
    count = C.EV(new HFunction(C.Add, count, step));
    if (variable != null) {
      variable.putDownRule(HRule.SET, variable, count);
    }
		return count;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @see
	 */
	public void clearVariable() {
		if (variable != null) {
			variable.clearSymbolRule(variable);
		}
	}

	//{{DECLARE_CONTROLS
	//}}
}



/*--- formatting done in "Sun Java Convention" style on 06-27-1999 ---*/
