/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/
package com.hartmath.awt;

import com.hartmath.*;
import com.hartmath.expression.*;
import com.hartmath.initial.*;
import com.hartmath.util.*;
import com.hartmath.lib.*;
import com.hartmath.awt.*;

import java.lang.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

// import java.awt.datatransfer.*;

// import java.awt.event.*;
import java.applet.Applet;

/**
 * HMApplet - implements the graphical user interface
 * 
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class HMApplet extends Applet
{
   public static boolean       isStandalone = false;
   public TextArea             edit1;
   public OutputTextArea       edit2;
   
   /**
    * Returns the value of the named parameter in the HTML tag.
    */
   public String getParameter(String key, String def)
   {
      return isStandalone ? System.getProperty(key, def) 
             : (getParameter(key) != null ? getParameter(key) : def);
   }

   /**
    * Returns information about this applet.
    * 
    * @return  a string containing information about the version
    */
   public String getAppletInfo()
   {
      return "HartMath v0.6 alpha";
   }

   protected static String        main_args[];

   // class Variables
   protected Choice               choiceClass;
   protected Choice               choiceVariable;
   protected Choice               choiceConstant;
   protected Choice               choiceFunction;
   // public static int    xSize = 0;
   // public static int    ySize = 0;
   protected final static int     maxClassItems = 4;
   protected String               classItems[] =
   {
      "Chemistry", "Conversion",
      "Fourier", "MathML"
   };
   protected final static int     maxVariableItems = 26;
   protected String               variableItems[] =
   {
      "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n",
      "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"
   };
   protected final static int     maxConstantItems = 18;
   protected String               constantItems[] =
   {
      "Catalan", "Constant", "Degree", "E", "EulerGamma", "False", "Flat",
      "HoldAll", "HoldFirst", "HoldRest",
      "I", "Infinity", "Listable", "Null", "OneIdentity", "Orderless", "Pi",
      "True"
   };
   protected Button               btn0, btn1, btn2, btn3, btn4,
                                  btn5, btn6, btn7, btn8, btn9;
   protected Button               btnAdd, btnSubtract, btnComma, btnPow,
                                  btnBraOpen, btnBraClose;
   protected Button               btnLstOpen, btnLstClose;
   protected Button               btnPartOpen, btnPartClose;
   protected Button               btnDot, btnSet, btnSetDelayed;
   protected Button               btnMultiply, btnDivide;
   protected Button               btnEQ, btnNE, btnLE, btnGE, btnLT, btnGT;
   protected Button               btnEval, btnCE;

   /**
    * Method Declaration.
    * 
    * 
    * @param c
    * @param gbl
    * @param gbc
    * @param x
    * @param y
    * @param w
    * @param h
    * 
    * @see
    */
   public void add(Component c, GridBagLayout gbl, GridBagConstraints gbc, 
                    int x, int y, int w, int h)
   {
      gbc.gridx = x;
      gbc.gridy = y;
      gbc.gridwidth = w;
      gbc.gridheight = h;

      gbl.setConstraints(c, gbc);
      add(c);
   }

   /**
    * Method declaration
    *
    *
    * @return
    * 
    * @see
    */
   public boolean eval()
   {
      if (C.initialized == false)
      {
         return false;
      }             /*
      StringEvaluator se = new StringEvaluator(edit1.getText(), edit2);
      se.evaluate();  */
      C.count++;

      C.InArray.add(C.Null);
      C.OutArray.add(C.Null);

      try
      {
         Scanner        scan = new Scanner(edit1.getText());
         HObject        obj = scan.start();

         C.recursionLimit = ((HSignedNumber) C.EV(C.RecursionLimit)).intValue();
         C.iterationLimit = ((HSignedNumber) C.EV(C.IterationLimit)).intValue();
         C.InArray.set(C.count - 1, obj);
         edit2.append("In[" + java.lang.Integer.toString(C.count, 10)
                      + "]:\n");

         if (obj != null)
         {
            edit2.appendLine(obj.toString());
         }

         C.numericFlag = false;
         C.initLimits();

         HObject        res = C.EV(obj);

         C.OutArray.set(C.count - 1, res);
         edit2.append("Out[" + java.lang.Integer.toString(C.count, 10)
                      + "]:\n");
         edit2.appendLine(res.toString());

      }
      catch (SyntaxError se)
      {
         edit2.appendLine("Syntax Error: " + se.getMessage());

         if (C.DEBUG)
         {
            se.printStackTrace();
         }
      }
      catch (HBreakException se)
      {
         edit2.appendLine("Break() occured outside For, While, Switch");

         if (C.DEBUG)
         {
            se.printStackTrace();
         }
      }
      catch (HContinueException se)
      {
         edit2.appendLine("Continue() occured outside For, While");

         if (C.DEBUG)
         {
            se.printStackTrace();
         }
      }
      catch (HReturnException se)
      {
         edit2.appendLine("Return() occured");

         if (C.DEBUG)
         {
            se.printStackTrace();
         }
      }
      catch (HThrowException se)
      {
         edit2.appendLine("Throw::" + se.why().toString());

         if (C.DEBUG)
         {
            se.printStackTrace();
         }
      }
      catch (Throwable se)
      {
         edit2.appendLine("Unknown Exception occured: " + se.getMessage());

         if (C.DEBUG)
         {
            se.printStackTrace();
         }
      }
                 
      return true;
   }

   /**
    * Method declaration
    *
    *
    * @param evt
    * @param key
    *
    * @return
    *
    * @see
    */
   public boolean keyDown(Event evt, int key)
   {
      if (key == Event.ENTER && (evt.modifiers & Event.SHIFT_MASK) != 0)
      {
         return eval();
      }

      return false;
   }
   
   /**
    * event-handling for this applet
    */
   public boolean action(Event evt, Object arg)
   {
      if (evt.target.equals(btnEval))
      {
        return eval();
      }

      if (evt.target.equals(btnCE))
      {
         edit1.setText("");

         return true;
      }

      if (evt.target.equals(choiceClass))
      {
         if (!((Choice) evt.target).getSelectedItem().equals("<Classes>"))
         {
           new ELoadClassLibrary().loadClass("com.hartmath.classes."+ ((Choice) evt.target).getSelectedItem() );
         }

         return true;
      }

      if (evt.target.equals(choiceFunction))
      {
         if (!((Choice) evt.target).getSelectedItem().equals("<Functions>"))
         {
            edit1.append(((Choice) evt.target).getSelectedItem() + "(");
         }

         return true;
      }

      if (evt.target.equals(choiceConstant))
      {
         if (!((Choice) evt.target).getSelectedItem().equals("<Constants>"))
         {
            edit1.append(((Choice) evt.target).getSelectedItem());
         }

         return true;
      }

      if (evt.target.equals(choiceVariable))
      {
         if (!((Choice) evt.target).getSelectedItem().equals("<Variables>"))
         {
            edit1.append(((Choice) evt.target).getSelectedItem());
         }

         return true;
      }

      edit1.append(((Button) evt.target).getLabel());

      return true;
   }

   public void initHartMath()
   {
      C.init();

      C.resultOut = edit2;
      C.errorOut = edit2;
     // C.traceOut = edit2;
      C.statusOut = edit2;

      C.resultOut.append(C.version + " Build ");
      C.resultOut.append(new Integer(C.BUILD).toString());

      if (C.DEBUG)
      {
         C.resultOut.append(" Debug active");
      }

      C.resultOut.append("\nKey-Accelerators:\n" 
                         + "  Shift+ENTER for <Evaluate>\n"
                         + "  **          for <^> [Pow-operator]\n");
      if (!C.initialized)
      {
        new M().evaluate(null);
        new L().evaluate(null);
        new Programming().evaluate(null);
        //  new ELoadClassLibrary().loadClass("com.hartmath.initial.M");
        //  new ELoadClassLibrary().loadClass("com.hartmath.initial.L");
        //  new ELoadClassLibrary().loadClass("com.hartmath.initial.Programming");
        // load initial rules:
        try {
           //   C.EV(C.ReadObject.f(new HString("init.hm")));
          C.EV( InitRules.init(InitRules.larr, InitRules.barr) );
        }
        catch(Throwable t) {
          C.resultOut.appendLine("File init.hm incosistent;Exception occured: " + t.getMessage());
          if (C.DEBUG) {
            t.printStackTrace();
          }
        }
       // for (int i=0;i<C.hierStat.length;i++)
       // {
       //   if (C.hierStat[i]>10) {
       //     C.resultOut.appendLine(new Integer(i).toString()+"->"+new Integer(C.hierStat[i]).toString());
       //   }
       // }
        HSymbol.sortFunctions();

        if (choiceFunction != null)
        {
           for (int i = 0; i < HSymbol.maxItems; i++)
           {
              choiceFunction.addItem(HSymbol.choiceItems[i]);
           }
        }
      }
      C.initialized = true;
   }
}       // end class Hartmath
