/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath;

import com.hartmath.util.*;
import com.hartmath.lib.*;
import com.hartmath.expression.*;
import com.hartmath.initial.*;

import java.lang.*;
import java.awt.*;
import java.net.*;

/**
 * Evaluates a given input string
 * 
 * @author Klaus Hartlage (khartlage@t-online.de)
 */
public class HMInitThread extends ContextThread
{
   boolean              isStandalone;
   ResultOutput         edit2;
   Choice               choiceFunction;

   /**
    * Constructor declaration
    *
    *
    * @param edi1
    * @param edi2
    * @param choice
    *
    * @see
    */
   public HMInitThread(boolean standAlone,OutputTextArea edi2, Choice choice)
   {
     isStandalone = standAlone;
     edit2 = edi2;
     choiceFunction = choice;
   }

   /**
    * Method Declaration.
    *
    * 
    * @see
    */
   public void run()
   {
      C.init();

      C.resultOut = edit2;
      C.errorOut = edit2;
     // C.traceOut = edit2;
      C.statusOut = edit2;

      C.resultOut.append(C.version + " Build ");
      C.resultOut.append(new Integer(C.BUILD).toString());

      if (C.DEBUG)
      {
         C.resultOut.append(" Debug active");
      }

      C.resultOut.append("\nKey-Accelerators:\n" 
                         + "  Shift+ENTER for <Evaluate>\n" 
                         + "  **          for <^> [Pow-operator]\n");
      new M().evaluate(null);
      new L().evaluate(null);
      new Programming().evaluate(null);
      //  new ELoadClassLibrary().loadClass("com.hartmath.initial.M");
      //  new ELoadClassLibrary().loadClass("com.hartmath.initial.L");
      //  new ELoadClassLibrary().loadClass("com.hartmath.initial.Programming");
      // load initial rules:
        try {
         //   C.EV(C.ReadObject.f(new HString("init.hm")));
            C.EV( InitRules.init(InitRules.larr, InitRules.barr) );
        }
        catch(Throwable t) {
            C.resultOut.appendLine("File init.hm incosistent;Exception occured: " + t.getMessage());
            if (C.DEBUG) {
                t.printStackTrace();
            }
        }

      HSymbol.sortFunctions();

      if (choiceFunction != null)
      {
         for (int i = 0; i < HSymbol.maxItems; i++)
         {
            choiceFunction.addItem(HSymbol.choiceItems[i]);
         }
      }

      C.initialized = true;
   }

}


