/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

import com.hartmath.*;
import com.hartmath.util.*;
import com.hartmath.lib.*;
import com.hartmath.awt.*;
import com.hartmath.expression.*;

import java.lang.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

/**
 * HartMath applet class - implements the graphical user interface
 * 
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class HMPsionApplet extends HMApplet
{
   public int           xSize = 0;
   public int           ySize = 0;
   /**
    * Method Declaration.
    * 
    * 
    * @see
    */
   public void init()
   {
      if (C.initialized)
      {
        return;
      }
      try
      {
         C.codeBase = getDocumentBase();
      }
      catch (Exception e) {}

      boolean   vga = false;
      boolean   revo = false;

      Dimension d = getSize();

      if (ySize == 0)
      {
         xSize = d.width;
         ySize = d.height;
      }

      vga = (ySize >= 480);
      revo = (ySize <= 160);

      int       vgaFactor = 1;
      int       vgaSum = 0;

      if (vga)
      {
         vgaFactor = 3;
         vgaSum = 1;
      }

      if (revo)
      {
         vgaSum = -1;
      }

      GridBagLayout     gbl = new GridBagLayout();      // 12 x 14

      setLayout(gbl);

      if (revo)
      {
         setFont(new Font("Courier", Font.PLAIN, 10));
      }
      else
      {
         setFont(new Font("Courier", Font.PLAIN, 11));
      }

      GridBagConstraints        gbc = new GridBagConstraints();

      gbc.fill = GridBagConstraints.NONE;
      gbc.anchor = GridBagConstraints.CENTER;
      gbc.fill = GridBagConstraints.BOTH;
      gbc.weightx = 300;        // 20;
      gbc.weighty = 100;        // 100;
      edit1 = new TextArea("", 2 + vgaSum, 40, 
                           TextArea.SCROLLBARS_VERTICAL_ONLY);

      add(edit1, gbl, gbc, 0, 0, 12, 2 + vgaSum);

      edit2 = new OutputTextArea("", 6 * vgaFactor, 40, 
                                 TextArea.SCROLLBARS_VERTICAL_ONLY);

      add(edit2, gbl, gbc, 0, 7 + vgaSum, 12, 6 * vgaFactor);

      btn0 = new Button("0");

      add(btn0, gbl, gbc, 0, 6 + vgaSum, 2, 1);

      btnDot = new Button(".");

      add(btnDot, gbl, gbc, 2, 6 + vgaSum, 1, 1);

      btnAdd = new Button("+");

      add(btnAdd, gbl, gbc, 3, 6 + vgaSum, 1, 1);

      btnComma = new Button(",");

      add(btnComma, gbl, gbc, 4, 6 + vgaSum, 1, 1);

      btn1 = new Button("1");

      add(btn1, gbl, gbc, 0, 5 + vgaSum, 1, 1);

      btn2 = new Button("2");

      add(btn2, gbl, gbc, 1, 5 + vgaSum, 1, 1);

      btn3 = new Button("3");

      add(btn3, gbl, gbc, 2, 5 + vgaSum, 1, 1);

      btnSubtract = new Button("-");

      add(btnSubtract, gbl, gbc, 3, 5 + vgaSum, 1, 1);

      btnPartOpen = new Button("[");

      add(btnPartOpen, gbl, gbc, 4, 5 + vgaSum, 1, 1);

      btn4 = new Button("4");

      add(btn4, gbl, gbc, 0, 4 + vgaSum, 1, 1);

      btn5 = new Button("5");

      add(btn5, gbl, gbc, 1, 4 + vgaSum, 1, 1);

      btn6 = new Button("6");

      add(btn6, gbl, gbc, 2, 4 + vgaSum, 1, 1);

      btnMultiply = new Button("*");

      add(btnMultiply, gbl, gbc, 3, 4 + vgaSum, 1, 1);

      btn7 = new Button("7");

      add(btn7, gbl, gbc, 0, 3 + vgaSum, 1, 1);

      btn8 = new Button("8");

      add(btn8, gbl, gbc, 1, 3 + vgaSum, 1, 1);

      btn9 = new Button("9");

      add(btn9, gbl, gbc, 2, 3 + vgaSum, 1, 1);

      btnDivide = new Button("/");

      add(btnDivide, gbl, gbc, 3, 3 + vgaSum, 1, 1);

      btnBraOpen = new Button("(");

      add(btnBraOpen, gbl, gbc, 4, 3 + vgaSum, 1, 1);

      btnBraClose = new Button(")");

      add(btnBraClose, gbl, gbc, 5, 3 + vgaSum, 1, 1);

      btnLstOpen = new Button("{");

      add(btnLstOpen, gbl, gbc, 4, 4 + vgaSum, 1, 1);

      btnLstClose = new Button("}");

      add(btnLstClose, gbl, gbc, 5, 4 + vgaSum, 1, 1);

      btnPartClose = new Button("]");

      add(btnPartClose, gbl, gbc, 5, 5 + vgaSum, 1, 1);

      btnPow = new Button("^");

      add(btnPow, gbl, gbc, 5, 6 + vgaSum, 1, 1);
      add(new Button("%"), gbl, gbc, 6, 3 + vgaSum, 1, 1);
      add(new Button("_"), gbl, gbc, 6, 4 + vgaSum, 1, 1);
      add(new Button("->"), gbl, gbc, 6, 5 + vgaSum, 1, 1);
      add(new Button(":>"), gbl, gbc, 6, 6 + vgaSum, 1, 1);
      add(new Button("^="), gbl, gbc, 7, 3 + vgaSum, 1, 1);
      add(new Button("^:="), gbl, gbc, 7, 4 + vgaSum, 1, 1);
      add(new Button("="), gbl, gbc, 7, 5 + vgaSum, 1, 1);
      add(new Button(":="), gbl, gbc, 7, 6 + vgaSum, 1, 1);

      add(new Button("+="), gbl, gbc, 10, 3 + vgaSum, 1, 1);
      add(new Button("-="), gbl, gbc, 10, 4 + vgaSum, 1, 1);
      add(new Button("*="), gbl, gbc, 10, 5 + vgaSum, 1, 1);
      add(new Button("/="), gbl, gbc, 10, 6 + vgaSum, 1, 1);

      btnCE = new Button("CE");

      add(btnCE, gbl, gbc, 11, 3 + vgaSum, 1, 1);
      add(new Button("!"), gbl, gbc, 11, 4 + vgaSum, 1, 1);
      add(new Button("#"), gbl, gbc, 11, 5 + vgaSum, 1, 1);
      add(new Button("&"), gbl, gbc, 11, 6 + vgaSum, 1, 1);

      btnEQ = new Button("==");

      add(btnEQ, gbl, gbc, 8, 3 + vgaSum, 1, 1);

      btnNE = new Button("!=");

      add(btnNE, gbl, gbc, 9, 3 + vgaSum, 1, 1);

      btnLE = new Button("<=");

      add(btnLE, gbl, gbc, 8, 4 + vgaSum, 1, 1);

      btnGE = new Button(">=");

      add(btnGE, gbl, gbc, 9, 4 + vgaSum, 1, 1);

      btnLT = new Button("<");

      add(btnLT, gbl, gbc, 8, 5 + vgaSum, 1, 1);

      btnGT = new Button(">");

      add(btnGT, gbl, gbc, 9, 5 + vgaSum, 1, 1);

      btnEval = new Button("Evaluate");

      add(btnEval, gbl, gbc, 8, 6 + vgaSum, 2, 1);

      if (!revo)
      {
         gbc.fill = GridBagConstraints.HORIZONTAL;
         choiceClass = new Choice();

         add(choiceClass, gbl, gbc, 0, 2 + vgaSum, 3, 1);
         choiceClass.addItem("<Classes>");

         for (int i = 0; i < maxClassItems; i++)
         {
            choiceClass.addItem(classItems[i]);
         }

         choiceVariable = new Choice();

         add(choiceVariable, gbl, gbc, 3, 2 + vgaSum, 3, 1);
         choiceVariable.addItem("<Variables>");

         for (int i = 0; i < maxVariableItems; i++)
         {
            choiceVariable.addItem(variableItems[i]);
         }

         choiceConstant = new Choice();

         add(choiceConstant, gbl, gbc, 6, 2 + vgaSum, 3, 1);
         choiceConstant.addItem("<Constants>");

         for (int i = 0; i < maxConstantItems; i++)
         {
            choiceConstant.addItem(constantItems[i]);
         }

         choiceFunction = new Choice();

         add(choiceFunction, gbl, gbc, 9, 2 + vgaSum, 3, 1);
         choiceFunction.addItem("<Functions>");
      }
      initHartMath();

 //     HMInitThread      thread = new HMInitThread(isStandalone, edit2,
 //                                                 choiceFunction);
 //
 //     thread.start();
   }    // end init()

}       



