/*--- formatted by Jindent 2.0b2, (www.c-lab.de/~jindent) ---*/
package com.hartmath.expression;

import java.lang.*;

/**
 * Interface that represents a number (e.g. HDouble, HInteger, HFraction, HComplex)
 * 
 * 
 * @see HDouble
 * @see HDoubleComplex
 * @see HInteger
 * @see HFraction
 * @see HComplex
 * @see HRational
 * @see HSignedNumber
 * 
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public interface HNumber {

	/**
	 * 0  for this == 0;
	 * +1 for re(this) > 0 or ( re(this)==0 and im(this)>0 );
	 * -1 for re(this) < 0 or ( re(this)==0 and im(this)<0 );
	 */
	abstract public int compSignum();

	/**
	 * Returns the absolute value.
	 * If the argument is not negative, the argument is returned.
	 * If the argument is negative, the negation of the argument is returned.
	 * 
	 * @return  the absolute value of the object.
	 */
	abstract public HObject abs();

  /**
	 * returns the conjugate complex of a number
	 */
	abstract public HObject conjugate();

	/**
	 * returns the real part of a number
	 */
	abstract public HObject re();

	/**
	 * returns the imaginary part of a number
	 */
	abstract public HObject im();

  abstract public boolean isZero();

}



/*--- formatting done in "Sun Java Convention" style on 07-01-1999 ---*/

