package com.hartmath.mapping;

import com.hartmath.lib.*;
import com.hartmath.expression.*;

public class HUnaryNumerical 
{
    HObject   fun;
   // HFunction rule;
    HObject   variable;
    public HUnaryNumerical(HObject fn, HObject v) {
     // rule = C.Rule.f(v, null);
      variable = v;
      fun  = fn;
    }

    public HUnaryNumerical(HObject fn, String ident)
    {
      variable = new HSymbol(ident).addSymbol();
      fun  = fn;
    }
    public Object execute( Object first ) {
    //  rule.put(1, first);
 	    return C.NEV( fun.substitute(variable, (HObject)first) );
    }

    /**
      * A user-defined function.
      */
    public double map(double x) {
      Object temp = execute( new HDouble(x) );
      if (temp instanceof HDouble) {
        return ((HDouble)temp).doubleValue();
      }
      throw new HThrowException(C.ArithmeticError,
                                C.N, new HString("double value expected"));
    }
    /**
      * A user-defined complex function.
      */
    public HDoubleComplex map(HDoubleComplex z) {
      Object temp = execute( z );
      if (temp instanceof HDoubleComplex) {
        return (HDoubleComplex)temp;
      }
      if (temp instanceof HDouble) {
        return new HDoubleComplex( (HDouble)temp );
      }
      throw new HThrowException(C.ArithmeticError,
                                C.N, new HString("numerical complex value expected"));
    }
	//{{DECLARE_CONTROLS
	//}}
}