package com.hartmath.combinatoric;

import com.hartmath.expression.*;
import com.hartmath.lib.*;

import java.util.*;

public class KPermutations {

  final int n;
  final int k;
  //HFunction f;
  boolean first;
  int h, i, m;
  int x[];
  int y[];
  public KPermutations(int[] data, int parts)
  {
    n = data.length;
    k = parts;
    //f = fun;
    x = new int[n];
    y = new int[n];
    for (int a=0;a<n;a++)
    {
      x[a] = data[a];
      y[a] = a;
    }
    if (k==n)
    {
      m = k - 1;
    }
    else
    {
      m = k;
    }
    first = true;
    i = m-1;
  }
  public KPermutations(HFunction fun, int parts)
  {
    n = fun.size();
    k = parts;
    //f = fun;
    x = new int[n];
    y = new int[n];
    x[0]=0;
    y[0]=0;
    for (int a=1;a<n;a++)
    {
      if (fun.get(a).equals(fun.get(a-1))) {
        x[a]=x[a-1];
      }
      else {
        x[a] = a;
      }
      y[a] = a;
    }
    if (k==n)
    {
      m = k - 1;
    }
    else
    {
      m = k;
    }
    first = true;
    i = m-1;
  }

  public Object nextElement()
  {
    if (first)
    {
      first = false;
      return x;
    }
    do {
      if ( y[i]<(n-1) )
      {
        y[i] = y[i]+1;
        if (x[i]!=x[y[i]])    // check fixpoint
        {
          h = x[i]; x[i] = x[y[i]]; x[y[i]] = h;
          i=m-1;
          return x;
        }
        continue;
      }
      do {
        h = x[i]; x[i] = x[y[i]]; x[y[i]] = h;
        y[i] = y[i]-1;
      }
      while (y[i]>i);
      i--;
    }
    while (i!=-1);
    return null;
  }
                   /*
  public static void main(String arg[]) throws Exception
   {

      HSymbol a = new HSymbol("a");
      HSymbol b = new HSymbol("b");
      HSymbol c = new HSymbol("b");
      HSymbol d = new HSymbol("d");
      HFunction f = C.List.f(a,b,c);
      f.add(d);
      int len = f.size();
      try {
        KPermutations comb = new KPermutations(f, 4);
        int j[];
        while( (j = (int[])comb.nextElement()) != null)
        {
            for (int k=0; k<4; k++) {
              System.out.print(f.get(j[k]));
       //       System.out.print(Integer.toString(j[k]));
            }
          System.out.print(" ");
        }
      }
      catch (Throwable se)
      {
        se.printStackTrace();
      }
      System.in.read();
      System.exit(0);
   }                 */
}
