package com.hartmath.combinatoric;

import com.hartmath.expression.*;
import com.hartmath.lib.*;

import java.util.*;

public class KSubsets {

  final int n;
  final int k;
  long bin;
  //HFunction f;
  boolean first;
  //int h, i, m;
  int x[];
  public KSubsets(int len, int parts)
  {
    n = len;
    k = parts;
    //f = fun;
    x = new int[n];
    for (int a=0;a<n;a++)
    {
      x[a] = a;
    }
    bin = binomial(n, k);
    first = true;
  }
  public static long binomial(long n, long k)
  {
    long bin = 1;
    if ( k > (n/2) )
    {
      k = n - k;
    }
    for (long i=1;i<=k;i++) {
      bin = (bin * (n-i+1)) / i;
    }
    return bin;
  }
  public Object nextElement()
  {
    if (bin-- == 0)
    {
      return null;
    }
    if (first)
    {
      first = false;
      return x;
    }
    int i = k-1;
    while (x[i]==n-k+i)
    {
      i--;
    }
    x[i] = x[i] + 1;
    for (int j=i+1;j<n;j++)
    {
      x[j] = x[j-1] + 1;
    }
    return x;
  }
             /*
  public static void main(String arg[]) throws Exception
   {

      HSymbol a = new HSymbol("a");
      HSymbol b = new HSymbol("b");
      HSymbol c = new HSymbol("b");
      HSymbol d = new HSymbol("d");
      HFunction f = C.List.f(a,b,c);
      f.add(d);
      int len = f.size();
      try {
        KSubsets comb = new KSubsets(6, 4);
        int j[];
        while( (j = (int[])comb.nextElement()) != null)
        {
            for (int k=0; k<4; k++) {
       //       System.out.print(f.get(j[k]));
              System.out.print(Integer.toString(j[k]));
            }
          System.out.print(" ");
        }
      }
      catch (Throwable se)
      {
        se.printStackTrace();
      }
      System.in.read();
      System.exit(0);
   }        */
}          
