/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.initial;
                                                            
import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.expression.*;
import com.hartmath.patternmatching.*;

import java.net.URL;
import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;
/*
class EComplement implements FunctionEvaluator
{

   public HObject evaluate(HFunction vect)
   {
      if (vect.size() >= 2)
      {
         if (!(vect.get(0) instanceof HFunction))
         {
            return null;
         }

         HashSet        set0 = new HashSet();
         HFunction      f = (HFunction) vect.get(0);
         HFunction      result = C.List.f();

         for (int i = 0; i < f.size(); i++)
         {
            set0.add(f.get(i));
         }

         HFunction      lst;
         HashSet        set1;

         for (int i = 1; i < vect.size(); i++)
         {
            if (vect.get(i) instanceof HFunction)
            {
               lst = (HFunction) vect.get(i);
               set1 = new HashSet();

               for (int j = 0; j < lst.size(); j++)
               {
                  set1.add(lst.get(j));
               }

               set0 = set0.difference(set1);
            }
            else
            {
               return null;
            }
         }

         Enumeration    e = set0.elements();

         while (e.hasMoreElements())
         {
            result.add((HObject)e.nextElement());
         }

         result.sort();

         return result;
      }

      return null;
   }

} */
/*
class EIntersection implements FunctionEvaluator
{
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() >= 2)
      {
         if (!(vect.get(0) instanceof HFunction))
         {
            return null;
         }

         HashSet        set0 = new HashSet();
         HFunction      f = (HFunction) vect.get(0);
         HFunction      result = C.List.f();

         for (int i = 0; i < f.size(); i++)
         {
            set0.add(f.get(i));
         }

         HFunction      lst;
         HashSet        set1;

         for (int i = 1; i < vect.size(); i++)
         {
            if (vect.get(i) instanceof HFunction)
            {
               lst = (HFunction) vect.get(i);
               set1 = new HashSet();

               for (int j = 0; j < lst.size(); j++)
               {
                  set1.add(lst.get(j));
               }

               set0 = set0.intersection(set1);
            }
            else
            {
               return null;
            }
         }

         Enumeration    e = set0.elements();

         while (e.hasMoreElements())
         {
            result.add((HObject)e.nextElement());
         }

         result.sort();

         return result;
      }

      return null;
   }

}
*/

/**
 * Class declaration
 *
 *
 * @author
 * @version %I%, %G%
 */
class EAddTo implements FunctionOpEvaluator
{
   public HObject evaluate(HFunction f)
   {
      if (f.size() == 2)
      {
         if (f.get(0) instanceof HSymbol)
         {
            HObject     v1 = C.EV(f.get(1));
            HSymbol     sym = (HSymbol) f.get(0);
            HObject     result;
            Object      temp;

            if (!sym.isEmptyBlockVariable())
            {
               result = sym.popBlockVariable();
               temp = execute(result, v1);

               if (temp != null)
               {
                  sym.pushBlockVariable((HObject) temp);

                  return (HObject) temp;
               }

               sym.pushBlockVariable(result);

               return null;
            }

            result = sym.getDownRule(sym);

            if (result != null)
            {
               temp = execute(result, v1);

               if (temp != null)
               {
                  sym.putDownRule(HRule.SET, sym, (HObject) temp);

                  return (HObject) temp;
               }
            }
         }
      }

      return null;
   }
   /**
    * Method declaration
    *
    *
    * @param first
    * @param second
    *
    * @return
    *
    * @see
    */
   public Object execute(Object first, Object second)
   {
      return C.EV(C.Add.f((HObject) first, (HObject) second));
   }

   /**
    * Method declaration
    *
    *
    * @param fun
    *
    * @return
    *
    * @see
    */
   public String toOpString(HFunction fun)
   {
      return E2Arg.operatorString(fun, "+=", 30);
   }

   /**
    * Method declaration
    *
    *
    * @return
    *
    * @see
    */
   public int precedence()
   {
      return 30;
   }

}

/**
 * Class declaration
 *
 *
 * @author
 * @version %I%, %G%
 */
class ESubtractFrom extends EAddTo
{

   /**
    * Method declaration
    *
    *
    * @param first
    * @param second
    *
    * @return
    *
    * @see
    */
   public Object execute(Object first, Object second)
   {
      return C.EV(C.Add.f((HObject) first, 
                          C.Multiply.f(C.CN1, (HObject) second)));
   }

   /**
    * Method declaration
    *
    *
    * @param fun
    *
    * @return
    *
    * @see
    */
   public String toOpString(HFunction fun)
   {
      return E2Arg.operatorString(fun, "-=", 30);
   }

}

/**
 * Class declaration
 *
 *
 * @author
 * @version %I%, %G%
 */
class ETimesBy extends EAddTo
{

   /**
    * Method declaration
    *
    *
    * @param first
    * @param second
    *
    * @return
    *
    * @see
    */
   public Object execute(Object first, Object second)
   {
      return C.EV(C.Multiply.f((HObject) first, (HObject) second));
   }

   /**
    * Method declaration
    *
    *
    * @param fun
    *
    * @return
    *
    * @see
    */
   public String toOpString(HFunction fun)
   {
      return E2Arg.operatorString(fun, "*=", 30);
   }

}

/**
 * Class declaration
 *
 *
 * @author
 * @version %I%, %G%
 */
class EDivideBy extends EAddTo
{

   /**
    * Method declaration
    *
    *
    * @param first
    * @param second
    *
    * @return
    *
    * @see
    */
   public Object execute(Object first, Object second)
   {
      return C.EV(C.Multiply.f((HObject) first, 
                               C.Pow.f((HObject) second, C.CN1)));
   }

   /**
    * Method declaration
    *
    *
    * @param fun
    *
    * @return
    *
    * @see
    */
   public String toOpString(HFunction fun)
   {
      return E2Arg.operatorString(fun, "/=", 30);
   }

}
/**
 * Implementation of functions for list manipulations
 * 
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class L implements FunctionEvaluator
{

   public HObject evaluate(HFunction vect)
   {
   //   C.Complement.setEval(new EComplement());
  //    C.Intersection.setEval(new EIntersection());
      C.AddTo.setEval(new EAddTo());
      C.DivideBy.setEval(new EDivideBy());
      C.SubtractFrom.setEval(new ESubtractFrom());
      C.TimesBy.setEval(new ETimesBy());

      return C.Null;
   }

}

