package com.hartmath.initial;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.expression.*;

import java.lang.*;

/**
 * Class Declaration.
 * @see
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 * @version   %I%, %G%
 */
class EAdd extends EMultiArg implements FunctionOpEvaluator
{

   /**
    * Method Declaration.
    * @param o0
    * @param o1
    * @return
    * @see
    */
   public HObject e2ObjArg(HObject o0, HObject o1)
   {

      // Context ct = ((ContextThread) Thread.currentThread()).getContext();
      if (C.numericFlag)
      {
         if (o0.equals(C.CD0))
         {
            return o1;
         }

         if (o1.equals(C.CD0))
         {
            return o0;
         }
      }

      if (o0.equals(C.C0))
      {
         return o1;
      }

      if (o1.equals(C.C0))
      {
         return o0;
      }

      if (o0.equals(o1))
      {
         return C.Multiply.f(C.C2, o0);
      }

      if (o0.head().equals(C.Multiply) && (((HFunction) o0).size() > 1))
      {
         HFunction      f0 = (HFunction) o0;

         if (((HFunction) o0).get(0).isNumber())
         {
            if ((f0.size() == 2) && f0.get(1).equals(o1))
            {
               return C.Multiply.f(C.Add.f(C.C1, f0.get(0)), o1);
            }

            if (o1.head().equals(C.Multiply) && (((HFunction) o1).size() > 1))
            {
               HFunction        f1 = (HFunction) o1;

               if (f1.get(0).isNumber())
               {
                  if (f0.equalsFromPosition(1, f1, 1))
                  {
                     HFunction  result = new HFunction(f0, C.Multiply, 1, 
                                                       f0.size(), true);

                     return C.Multiply.f(C.Add.f(f0.get(0), f1.get(0)), 
                                         result);
                  }
               }
               else
               {
                  if (f0.equalsFromPosition(1, f1, 0))
                  {
                     HFunction  result = new HFunction(f0, C.Multiply, 1, 
                                                       f0.size(), true);

                     return C.Multiply.f(C.Add.f(C.C1, f0.get(0)), result);
                  }
               }
            }
         }
         else
         {
            if (o1.head().equals(C.Multiply) && (((HFunction) o1).size() > 1))
            {
               HFunction        f1 = (HFunction) o1;

               if (f1.get(0).isNumber())
               {
                  if (f0.equalsFromPosition(0, f1, 1))
                  {
                     HFunction  result = new HFunction(f1, C.Multiply, 1, 
                                                       f1.size(), true);

                     return C.Multiply.f(C.Add.f(C.C1, f1.get(0)), result);
                  }
               }
            }
         }
      }

      if (o1.head().equals(C.Multiply) && (((HFunction) o1).size() > 1) 
          && ((HFunction) o1).get(0).isNumber())
      {
         HFunction      f1 = (HFunction) o1;

         if ((f1.size() == 2) && f1.get(1).equals(o0))
         {
            return C.Multiply.f(C.Add.f(C.C1, f1.get(0)), o0);
         }
      }

      return null;
   }

   /**
    * Method Declaration.
    * @param d0
    * @param d1
    * @return
    * @see
    */
   public HObject e2DblArg(HDouble d0, HDouble d1)
   {
      return d0.add(d1);
   }

   /**
    * Method Declaration.
    * @param d0
    * @param d1
    * @return
    * @see
    */
   public HObject e2DblComArg(HDoubleComplex d0, HDoubleComplex d1)
   {
      return d0.add(d1);
   }

   /**
    * Method Declaration.
    * @param i0
    * @param i1
    * @return
    * @see
    */
   public HObject e2IntArg(HInteger i0, HInteger i1)
   {
      return i0.add(i1);
   }

   /**
    * Method Declaration.
    * @param f0
    * @param f1
    * @return
    * @see
    */
   public HObject e2FraArg(HFraction f0, HFraction f1)
   {
      return f0.add(f1);
   }

   /**
    * Method Declaration.
    * @param c0
    * @param c1
    * @return
    * @see
    */
   public HObject e2ComArg(HComplex c0, HComplex c1)
   {
      return c0.add(c1);
   }

   /**
    * Method Declaration.
    * @param c0
    * @param i1
    * @return
    * @see
    */
   public HObject eComIntArg(HComplex c0, HInteger i1)
   {
      return c0.add(new HComplex(i1, C.C0));
   }

   /**
    * Method Declaration.
    * @param fun
    * @return
    * @see
    */
   public String toOpString(HFunction fun)
   {
      final int         prec = 100;
      final char        ch = '+';
      StringBuffer      buf = new StringBuffer();
      HObject           temp;

      if (fun.size() <= 1)
      {         // important for tracing pattern-matching
         buf.append("Add(");

         if (fun.size() == 1)
         {
            buf.append(fun.get(0).toString());
         }

         buf.append(")");

         return buf.toString();
      }

      for (int i = 0; i < fun.size(); i++)
      {
         temp = fun.get(i);

         if (temp instanceof HFunction && (((HFunction) temp).size() > 0) 
             && temp.head().equals(C.Multiply))
         {
            final int   multPrec = 300;
            final char  multCh = '*';
            boolean     flag = false;
            HFunction   multFun = (HFunction) temp;
            HObject     temp1 = multFun.get(0);

            if (temp1 instanceof HSignedNumber 
                && ((HSignedNumber) temp1).isNegative())
            {
               if (temp1.equals(C.C1))
               {
                  flag = true;
               }
               else
               {
                  if (temp1.equals(C.CD1))
                  {
                     flag = true;
                  }
                  else
                  {
                     if (temp1.equals(C.CN1))
                     {
                        buf.append("-");

                        flag = true;
                     }
                     else
                     {
                        if (temp1.equals(C.CDN1))
                        {
                           buf.append("-");

                           flag = true;
                        }
                        else
                        {
                           buf.append(temp1.toString());
                        }
                     }
                  }
               }
            }
            else
            {
               if (i > 0)
               {
                  buf.append(ch);
               }

               if (temp1.precedence() < multPrec)
               {
                  buf.append('(');
               }

               buf.append(temp1.toString());

               if (temp1.precedence() < multPrec)
               {
                  buf.append(')');
               }
            }

            for (int j = 1; j < multFun.size(); j++)
            {
               temp1 = multFun.get(j);

               if ((j > 1) || (flag == false))
               {
                  buf.append(multCh);
               }

               if (temp1.precedence() < multPrec)
               {
                  buf.append('(');
               }

               buf.append(temp1.toString());

               if (temp1.precedence() < multPrec)
               {
                  buf.append(')');
               }
            }
         }
         else
         {
            if (temp instanceof HSignedNumber 
                && ((HSignedNumber) temp).isNegative())
            {

               // special case negative number:
               buf.append(temp.toString());
            }
            else
            {
               if (i > 0)
               {
                  buf.append(ch);
               }

               if (temp.precedence() < prec)
               {
                  buf.append('(');
               }

               buf.append(temp.toString());

               if (temp.precedence() < prec)
               {
                  buf.append(')');
               }
            }
         }
      }

      return buf.toString();
   }

   /**
    * Method Declaration.
    * @return
    * @see
    */
   public int precedence()
   {
      return 100;
   }

}






/**
 * Class Declaration.
 * @see
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 * @version   %I%, %G%
 */
class EMultiply extends EMultiArg implements FunctionOpEvaluator
{

   /**
    * Method Declaration.
    * @param o0
    * @param o1
    * @return
    * @see
    */
   public HObject e2ObjArg(HObject o0, HObject o1)
   {

      // Context ct = ((ContextThread) Thread.currentThread()).getContext();
      if (C.numericFlag)
      {
         if (o0.equals(C.CD0))
         {
            return C.CD0;
         }

         if (o1.equals(C.CD0))
         {
            return C.CD0;
         }

         if (o0.equals(C.CD1))
         {
            return o1;
         }

         if (o1.equals(C.CD1))
         {
            return o0;
         }
      }

      if (o0.equals(C.C0))
      {
         return C.C0;
      }

      if (o1.equals(C.C0))
      {
         return C.C0;
      }

      if (o0.equals(C.C1))
      {
         return o1;
      }

      if (o1.equals(C.C1))
      {
         return o0;
      }

      if (o0.equals(o1))
      {
         return C.Pow.f(o0, C.C2);
      }

      if (o0.head().equals(C.Pow) && (((HFunction) o0).size() == 2))
      {
         HFunction      f0 = (HFunction) o0;

         if (f0.get(1).isNumber())
         {
            if (f0.get(0).equals(o1))
            {
               return C.Pow.f(o1, C.Add.f(C.C1, f0.get(1)));
            }

            if (o1.head().equals(C.Pow) && (((HFunction) o1).size() == 2))
            {
               HFunction        f1 = (HFunction) o1;

               if (f1.get(1).isNumber())
               {
                  if (f0.get(0).equals(f1.get(0)))
                  {
                     return C.Pow.f(f0.get(0), C.Add.f(f0.get(1), f1.get(1)));
                  }
               }
            }
         }
      }

      if (o1.head().equals(C.Pow) && (((HFunction) o1).size() == 2) 
          && ((HFunction) o1).get(1).isNumber())
      {
         HFunction      f1 = (HFunction) o1;

         if (f1.get(0).equals(o0))
         {
            return C.Pow.f(o0, C.Add.f(C.C1, f1.get(1)));
         }
      }

      return null;
   }

   /**
    * Method Declaration.
    * @param d0
    * @param d1
    * @return
    * @see
    */
   public HObject e2DblArg(HDouble d0, HDouble d1)
   {
      return d0.multiply(d1);
   }

   /**
    * Method Declaration.
    * @param d0
    * @param d1
    * @return
    * @see
    */
   public HObject e2DblComArg(HDoubleComplex d0, HDoubleComplex d1)
   {
      return d0.multiply(d1);
   }

   /**
    * Method Declaration.
    * @param i0
    * @param i1
    * @return
    * @see
    */
   public HObject e2IntArg(HInteger i0, HInteger i1)
   {
      return i0.multiply(i1);
   }

   /**
    * Method Declaration.
    * @param f0
    * @param f1
    * @return
    * @see
    */
   public HObject e2FraArg(HFraction f0, HFraction f1)
   {
      return f0.multiply(f1);
   }

   /**
    * Method Declaration.
    * @param c0
    * @param i1
    * @return
    * @see
    */
   public HObject eComIntArg(HComplex c0, HInteger i1)
   {
      return c0.multiply(new HComplex(i1, C.C0));
   }

   /**
    * Method Declaration.
    * @param c0
    * @param c1
    * @return
    * @see
    */
   public HObject e2ComArg(HComplex c0, HComplex c1)
   {
      return c0.multiply(c1);
   }

   /**
    * Method Declaration.
    * @param fun
    * @return
    * @see
    */
   public String toOpString(HFunction fun)
   {
      final int         prec = 300;
      final char        ch = '*';
      StringBuffer      buf = new StringBuffer();
      HObject           temp;

      if (fun.size() <= 1)
      {         // important for tracing pattern-matching
         buf.append("Multiply(");

         if (fun.size() == 1)
         {
            buf.append(fun.get(0).toString());
         }

         buf.append(")");

         return buf.toString();
      }

      for (int i = 0; i < fun.size(); i++)
      {
         temp = fun.get(i);

         if (temp.equals(C.CN1))
         {
            buf.append('-');
         }
         else
         {
            if (temp.precedence() < prec)
            {
               buf.append('(');
            }

            buf.append(temp.toString());

            if (temp.precedence() < prec)
            {
               buf.append(')');
            }

            if (i != (fun.size() - 1))
            {
               buf.append(ch);
            }
         }
      }

      return buf.toString();
   }

   /**
    * Method Declaration.
    * @return
    * @see
    */
   public int precedence()
   {
      return 300;
   }

}


/**
 * Class Declaration.
 * @see
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 * @version   %I%, %G%
 */
class EN extends E1Arg
{

   /**
    * Method Declaration.
    * @param o
    * @return
    * @see
    */
   public HObject e1ObjArg(HObject o)
   {
      return C.NEV(o);
   }

}




/**
 * Class Declaration.
 * @see
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 * @version   %I%, %G%
 */
class EPow extends E2Arg implements FunctionOpEvaluator
{

   /**
    * Method Declaration.
    * @param o0
    * @param o1
    * @return
    * @see
    */
   public HObject e2ObjArg(HObject o0, HObject o1)
   {

      // Context ct = ((ContextThread) Thread.currentThread()).getContext();
      if (C.numericFlag)
      {
         if (o0.equals(C.CD0))
         {
            if (o1.equals(C.CD0))
            {           // 0^0
               throw new HThrowException(C.UndefinedError, C.Pow, 
                                         new HString("0^0"));
            }

            if (o1 instanceof HSignedNumber 
                && ((HSignedNumber) o1).isNegative())
            {
               throw new HThrowException(C.ArithmeticError, C.Pow, 
                                         new HString("division by zero"));
            }

            return C.CD0;
         }

         if (o1.equals(C.CD0))
         {
            return C.CD1;
         }

         if (o1.equals(C.CD1))
         {
            return o0;
         }

         if (o0.equals(C.CD1))
         {
            return C.CD1;
         }
      }

      if (o0.equals(C.C0))
      {
         if (o1.equals(C.C0))
         {      // 0^0
            throw new HThrowException(C.UndefinedError, C.Pow, 
                                      new HString("0^0"));
         }

         if (o1 instanceof HSignedNumber && ((HSignedNumber) o1).isNegative())
         {
            throw new HThrowException(C.ArithmeticError, C.Pow, 
                                      new HString("division by zero"));
         }

         return C.C0;
      }

      if (o1.equals(C.C0))
      {
         return C.C1;
      }

      if (o1.equals(C.C1))
      {
         return o0;
      }

      if (o0.equals(C.C1))
      {
         return C.C1;
      }

      if (o1.isNumber() && o0.head().equals(C.Pow))
      {
         HFunction      f0 = (HFunction) o0;

         if ((f0.size() == 2) && f0.get(1).isNumber())
         {
            return C.Pow.f(f0.get(0), C.Multiply.f(f0.get(1), o1));
         }
      }

      if (o0.head().equals(C.Multiply) && o1.isNumber())
      {
         HFunction      f0 = (HFunction) o0;

         if ((f0.size() > 0) && f0.get(0).isNumber())
         {
            return C.Multiply.f(C.Pow.f(f0.get(0), o1), 
                                C.Pow.f(new HFunction(f0, C.Multiply, 1, f0.size(), true), 
                                        o1));
         }
      }

      return null;
   }

   /**
    * Method Declaration.
    * @param i0
    * @param i1
    * @return
    * @see
    */
   public HObject e2IntArg(HInteger i0, HInteger i1)
   {
      if (i0.equals(C.C0))
      {         // all other cases see e2ObjArg
         return null;
      }

      if (i1.less(C.C0))
      {
         return new HFraction(C.C1, i0.pow(i1.negate().intValue()));
      }

      return i0.pow(i1.intValue());
   }

   /**
    * Method Declaration.
    * @param f0
    * @param f1
    * @return
    * @see
    */
   public HObject e2FraArg(HFraction f0, HFraction f1)
   {
      if (f0.numer().equals(C.C0))
      {
         return C.C0;
      }

      if (f1.numer().equals(C.C0))
      {
         return C.C1;
      }

      if (f0.denom().equals(C.C1) && f1.numer().equals(C.C1))
      {
         boolean        negFlag = false;
         HInteger       a = f0.numer();
         final HInteger root = f1.denom();
         HInteger       result;

         if (root.isNegative())
         {
            return null;
         }

         int    iRoot = root.intValue();

         if (a.isNegative())
         {
            if (root.isEven())
            {           // complex root ???
               a = a.negate();
               result = a.root(iRoot);

               if (result.pow(iRoot).equals(a))
               {
                  if (iRoot % 4 != 0)
                  {
                     return C.EV(C.Multiply.f(C.CI, result));
                  }
               }

               return null;
            }

            negFlag = true;
            a = a.negate();
         }

         result = a.root(iRoot);

         if (result.pow(iRoot).equals(a))
         {
            if (negFlag)
            {
               return result.negate();
            }

            return result;
         }

         return null;
      }

      if (f1.denom().unequals(C.C1))
      {
         return null;
      }

      return f0.pow(f1.numer().intValue());
   }

   /**
    * Method Declaration.
    * @param c0
    * @param i1
    * @return
    * @see
    */
   public HObject eComIntArg(HComplex c0, HInteger i1)
   {
      if (c0.isZero())
      {
         return C.C0;
      }

      if (i1.isZero())
      {
         return C.C1;
      }

      return c0.pow(i1.intValue());
   }

   /**
    * Method Declaration.
    * @param d0
    * @param d1
    * @return
    * @see
    */
   public HObject e2DblArg(HDouble d0, HDouble d1)
   {
      HDouble   res = d0.pow(d1);

      if (res.isNaN())
      {
         return new HDoubleComplex(d0.doubleValue()).pow(new HDoubleComplex(d1));
      }

      return res;
   }

   /**
    * Method Declaration.
    * @param d0
    * @param d1
    * @return
    * @see
    */
   public HObject e2DblComArg(HDoubleComplex d0, HDoubleComplex d1)
   {
      return d0.pow(d1);
   }

   /**
    * Method Declaration.
    * @param fun
    * @return
    * @see
    */
   public String toOpString(HFunction fun)
   {
      StringBuffer      buf = new StringBuffer();
      HObject           temp;

      if (fun.size() > 0)
      {
         if ((fun.size() == 2) 
             && (fun.get(1).equals(C.CN1) || fun.get(1).equals(C.C1D2) 
                 || fun.get(1).equals(C.CN1D2)))
         {
            temp = fun.get(0);

            if (fun.get(1).equals(C.C1D2))
            {
               buf.append("Sqrt(");
               buf.append(temp.toString());
               buf.append(")");
            }
            else
            {
               buf.append("1/");

               if (fun.get(1).equals(C.CN1D2))
               {
                  buf.append("Sqrt(");
                  buf.append(temp.toString());
                  buf.append(")");
               }
               else
               {
                  if (temp.precedence() < 450)
                  {
                     buf.append('(');
                  }

                  buf.append(temp.toString());

                  if (temp.precedence() < 450)
                  {
                     buf.append(')');
                  }
               }
            }
         }
         else
         {
            temp = fun.get(0);

            if (temp.precedence() < 500)
            {
               buf.append('(');
            }

            buf.append(temp.toString());

            if (temp.precedence() < 500)
            {
               buf.append(')');
            }

            if (fun.size() > 1)
            {
               buf.append('^');
            }

            for (int i = 1; i < fun.size(); i++)
            {
               temp = fun.get(i);

               if (temp.precedence() <= 500)
               {
                  buf.append('(');
               }

               buf.append(temp.toString());

               if (temp.precedence() <= 500)
               {
                  buf.append(')');
               }

               if (i != (fun.size() - 1))
               {
                  buf.append('^');
               }
            }
         }
      }

      return buf.toString();
   }

   /**
    * Method Declaration.
    * @return
    * @see
    */
   public int precedence()
   {
      return 500;
   }

}





/**
 * Class Declaration.
 * @see
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 * @version   %I%, %G%
 */
class ESqrt extends E1Arg
{

   /**
    * Method Declaration.
    * @param o
    * @return
    * @see
    */
   public HObject e1ObjArg(HObject o)
   {
      return C.Pow.f(o, C.C1D2);
   }

}


/*
 * class EACos extends E1Arg {
 * public HObject e1DblArg(HDouble d) {
 * return new HDouble( Math.acos(d.doubleValue() ) );
 * }
 * }
 * 
 * class EASin extends E1Arg {
 * public HObject e1DblArg(HDouble d) {
 * return new HDouble( Math.asin(d.doubleValue() ) );
 * }
 * }
 * 
 * class EATan extends E1Arg {
 * public HObject e1DblArg(HDouble d) {
 * return new HDouble( Math.atan(d.doubleValue() ) );
 * }
 * }
 * 
 * class ECos extends E1Arg {
 * public HObject e1DblArg(HDouble d) {
 * return new HDouble( Math.cos(d.doubleValue() ) );
 * }
 * public HObject e1DblComArg(HDoubleComplex d) {
 * return d.cos( );
 * }
 * }
 * 
 * class ECosh extends E1Arg {
 * public HObject e1DblArg(HDouble d) {
 * return d.cosh( );
 * }
 * public HObject e1DblComArg(HDoubleComplex d) {
 * return d.cosh( );
 * }
 * }
 * 
 * class ECot extends E1Arg {
 * public HObject e1DblArg(HDouble d) {
 * return new HDouble( 1.0d / Math.tan(d.doubleValue() ) );
 * }
 * }
 * 
 * class EExp extends E1Arg {
 * public HObject e1DblArg(HDouble d) {
 * return new HDouble( Math.exp(d.doubleValue() ) );
 * }
 * public HObject e1DblComArg(HDoubleComplex d) {
 * return d.exp( );
 * }
 * }
 * 
 * class ELog extends E1Arg {
 * public HObject e1DblArg(HDouble d) {
 * return new HDouble( Math.log(d.doubleValue() ) );
 * }
 * public HObject e1DblComArg(HDoubleComplex d) {
 * return d.log( );
 * }
 * }
 * 
 * class ESin extends E1Arg {
 * public HObject e1DblArg(HDouble d) {
 * return new HDouble( Math.sin(d.doubleValue() ) );
 * }
 * public HObject e1DblComArg(HDoubleComplex d) {
 * return d.sin( );
 * }
 * }
 * 
 * class ESinh extends E1Arg {
 * public HObject e1DblArg(HDouble d) {
 * return d.sinh( );
 * }
 * public HObject e1DblComArg(HDoubleComplex d) {
 * return d.sinh( );
 * }
 * }
 * 
 * class ETan extends E1Arg {
 * public HObject e1DblArg(HDouble d) {
 * return new HDouble( Math.tan(d.doubleValue() ) );
 * }
 * public HObject e1DblComArg(HDoubleComplex d) {
 * return d.tan( );
 * }
 * }
 * 
 * class ETanh extends E1Arg {
 * public HObject e1DblArg(HDouble d) {
 * return d.tanh( );
 * }
 * public HObject e1DblComArg(HDoubleComplex d) {
 * return d.tanh( );
 * }
 * }
 */



/**
 * Class Declaration.
 * @see
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 * @version   %I%, %G%
 */

/*
 * class TxDy {
 * 
 * 
 * public HObject f(HObject o) {
 * return C.Pow.f(o, C.CN1);
 * }
 * 
 * 
 * public HObject f(HObject o0, HObject o1) {
 * return C.Multiply.f(o0, C.Pow.f(o1, C.CN1));
 * }
 * 
 * 
 * public HObject f(HObject o0, HObject o1, HObject o2) {
 * return C.Multiply.f(o0, C.Pow.f(o1, o2));
 * }
 * }
 */

/**
 * Implementation of mathematical functions
 * @see C
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class M implements FunctionEvaluator
{

   /**
    * Method declaration
    *
    *
    * @param vect
    *
    * @return
    *
    * @see
    */
   public HObject evaluate(HFunction vect)
   {

      /*
       * ACos - 0
       * ACot - 1
       * ASin - 2
       * ATan - 3
       * Cos  - 4
       * Cosh - 5
       * Cot  - 6
       * Coth - 7
       * Sin  - 8
       * Sinh - 9
       * Tan  - 10
       * Tanh - 11
       * Exp  - 12
       * Log  - 13
       */

   //   C.ACos.setEval(new E1Float(0));

      // C.ACot.setEval( new SymbolEvaluator());
   //   C.ASin.setEval(new E1Float(2));
   //   C.ATan.setEval(new E1Float(3));
   //   C.Cos.setEval(new E1Float(4));
   //   C.Cosh.setEval(new E1Float(5));

      // C.Cot.setEval( new E1Float(6));
   //   C.ACosh.setEval(new E1Float(14));
   //   C.ASinh.setEval(new E1Float(15));
   //   C.ATanh.setEval(new E1Float(16));
   //   C.Exp.setEval(new E1Float(12));
   //   C.Log.setEval(new E1Float(13));
   //   C.Sin.setEval(new E1Float(8));
   //   C.Sinh.setEval(new E1Float(9));
   //   C.Tan.setEval(new E1Float(10));
   //   C.Tanh.setEval(new E1Float(11));
      C.Add.setEval(new EAdd());
      C.Multiply.setEval(new EMultiply());
      C.N.setEval(new EN());
      C.Pow.setEval(new EPow());
      C.Sqrt.setEval(new ESqrt());
      

      return C.Null;

      // C.rule( C.Exp.f( C.C0 ), C.C1 );
      // C.ASin.putRule( C.ASin.f( C.CN1 ), C.Multiply.f( C.CN1D2, C.Pi ) );
      // C.ASin.putRule( C.ASin.f( C.Multiply.f(C.CN1, C.Pow.f(C.Sqrt.f(C.C2),C.CN1) ) ),
      // C.Multiply.f( C.CN1D4, C.Pi ) );
      // C.ASin.putRule( C.ASin.f( C.C0 ), C.C0 );
      // C.ASin.putRule( C.ASin.f( C.C1 ), C.Multiply.f( C.C1D2, C.Pi ) );
      // C.ACos.putRule( C.ACos.f( C.CN1 ), C.Pi );
      // C.ACos.putRule( C.ACos.f( C.Multiply.f(C.CN1, C.Pow.f(C.Sqrt.f(C.C2),C.CN1) ) ),
      // C.Multiply.f( C.C3D4, C.Pi ) );
      // C.ACos.putRule( C.ACos.f( C.C0 ), C.Multiply.f( C.C1D2, C.Pi ) );
      // C.ACos.putRule( C.ACos.f( C.C1 ), C.C0 );

      /*
       * C.Sin.putRule( C.Sin.f( C.C0 ), C.C0 );
       * C.Sin.putRule( C.Sin.f( C.Multiply.f( C.C1D6, C.Pi ) ), C.C1D2 );
       * C.Sin.putRule( C.Sin.f( C.Multiply.f( C.C1D4, C.Pi ) ), C.Multiply.f(C.C1D2, C.Sqrt.f(C.C2)) );
       * C.Sin.putRule( C.Sin.f( C.Multiply.f( C.C1D3, C.Pi ) ), C.Multiply.f(C.C1D2, C.Sqrt.f(C.C3)) );
       * C.Sin.putRule( C.Sin.f( C.Multiply.f( C.C1D2, C.Pi ) ), C.C1);
       * 
       * C.Cos.putRule( C.Cos.f( C.C0 ), C.C1 );
       * C.Cos.putRule( C.Cos.f( C.Multiply.f( C.C1D6, C.Pi ) ), C.Multiply.f(C.C1D2, C.Sqrt.f(C.C3)) );
       * C.Cos.putRule( C.Cos.f( C.Multiply.f( C.C1D4, C.Pi ) ), C.Multiply.f(C.C1D2, C.Sqrt.f(C.C2)) );
       * C.Cos.putRule( C.Cos.f( C.Multiply.f( C.C1D3, C.Pi ) ), C.C1D2 );
       * C.Cos.putRule( C.Cos.f( C.Multiply.f( C.C1D2, C.Pi ) ), C.C0);
       * 
       * C.Tan.putRule( C.Tan.f( C.C0 ), C.C0 );
       * C.Tan.putRule( C.Tan.f( C.Multiply.f( C.C1D6, C.Pi ) ), C.Multiply.f(C.C1D3, C.Sqrt.f(C.C3)) );
       * C.Tan.putRule( C.Tan.f( C.Multiply.f( C.C1D4, C.Pi ) ), C.C1 );
       * C.Tan.putRule( C.Tan.f( C.Multiply.f( C.C1D3, C.Pi ) ), C.Sqrt.f(C.C3) );
       */

      // C.Cot.putRule( C.Cot.f( C.C0 ), C.C0 );
      // C.Cot.putRule( C.Cot.f( C.Multiply.f( C.C1D6, C.Pi ) ), C.Sqrt.f(C.C3) );
      // C.Cot.putRule( C.Cot.f( C.Multiply.f( C.C1D4, C.Pi ) ), C.C1 );
      // C.Cot.putRule( C.Cot.f( C.Multiply.f( C.C1D3, C.Pi ) ), C.Multiply.f(C.C1D3, C.Sqrt.f(C.C3)) );
      // C.rule( C.Cosh.f( C.C0 ), C.C1 );
      // C.rule( C.Cosh.f( C.CN1 ), CXDY.f(C.Add.f(C.C1, C.CEP2), C.Multiply.f(C.C2, C.E) ) );
      // C.rule( C.Cosh.f( C.C1 ), CXDY.f(C.Add.f(C.C1, C.CEP2), C.Multiply.f(C.C2, C.E) ) );
      // 
      // C.rule( C.Sinh.f( C.C0 ), C.C0 );
      // C.rule( C.Sinh.f( C.CN1 ), CXDY.f(C.Subtract.f(C.C1, C.CEP2), C.Multiply.f(C.C2, C.E) ) );
      // C.rule( C.Sinh.f( C.C1 ), CXDY.f(C.Add.f(C.CN1, C.CEP2), C.Multiply.f(C.C2, C.E) ) );
      // C.rule( C.Tanh.f( C.C0 ), C.C0 );
      // C.rule( C.Tanh.f( C.CN1 ), CXDY.f(C.Subtract.f(C.C1, C.CEP2), C.Add.f(C.C1, C.CEP2) ) );
      // C.rule( C.Tanh.f( C.C1 ), CXDY.f(C.Add.f(C.CN1, C.CEP2), C.Add.f(C.C1, C.CEP2) ) );
      // C.rule( C.Tanh.f( C.C1D2 ), CXDY.f(C.Add.f(C.CN1, C.E), C.Add.f(C.C1, C.E) ) );
      // C.rule( C.Tanh.f( C.CN1D2 ), CXDY.f(C.Subtract.f(C.C1, C.E), C.Add.f(C.C1, C.E) ) );

      /*
       * C.rule( C.D.f(y_, x_), C.Statement.f( C.Check.f(C.IsNoMember.f(x, y)) , C.C0 ) );
       * C.rule( C.D.f(x_, x_), C.C1 );
       * C.rule( C.D.f(C.Add.f(x_, y_),z_), C.Add.f( C.D.f(x, z), C.D.f(y, z) ) );
       * // f(x) * g(x)
       * C.rule( C.D.f(C.Multiply.f(x_, y_),z_),
       * C.Add.f( C.Multiply.f(C.D.f(x, z),y), C.Multiply.f(C.D.f(y, z),x) ) );
       * 
       * 
       * // f(x) ^ g(x)
       * C.rule( C.D.f(C.Pow.f(x_, y_), z_),
       * C.Multiply.f( C.Pow.f(x, y),
       * C.Add.f( C.Multiply.f( C.Log.f(x), C.D.f(y, z) ),
       * C.Multiply.f( y, C.Pow.f(x, C.CN1), C.D.f(x, z) )
       * )
       * )
       * );
       * C.rule( C.D.f(C.Pow.f(x_, i_Integer),z_),
       * C.Multiply.f( i, C.Pow.f(x, C.Add.f(i, C.CN1) ), C.D.f(x, z) ) );
       * 
       * C.rule( C.D.f(C.ASin.f(x_), y_),
       * CXDY.f(C.D.f(x, y),C.Add.f(C.C1,C.Multiply.f(C.CN1,C.Pow.f(x,C.C2))), C.CN1D2) );
       * C.rule( C.D.f(C.ACos.f(x_), y_), C.Multiply.f(C.D.f(x, y),
       * CXDY.f(C.CN1, C.Add.f(C.C1,C.Multiply.f(C.CN1,C.Pow.f(x,C.C2))), C.CN1D2) ) );
       * C.rule( C.D.f(C.ATan.f(x_), y_),
       * CXDY.f(C.D.f(x, y), C.Add.f(C.C1,C.Pow.f(x,C.C2)), C.CN1) );
       * C.rule( C.D.f(C.ACot.f(x_), y_), C.Multiply.f(C.D.f(x, y),
       * CXDY.f(C.CN1, C.Add.f(C.C1,C.Pow.f(x,C.C2)), C.CN1) ) );
       * C.rule( C.D.f(C.Sin.f(x_), y_),
       * C.Multiply.f(C.Cos.f(x), C.D.f(x, y) ) );
       * C.rule( C.D.f(C.Cos.f(x_), y_),
       * C.Multiply.f(C.CN1, C.Sin.f(x), C.D.f(x, y) ) );
       * C.rule( C.D.f(C.Tan.f(x_), y_),
       * C.Multiply.f(C.Pow.f(C.Cos.f(x),C.CN2), C.D.f(x, y) ) );
       * C.rule( C.D.f(C.Sinh.f(x_), y_),
       * C.Multiply.f(C.Cosh.f(x), C.D.f(x, y) ) );
       * C.rule( C.D.f(C.Cosh.f(x_), y_),
       * C.Multiply.f(C.Sinh.f(x), C.D.f(x, y) ) );
       * C.rule( C.D.f(C.Cot.f(x_), y_),
       * C.Multiply.f(C.CN1, C.Pow.f(C.Sin.f(x),C.CN2), C.D.f(x, y) ) );
       * C.rule( C.D.f(C.Exp.f(x_), y_),
       * C.Multiply.f(C.Exp.f(x), C.D.f(x, y) ) );
       * C.rule( C.D.f(C.Log.f(x_), y_),
       * C.Multiply.f(C.Pow.f(x, C.CN1), C.D.f(x, y) ) );
       */
   }

}

