/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.classes;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.expression.*;
import com.hartmath.mapping.*;

import java.util.Hashtable;



class ApplyHeader
{
   protected String       str;
   public static Hashtable      CA = new Hashtable(997);
   static
   {
      CA.put(C.Add, new ApplyHeader( "<plus/>"));
      CA.put(C.Pow, new ApplyHeader( "<power/>"));
      CA.put(C.Multiply, new ApplyHeader( "<times/>"));

      CA.put(C.And, new ApplyHeader( "<and/>"));
      CA.put(C.Or, new ApplyHeader( "<or/>"));
      CA.put(C.Xor, new ApplyHeader( "<xor/>"));
      CA.put(C.Not, new ApplyHeader( "<not/>"));

      CA.put(C.Abs, new ApplyHeader( "<abs/>"));
      CA.put(C.Conjugate, new ApplyHeader( "<conjugate/>"));

      CA.put(C.Equal, new ApplyHeader( "<eq/>"));
      CA.put(C.Unequal, new ApplyHeader( "<ne/>"));
      CA.put(C.Greater, new ApplyHeader( "<gt/>"));
      CA.put(C.Less, new ApplyHeader( "<lt/>"));
      CA.put(C.GreaterEqual, new ApplyHeader( "<geq/>"));
      CA.put(C.LessEqual, new ApplyHeader( "<leq/>"));

      CA.put(C.Sin, new ApplyHeader( "<sin/>"));
      CA.put(C.Cos, new ApplyHeader( "<cos/>"));
      CA.put(C.Tan, new ApplyHeader( "<tan/>"));
      CA.put(C.Sinh, new ApplyHeader( "<sinh/>"));
      CA.put(C.Cosh, new ApplyHeader( "<cosh/>"));
      CA.put(C.Tanh, new ApplyHeader( "<tanh/>"));
      CA.put(C.ASin, new ApplyHeader( "<arcsin/>"));
      CA.put(C.ACos, new ApplyHeader( "<arccos/>"));
      CA.put(C.ATan, new ApplyHeader( "<arctan/>"));


      CA.put(C.Det, new ApplyMatrixUnaryFunction( "<determinant/>"));
      CA.put(C.Transpose, new ApplyMatrixUnaryFunction( "<transpose/>"));
   }

   /**
    * Class Constructor.
    * 
    * 
    * @param ins
    * 
    * @see
    */
   public ApplyHeader(String ins)
   {
      str = ins;
   }

   public void convert(StringBuffer buf, HFunction f)
   {
     buf.append(" <apply>");
     buf.append(str);
     buf.append("\n");
     for (int i = 0; i < f.size(); i++)
     {
       EMMLContent.convert(buf, f.get(i));
     }
     buf.append(" </apply>\n");
   }
   static public void convertFunction(StringBuffer buf, HFunction f)
   {
     ApplyHeader ah = (ApplyHeader) CA.get(f.head());
     if (ah==null) {
       buf.append(" <apply>");
       buf.append("  <ci>");
       buf.append( f.head().toString() );
       buf.append("</ci>\n");
       buf.append("\n");
       for (int i = 0; i < f.size(); i++)
       {
         EMMLContent.convert(buf, f.get(i));
       }
       buf.append(" </apply>\n");
     }
     else {
       ah.convert(buf, f);
     }


   }

}

class ApplyMatrixUnaryFunction extends ApplyHeader
{
   public ApplyMatrixUnaryFunction(String ins)
   {
      super(ins);
   }

   public void convert(StringBuffer buf, HFunction f)
   {
     if (f.size()==1)
     {
       buf.append(" <apply>");
       buf.append(str);
       buf.append("\n");
       HObject obj = f.get(0);
       if (obj instanceof HSymbol) {
         buf.append("  <ci type=\"matrix\"> ");
         buf.append(obj.toString());
         buf.append(" </ci>\n");
       }
       buf.append(" </apply>\n");
     }
     else {
       super.convert(buf, f);
     }

   }
}

class EMMLContent extends E1Arg
{

   /*
    * converter table
    */
   public static Hashtable      CV = new Hashtable(997);
   /*
    *  convertings for a header of function (apply)
    */

   static public void convertDouble(StringBuffer buf, HDouble d)
   {
     buf.append("  <cn>");
     buf.append(d.toString());
     buf.append("</cn>\n");
   }
   static public void convertDoubleComplex(StringBuffer buf, HDoubleComplex dc)
   {
     buf.append("  <cn type=\"complex-cartesian\">");
     buf.append( String.valueOf(dc.real()) );
     buf.append("<sep/>");
     buf.append( String.valueOf(dc.imag()) );
     buf.append("</cn>\n");
   }
   static public void convertInteger(StringBuffer buf, HInteger i)
   {
     buf.append("  <cn type=\"integer\">");
     buf.append( i.toString() );
     buf.append("</cn>\n");
   }
   static public void convertFraction(StringBuffer buf, HFraction f)
   {
     buf.append("  <cn type=\"rational\">");
     buf.append( f.numer().toString() );     
     buf.append("<sep/>");
     buf.append( f.denom().toString() );
     buf.append("</cn>\n");
   }
   static public void convertComplex(StringBuffer buf, HComplex c)
   {
     buf.append("  <cn type=\"complex\">");
     buf.append( c.re().toString() );
     buf.append("<sep/>");
     buf.append( c.im().toString() );
     buf.append("</cn>\n");
   }

   static public void convertString(StringBuffer buf, HString str)
   {
     buf.append("  <ci>");
     buf.append( str.toString() );
     buf.append("</ci>\n");
   }

   static public void convertSymbol(StringBuffer buf, HSymbol sym)
   {
     buf.append("  <ci>");
     buf.append( sym.toString() );
     buf.append("</ci>\n");
   }

   static public void convertPattern(StringBuffer buf, HPattern p)
   {
     buf.append("  <ci>");
     buf.append( p.toString() );
     buf.append("</ci>\n");
   }

   /**
    * Method Declaration.
    *
    *
    * @param o
    *
    * @return
    *
    * @see
    */
   static public void convert(StringBuffer buf, HObject o)
   {
      int       hier = o.hierarchy();

      switch (hier)
      {
         case HObject.DOUBLEID:
           convertDouble(buf, (HDouble) o );
           break;
         case HObject.DOUBLECOMPLEXID:
           convertDoubleComplex(buf, (HDoubleComplex) o );
           break;
         case HObject.INTEGERID:
           convertInteger(buf, (HInteger) o );
           break;
         case HObject.FRACTIONID:
           convertFraction(buf, (HFraction) o );
           break;
         case HObject.COMPLEXID:
           convertComplex(buf, (HComplex) o );
           break;
         case HObject.STRINGID:
           convertString(buf, (HString) o );
           break;
         case HObject.SYMBOLID:
           convertSymbol(buf, (HSymbol) o );
           break;
         case HObject.PATTERNID:
           convertPattern(buf, (HPattern) o );
           break;
         case HObject.FUNCTIONID:
            HFunction   f = ((HFunction) o);
         //   Gen         g = (Gen) CV.get(f.head());
            if (f.head().equals(C.List) )
            {
              buf.append(" <set>\n");

              for (int i = 0; i < f.size(); i++)
              {
                 convert(buf, f.get(i));
              }

              buf.append(" </set>\n");
              break;
            }
            ApplyHeader.convertFunction(buf, f);
               /*
            if (g == null)
            {
               res = "<apply>\n" + convertSymbol(f.head());

               for (int i = 0; i < f.size(); i++)
               {
                  res += convert(f.get(i));

                  if (i < f.size() - 1)
                  {
                     res += ", ";
                  }
               }

               res += "</apply>\n";
            }
            else
            {
               res = g.getPre();

               for (int i = 0; i < f.size(); i++)
               {
                  res += convert(f.get(i));

                  if (i < f.size() - 1)
                  {
                     res += g.getIn();
                  }
               }

               res += g.getPost();
            }
               */
            break;

         default:
            buf.append( o.toString() );
      }
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param o
    * 
    * @return
    * 
    * @see
    */
   public HObject e1ObjArg(HObject o)
   {
      StringBuffer res = new StringBuffer("<math>\n");
      convert(res, o);
      res.append("</math>\n");
      return new HString(res);
   }

}

class MMLOperator {
  String frst;
  String oper;
  String last;
  public MMLOperator(String fs, String op, String ls)
  {
    frst = fs;
    oper = op;
    last = ls;
  }
  public void convert(StringBuffer buf, HFunction f)
   {
    buf.append(frst);
    for (int i = 0; i < f.size(); i++)
    {
      EMML.convert(buf, f.get(i));
      if (i<f.size()-1)
      {
        if (oper.compareTo("")!=0) {
          buf.append("     <mo>");
          buf.append(oper);
          buf.append("</mo>\n");
        }
      }
    }
    buf.append(last);
  }
}

class EMML extends E1Arg
{
   /*
    *  convertings for a header of function (apply)
    */
   public static Hashtable greekSym = new Hashtable(199);
   public static Hashtable operTab  = new Hashtable(199);


   static
   {
      operTab.put(C.Add, new MMLOperator("   <mrow>\n", "+", "   </mrow>\n"));
      operTab.put(C.Multiply, new MMLOperator("   <mrow>\n", "&InvisibleTimes;", "   </mrow>\n"));
      operTab.put(C.Pow, new MMLOperator("   <msup>\n", "", "   </msup>\n"));
      greekSym.put("Alpha", C.True);
      greekSym.put("Beta", C.True);
      greekSym.put("Chi", C.True);
      greekSym.put("Delta", C.True);
      greekSym.put("Epsilon", C.True);
      greekSym.put("Phi", C.True);
      greekSym.put("Gamma", C.True);
      greekSym.put("Eta", C.True);
      greekSym.put("Iota", C.True);
      greekSym.put("varTheta", C.True);
      greekSym.put("Kappa", C.True);
      greekSym.put("Lambda", C.True);
      greekSym.put("Mu", C.True);
      greekSym.put("Nu", C.True);
      greekSym.put("Omicron", C.True);
      greekSym.put("Pi", C.True);
      greekSym.put("Theta", C.True);
      greekSym.put("Rho", C.True);
      greekSym.put("Sigma", C.True);
      greekSym.put("Tau", C.True);
      greekSym.put("Upsilon", C.True);
      greekSym.put("Omega", C.True);
      greekSym.put("Xi", C.True);
      greekSym.put("Psi", C.True);
      greekSym.put("Zeta", C.True);

      greekSym.put("alpha", C.True);
      greekSym.put("beta", C.True);
      greekSym.put("chi", C.True);
      greekSym.put("selta", C.True);
      greekSym.put("epsilon", C.True);
      greekSym.put("phi", C.True);
      greekSym.put("gamma", C.True);
      greekSym.put("eta", C.True);
      greekSym.put("iota", C.True);
      greekSym.put("varphi", C.True);
      greekSym.put("kappa", C.True);
      greekSym.put("lambda", C.True);
      greekSym.put("mu", C.True);
      greekSym.put("nu", C.True);
      greekSym.put("omicron", C.True);
      greekSym.put("pi", C.True);
      greekSym.put("theta", C.True);
      greekSym.put("rho", C.True);
      greekSym.put("sigma", C.True);
      greekSym.put("tau", C.True);
      greekSym.put("upsilon", C.True);
      greekSym.put("varomega", C.True);
      greekSym.put("omega", C.True);
      greekSym.put("xi", C.True);
      greekSym.put("psi", C.True);
      greekSym.put("zeta", C.True);
   }

   static public void convertDouble(StringBuffer buf, HDouble d)
   {
     buf.append("  <mn>");
     buf.append(d.toString());
     buf.append("</mn>\n");
   }
   static public void convertDoubleComplex(StringBuffer buf, HDoubleComplex dc)
   {
     buf.append("  <mrow>");
     buf.append( String.valueOf(dc.real()) );
     buf.append("     <mo> + </mo>\n");
     buf.append("     <mrow>\n");
     buf.append( String.valueOf(dc.imag()) );
     buf.append("     <mo> &InvisibleTimes; </mo>\n");
     buf.append("     <mi> &ImaginrayI; </mi>\n");
     buf.append("     </mrow>\n");
     buf.append("  </mrow>\n");
   }
   static public void convertInteger(StringBuffer buf, HInteger i)
   {
     buf.append("  <mn>");
     buf.append( i.toString() );
     buf.append("</mn>\n");
   }
   static public void convertFraction(StringBuffer buf, HFraction f)
   {
     buf.append("  <mfrac> <mn>");
     buf.append( f.numer().toString() );
     buf.append("<mn/> <mn>");
     buf.append( f.denom().toString() );
     buf.append("</mn> <mfrac>\n");
   }
   static public void convertComplex(StringBuffer buf, HComplex c)
   {
     buf.append("  <mrow>");
     buf.append( c.re().toString() );
     buf.append("     <mo> + </mo>\n");
     buf.append("     <mrow>\n");
     buf.append( c.im().toString() );
     buf.append("     <mo> &InvisibleTimes; </mo>\n");
     buf.append("     <mi> &ImaginrayI; </mi>\n");
     buf.append("     </mrow>\n");
     buf.append("  </mrow>\n");
   }

   static public void convertString(StringBuffer buf, HString str)
   {
     buf.append("  <mtext>");
     buf.append( str.toString() );
     buf.append("</mtext>\n");
   }

   static public void convertSymbol(StringBuffer buf, HSymbol sym)
   {
     HObject ho = (HObject) greekSym.get(sym.toString());
     buf.append("  <mi>");
     if (ho==C.True) {
       buf.append( "&" );
     }
     buf.append( sym.toString() );
     buf.append("</mi>\n");
   }

   static public void convertPattern(StringBuffer buf, HPattern p)
   {
     buf.append("  <mi>");
     buf.append( p.toString() );
     buf.append("</mi>\n");
   }

   static public void convertHead(StringBuffer buf, HSymbol sym)
   {
       HObject ho = (HObject) greekSym.get(sym.toString());
       buf.append("  <mi>");
       if (ho==C.True) {
         buf.append( "&" );
       }
       buf.append( sym.toString() );
       buf.append("</mi>\n");
       buf.append("  <mo> &ApplyFunction; </mo>\n");
   }
   /**
    * Method Declaration.
    *
    *
    * @param o
    *
    * @return
    *
    * @see
    */
   static public void convert(StringBuffer buf, HObject o)
   {
      int       hier = o.hierarchy();

      switch (hier)
      {
         case HObject.DOUBLEID:
           convertDouble(buf, (HDouble) o );
           break;
         case HObject.DOUBLECOMPLEXID:
           convertDoubleComplex(buf, (HDoubleComplex) o );
           break;
         case HObject.INTEGERID:
           convertInteger(buf, (HInteger) o );
           break;
         case HObject.FRACTIONID:
           convertFraction(buf, (HFraction) o );
           break;
         case HObject.COMPLEXID:
           convertComplex(buf, (HComplex) o );
           break;
         case HObject.STRINGID:
           convertString(buf, (HString) o );
           break;
         case HObject.SYMBOLID:
           convertSymbol(buf, (HSymbol) o );
           break;
         case HObject.PATTERNID:
           convertPattern(buf, (HPattern) o );
           break;
         case HObject.FUNCTIONID:
            HFunction   f = ((HFunction) o);
            MMLOperator io = (MMLOperator) operTab.get(f.head());
            if (io != null)
            {
              io.convert(buf, f);
            }
            else
            {
               buf.append(" <mrow>");
               convertHead(buf, f.head());
               buf.append("   <mrow>");
               buf.append("     <mo> ( </mo>\n");
               for (int i = 0; i < f.size(); i++)
               {
                  convert(buf, f.get(i));
                  if (i<f.size()-1)
                  {
                    buf.append("     <mo> , </mo>\n");
                  }
               }
               buf.append("     <mo> ) </mo>\n");
               buf.append("   </mrow>\n");
               buf.append(" </mrow>\n");
            }
            break;

         default:
            buf.append( o.toString() );
      }
   }

   /**
    * Method Declaration.
    *
    * 
    * @param o
    * 
    * @return
    * 
    * @see
    */
   public HObject e1ObjArg(HObject o)
   {
      StringBuffer res = new StringBuffer("<math>\n");
      convert(res, o);
      res.append("</math>\n");
      return new HString(res);
   }

}

class EzMathOperator {
  String frst;
  String oper;
  String last;
  int description;    // -1 prefix; 0 infix; +1 postfix
  int precedence;
  public EzMathOperator(String fs, String op, String ls, int desc, int prec)
  {
    frst = fs;
    oper = op;
    last = ls;
    description = desc;
    precedence = prec;
  }
  public EzMathOperator(String op, int desc, int prec)
  {
    frst = "";
    oper = op;
    last = "";
    description = desc;
    precedence = prec;
  }
  public EzMathOperator(String op, int prec)
  {
    frst = "";
    oper = op;
    last = "";
    description = 0;
    precedence = prec;
  }

  public int getPrecedence()
  {
    return precedence;
  }
  
  public void convert(StringBuffer buf, HFunction f)
   {
    buf.append(frst);
    if (description == -1) {
      buf.append(oper);
    }
    for (int i = 0; i < f.size(); i++)
    {
      if ( EEzMath.getPrecedence(f.get(i)) < precedence)
      {
        buf.append("(");
      }
      EEzMath.convert(buf, f.get(i));  
      if ( EEzMath.getPrecedence(f.get(i)) < precedence)
      {
        buf.append(")");
      }

      if (i<f.size()-1)  
      {  
        if (description==0) {  
          buf.append(oper);  
        }  
      }
    }
    if (description == 1) {
      buf.append(oper);
    }
    buf.append(last);
  }
}

class EEzMath extends E1Arg
{
   /*
    *  convertings for a header of function (apply)
    */
   public static Hashtable greekSym = new Hashtable(199);
   public static Hashtable operTab  = new Hashtable(199);


   static
   {
      operTab.put(C.Abs, new EzMathOperator("", "abs {", "}", -1, 1000));
      operTab.put(C.Sin, new EzMathOperator("", "sin {", "}", -1, 1000));
      operTab.put(C.Cos, new EzMathOperator("", "cos {", "}", -1, 1000));
      operTab.put(C.Tan, new EzMathOperator("", "tan {", "}", -1, 1000));
      operTab.put(C.Sinh, new EzMathOperator("", "sinh {", "}", -1, 1000));
      operTab.put(C.Cosh, new EzMathOperator("", "cosh {", "}", -1, 1000));
      operTab.put(C.Tanh, new EzMathOperator("", "tanh {", "}", -1, 1000));
      operTab.put(C.ASin, new EzMathOperator("", "arcsin {", "}", -1, 1000));
      operTab.put(C.ACos, new EzMathOperator("", "arccos {", "}", -1, 1000));
      operTab.put(C.ATan, new EzMathOperator("", "arctan {", "}", -1, 1000));
      operTab.put(C.Exp, new EzMathOperator("", "exp {", "}", -1, 1000));

      operTab.put(C.Factorial, new EzMathOperator("!", 780));
      operTab.put(C.Pow, new EzMathOperator("^", 760));
      operTab.put(C.Add, new EzMathOperator("+", 400));
      operTab.put(C.Multiply, new EzMathOperator("*", 480));
      operTab.put(C.Equal, new EzMathOperator(" equals ", 300));
      operTab.put(C.Unequal, new EzMathOperator("!=", 300));
      operTab.put(C.Less, new EzMathOperator("<", 300));
      operTab.put(C.Greater, new EzMathOperator(">", 300));
      operTab.put(C.LessEqual, new EzMathOperator("<=", 300));
      operTab.put(C.GreaterEqual, new EzMathOperator(">=", 300));
      greekSym.put("Alpha", C.True);
      greekSym.put("Beta", C.True);
      greekSym.put("Chi", C.True);
      greekSym.put("Delta", C.True);
      greekSym.put("Epsilon", C.True);
      greekSym.put("Phi", C.True);
      greekSym.put("Gamma", C.True);
      greekSym.put("Eta", C.True);
      greekSym.put("Iota", C.True);
      greekSym.put("varTheta", C.True);
      greekSym.put("Kappa", C.True);
      greekSym.put("Lambda", C.True);
      greekSym.put("Mu", C.True);
      greekSym.put("Nu", C.True);
      greekSym.put("Omicron", C.True);
      greekSym.put("Pi", C.True);
      greekSym.put("Theta", C.True);
      greekSym.put("Rho", C.True);
      greekSym.put("Sigma", C.True);
      greekSym.put("Tau", C.True);
      greekSym.put("Upsilon", C.True);
      greekSym.put("Omega", C.True);
      greekSym.put("Xi", C.True);
      greekSym.put("Psi", C.True);
      greekSym.put("Zeta", C.True);

      greekSym.put("alpha", C.True);
      greekSym.put("beta", C.True);
      greekSym.put("chi", C.True);
      greekSym.put("selta", C.True);
      greekSym.put("epsilon", C.True);
      greekSym.put("phi", C.True);
      greekSym.put("gamma", C.True);
      greekSym.put("eta", C.True);
      greekSym.put("iota", C.True);
      greekSym.put("varphi", C.True);
      greekSym.put("kappa", C.True);
      greekSym.put("lambda", C.True);
      greekSym.put("mu", C.True);
      greekSym.put("nu", C.True);
      greekSym.put("omicron", C.True);
      greekSym.put("pi", C.True);
      greekSym.put("theta", C.True);
      greekSym.put("rho", C.True);
      greekSym.put("sigma", C.True);
      greekSym.put("tau", C.True);
      greekSym.put("upsilon", C.True);
      greekSym.put("varomega", C.True);
      greekSym.put("omega", C.True);
      greekSym.put("xi", C.True);
      greekSym.put("psi", C.True);
      greekSym.put("zeta", C.True);
   }

   static public void convertDouble(StringBuffer buf, HDouble d)
   {
     buf.append("{");
     buf.append(d.toString());
     buf.append("}");
   }
   static public void convertDoubleComplex(StringBuffer buf, HDoubleComplex dc)
   {
     buf.append("  complex(");
     buf.append( String.valueOf(dc.real()) );
     buf.append(",");
     buf.append( String.valueOf(dc.imag()) );
     buf.append(")\n");
   }
   static public void convertInteger(StringBuffer buf, HInteger i)
   {
     buf.append("{");
     buf.append( i.toString() );
     buf.append("}");
   }
   static public void convertFraction(StringBuffer buf, HFraction f)
   {
     buf.append("{");
     buf.append( f.numer().toString() );
     buf.append("/");
     buf.append( f.denom().toString() );
     buf.append("}");
   }
   static public void convertComplex(StringBuffer buf, HComplex c)
   {
     buf.append("  complex(");
     buf.append( c.re().toString() );
     buf.append(",");
     buf.append( c.im().toString() );
     buf.append(")\n");
   }

   static public void convertString(StringBuffer buf, HString str)
   {
     buf.append( " " );
     buf.append( str.toString() );
     buf.append( " " );
   }

   static public void convertSymbol(StringBuffer buf, HSymbol sym)
   {
     buf.append( sym.toString() );
   }

   static public void convertPattern(StringBuffer buf, HPattern p)
   {
     buf.append( p.toString() );
   }

   /**
    * Method Declaration.
    *
    *
    * @param o
    *
    * @return
    *
    * @see
    */
   static public void convert(StringBuffer buf, HObject o)
   {
      int       hier = o.hierarchy();

      switch (hier)
      {
         case HObject.DOUBLEID:
           convertDouble(buf, (HDouble) o );
           break;
         case HObject.DOUBLECOMPLEXID:
           convertDoubleComplex(buf, (HDoubleComplex) o );
           break;
         case HObject.INTEGERID:
           convertInteger(buf, (HInteger) o );
           break;
         case HObject.FRACTIONID:
           convertFraction(buf, (HFraction) o );
           break;
         case HObject.COMPLEXID:
           convertComplex(buf, (HComplex) o );
           break;
         case HObject.STRINGID:
           convertString(buf, (HString) o );
           break;
         case HObject.SYMBOLID:
           convertSymbol(buf, (HSymbol) o );
           break;
         case HObject.PATTERNID:
           convertPattern(buf, (HPattern) o );
           break;
         case HObject.FUNCTIONID:
            HFunction   f = ((HFunction) o);
            EzMathOperator io = (EzMathOperator) operTab.get(f.head());
            if (io != null)
            {
              io.convert(buf, f);
            }
            else
            {
               buf.append(" function ");
               convert(buf, f.head());
               buf.append("(");
               for (int i = 0; i < f.size(); i++)
               {
                  convert(buf, f.get(i));
                  if (i<f.size()-1)
                  {
                    buf.append(", ");
                  }
               }
               buf.append(")");
            }
            break;

         default:
            buf.append( o.toString() );
      }
   }

   static public int getPrecedence(HObject o)
   {
      int       hier = o.hierarchy();

      switch (hier)
      {
         case HObject.DOUBLEID:
           return 1000;
         case HObject.DOUBLECOMPLEXID:
           return 1000;
         case HObject.INTEGERID:
           return 1000;
         case HObject.FRACTIONID:
           return 1000;
         case HObject.COMPLEXID:
           return 1000;
         case HObject.STRINGID:
           return 1000;
         case HObject.SYMBOLID:
           return 1000;
         case HObject.PATTERNID:
           return 1000;
         case HObject.FUNCTIONID:
            HFunction   f = ((HFunction) o);
            EzMathOperator io = (EzMathOperator) operTab.get(f.head());
            if (io != null)
            {
              return io.getPrecedence();
            }
            else
            {
              return 1000;
            }

         default:
            return 1000;
      }
   }
   /**
    * Method Declaration.
    *
    * 
    * @param o
    * 
    * @return
    * 
    * @see
    */
   public HObject e1ObjArg(HObject o)
   {
      StringBuffer res =
      new StringBuffer(
          "  <embed type=\"text/ezmath\"\n"
        + "  pluginspage=\"http://www.w3.org/People/Raggett/EzMath\"\n"
        + "  align=absmiddle\n"
        + "  width= 200 height=100\n"
    //    + "  fontsize=small\n"
        + "  color=\"#000000\"\n"
        + "  bgcolor=\"silver\"\n"
        + "  alt=\"");
      convert(res, o);
      res.append("\">\n");
      return new HString(res);
   }

}
/**
 * Class Declaration.
 * 
 * 
 * @see
 * 
 * @author
 * @version   %I%, %G%
 */
public class MathML implements FunctionEvaluator
{
   final static public HSymbol  MMLContent = new HSymbol("MMLContent",
   new EMMLContent(), HSymbol.HOLDALL);
   final static public HSymbol  MML = new HSymbol("MML",
   new EMML(), HSymbol.HOLDALL);
   final static public HSymbol  EzMath = new HSymbol("EzMath",
   new EEzMath(), HSymbol.HOLDALL);
   static
   {
      MMLContent.putSymbol();
      MML.putSymbol();
      EzMath.putSymbol();
   }

   
   public HObject evaluate(HFunction vect)
   {
      return C.Null;
   }

}



