package com.hartmath.util;

import com.hartmath.expression.*;

/**
* The MathNumber superclass provides an abstract encapsulation for numbers.
* @version 1.0
* @author Mark Hale
*/
public abstract class MathNumber {
        //public static double ZERO_TOL=0.0;
        public static double ZERO_TOL=HDouble.EPS;
        /**
        * Constructs a mathematical number.
        */
        public MathNumber() {}
        /**
        * Returns the addition of this number and another.
        */
        public abstract MathNumber add(MathNumber x);
        /**
        * Returns the subtraction of this number and another.
        */
        public abstract MathNumber subtract(MathNumber x);
        /**
        * Returns the multiplication of this number and another.
        */
        public abstract MathNumber multiply(MathNumber x);
        /**
        * Returns the division of this number and another.
        */
        public abstract MathNumber divide(MathNumber x);
}
