package com.hartmath.util;

/**
* The MathVector superclass provides an abstract encapsulation for vectors.
* @version 2.0
* @author Mark Hale
*/
public abstract class MathVector extends Object implements java.io.Serializable {
        /**
        * Constructs a mathematical vector.
        */
        public MathVector() {}
        /**
        * Returns the norm (magnitude).
        */
        public abstract double norm();
        /**
        * Returns the vector's dimension.
        */
        public abstract int dimension();
        /**
        * Returns the addition of this vector and another.
        */
        public abstract MathVector add(MathVector v);
        /**
        * Returns the subtraction of this vector by another.
        */
        public abstract MathVector subtract(MathVector v);
        /**
        * Returns the multiplication of this vector by a scalar.
        */
        public abstract MathVector scalarMultiply(MathNumber x);
}

