package com.hartmath.util;

/**
* The Matrix superclass provides an abstract encapsulation for matrices.
* @version 2.0
* @author Mark Hale
*/
public abstract class Matrix {
        /**
        * Constructs a matrix.
        */
        public Matrix() {}
        /**
        * Returns the number of rows.
        */
        public abstract int rows();
        /**
        * Returns the number of columns.
        */
        public abstract int columns();
        /**
        * Returns the addition of this matrix and another.
        */
        public abstract Matrix add(Matrix m);
        /**
        * Returns the subtraction of this matrix by another.
        */
        public abstract Matrix subtract(Matrix m);
        /**
        * Returns the multiplication of this matrix and another.
        */
        public abstract Matrix multiply(Matrix m);
        /**
        * Returns the transpose of this matrix.
        */
        public abstract Matrix transpose();
}

