package com.hartmath.util;

import com.hartmath.expression.*;
import com.hartmath.lib.*;

/**
* This exception occurs when a numerical algorithm exceeds it maximum number of allowable iterations.
* @version 1.0
* @author Mark Hale
*/
public final class MaximumIterationsExceededException extends HThrowException {
        /**
        * Constructs a MaximumIterationsExceededException with no detail message.
        */
        public MaximumIterationsExceededException() {
          super(C.List, C.List, new HString("maximum iterations exceeded"));
        }
        /**
        * Constructs a MaximumIterationsExceededException with the specified detail message.
        */
        public MaximumIterationsExceededException(String s) {
          super(C.List, C.List, new HString(s));
        }
}

