package com.hartmath.JSci.chemistry;

import com.hartmath.lib.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.JSci.chemistry.periodictable.*;
import com.hartmath.awt.EFrame;

import java.awt.*;
import java.awt.event.*;


/**
* Periodic Table.
* @author Mark Hale
* @version 1.2
*/
public final class PeriodicTable extends EFrame {
        private GridBagLayout gb;
        private GridBagConstraints gbc;              /*
        public static void main(String argv[]) {
                new PeriodicTable();
        }                                             */
        public PeriodicTable() {
                //super("Periodic Table");
                super(true);     /*
                addWindowListener(new WindowAdapter() {
                        public void windowClosing(WindowEvent evt) {
                                dispose();
                                System.exit(0);
                        }
                });              */
                createTable();
          //      setSize(650,300);
          //      setVisible(true);
        }
        private void createTable() {
                gb=new GridBagLayout();
                gbc=new GridBagConstraints();
                gbc.anchor = GridBagConstraints.CENTER;
                gbc.fill=GridBagConstraints.BOTH;
               // gbc.gridwidth = 18;
               // gbc.gridheight = 10;
                setLayout(gb);
                setFont(new Font("Courier", Font.PLAIN, 11));
                gbc.gridx=0;
                gbc.gridy=0;
                createButton(Element.Hydrogen);
                gbc.gridx=17;
                createButton(Element.Helium);
                gbc.gridy++;
                
                gbc.gridx=0;
                createButton(Element.Lithium);
                gbc.gridx=1;
                createButton(Element.Beryllium);
                gbc.gridx=12;
                createButton(Element.Boron);
                gbc.gridx++;
                createButton(Element.Carbon);
                gbc.gridx++;
                createButton(Element.Nitrogen);
                gbc.gridx++;
                createButton(Element.Oxygen);
                gbc.gridx++;
                createButton(Element.Fluorine);
                gbc.gridx++;
                createButton(Element.Neon);
                gbc.gridx=0;
                gbc.gridy++;
                createButton(Element.Sodium);
                gbc.gridx=1;
                createButton(Element.Magnesium);
                gbc.gridx=12;
                createButton(Element.Aluminium);
                gbc.gridx++;
                createButton(Element.Silicon);
                gbc.gridx++;
                createButton(Element.Phosphorus);
                gbc.gridx++;
                createButton(Element.Sulphur);
                gbc.gridx++;
                createButton(Element.Chlorine);
                gbc.gridx++;
                createButton(Element.Argon);
                gbc.gridx=0;
                gbc.gridy++;
                createButton(Element.Potassium);
                gbc.gridx++;
                createButton(Element.Calcium);
                gbc.gridx++;
                createButton(Element.Scandium);
                gbc.gridx++;
                createButton(Element.Titanium);
                gbc.gridx++;
                createButton(Element.Vanadium);
                gbc.gridx++;
                createButton(Element.Chromium);
                gbc.gridx++;
                createButton(Element.Manganese);
                gbc.gridx++;
                createButton(Element.Iron);
                gbc.gridx++;
                createButton(Element.Cobalt);
                gbc.gridx++;
                createButton(Element.Nickel);
                gbc.gridx++;
                createButton(Element.Copper);
                gbc.gridx++;
                createButton(Element.Zinc);
                gbc.gridx++;
                createButton(Element.Gallium);
                gbc.gridx++;
                createButton(Element.Germanium);
                gbc.gridx++;
                createButton(Element.Arsenic);
                gbc.gridx++;
                createButton(Element.Selenium);
                gbc.gridx++;
                createButton(Element.Bromine);
                gbc.gridx++;
                createButton(Element.Krypton);
                gbc.gridx=0;
                gbc.gridy++;
                createButton(Element.Rubidium);
                gbc.gridx++;
                createButton(Element.Strontium);
                gbc.gridx++;
                createButton(Element.Yttrium);
                gbc.gridx++;
                createButton(Element.Zirconium);
                gbc.gridx++;
                createButton(Element.Niobium);
                gbc.gridx++;
                createButton(Element.Molybdenum);
                gbc.gridx++;
                createButton(Element.Technetium);
                gbc.gridx++;
                createButton(Element.Ruthenium);
                gbc.gridx++;
                createButton(Element.Rhodium);
                gbc.gridx++;
                createButton(Element.Palladium);
                gbc.gridx++;
                createButton(Element.Silver);
                gbc.gridx++;
                createButton(Element.Cadmium);
                gbc.gridx++;
                createButton(Element.Indium);
                gbc.gridx++;
                createButton(Element.Tin);
                gbc.gridx++;
                createButton(Element.Antimony);
                gbc.gridx++;
                createButton(Element.Tellurium);
                gbc.gridx++;
                createButton(Element.Iodine);
                gbc.gridx++;
                createButton(Element.Xenon);
                gbc.gridx=0;
                gbc.gridy++;
                createButton(Element.Caesium);
                gbc.gridx++;
                createButton(Element.Barium);
                gbc.gridx++;
                createButton(Element.Lanthanum);
                gbc.gridx++;
                createButton(Element.Hafnium);
                gbc.gridx++;
                createButton(Element.Tantalum);
                gbc.gridx++;
                createButton(Element.Tungsten);
                gbc.gridx++;
                createButton(Element.Rhenium);
                gbc.gridx++;
                createButton(Element.Osmium);
                gbc.gridx++;
                createButton(Element.Iridium);
                gbc.gridx++;
                createButton(Element.Platinum);
                gbc.gridx++;
                createButton(Element.Gold);
                gbc.gridx++;
                createButton(Element.Mercury);
                gbc.gridx++;
                createButton(Element.Thallium);
                gbc.gridx++;
                createButton(Element.Lead);
                gbc.gridx++;
                createButton(Element.Bismuth);
                gbc.gridx++;
                createButton(Element.Polonium);
                gbc.gridx++;
                createButton(Element.Astatine);
                gbc.gridx++;
                createButton(Element.Radon);
                gbc.gridx=0;
                gbc.gridy++;
                createButton(Element.Francium);
                gbc.gridx++;
                createButton(Element.Radium);
                gbc.gridx++;
                createButton(Element.Actinium);
                gbc.gridx++;
                createButton(Element.Rutherfordium);
                gbc.gridx++;
                createButton(Element.Dubnium);
                gbc.gridx++;
                createButton(Element.Seaborgium);
                gbc.gridx++;
                createButton(Element.Bohrium);
                gbc.gridx++;
                createButton(Element.Hassium);
                gbc.gridx++;
                createButton(Element.Meitnerium);
                gbc.gridx++;
                createButton(Element.Ununnilium);
                gbc.gridx=0;
                gbc.gridy++;
                Label blankline=new Label("");
                gb.setConstraints(blankline,gbc);
                add(blankline);
                gbc.gridx=2;
                gbc.gridy++;
                createButton(Element.Cerium);
                gbc.gridx++;
                createButton(Element.Praseodymium);
                gbc.gridx++;
                createButton(Element.Neodymium);
                gbc.gridx++;
                createButton(Element.Promethium);
                gbc.gridx++;
                createButton(Element.Samarium);
                gbc.gridx++;
                createButton(Element.Europium);
                gbc.gridx++;
                createButton(Element.Gadolinium);
                gbc.gridx++;
                createButton(Element.Terbium);
                gbc.gridx++;
                createButton(Element.Dysprosium);
                gbc.gridx++;
                createButton(Element.Holmium);
                gbc.gridx++;
                createButton(Element.Erbium);
                gbc.gridx++;
                createButton(Element.Thulium);
                gbc.gridx++;
                createButton(Element.Ytterbium);
                gbc.gridx++;
                createButton(Element.Lutetium);
                gbc.gridx=2;
                gbc.gridy++;
                createButton(Element.Thorium);
                gbc.gridx++;
                createButton(Element.Protactinium);
                gbc.gridx++;
                createButton(Element.Uranium);
                gbc.gridx++;
                createButton(Element.Neptunium);
                gbc.gridx++;
                createButton(Element.Plutonium);
                gbc.gridx++;
                createButton(Element.Americium);
                gbc.gridx++;
                createButton(Element.Curium);
                gbc.gridx++;
                createButton(Element.Berkelium);
                gbc.gridx++;
                createButton(Element.Californium);
                gbc.gridx++;
                createButton(Element.Einsteinium);
                gbc.gridx++;
                createButton(Element.Fermium);
                gbc.gridx++;
                createButton(Element.Mendelevium);
                gbc.gridx++;
                createButton(Element.Nobelium);
                gbc.gridx++;
                createButton(Element.Lawrencium);
        }
        private void createButton(Element e) {
                Button but=new ElementButton(this, e);
          //      but.addActionListener(new ButtonAdapter(this,e));
                gbc.gridwidth = 1;
                gbc.gridheight = 1;

                gb.setConstraints(but, gbc);
                add(but);
        }


}

class ElementButton extends Button
{
   private Frame owner;
   private Element element;
   ElementButton(Frame f,Element e)
   {
      super(e.toString());
      owner=f;
      element=e;
   }

   public boolean action(Event evt, Object arg)
   {
      new InfoDialog(owner,element);
      return true;
   }

}

class WindowCloser extends WindowAdapter {
    Dialog dialog;
    public WindowCloser(Dialog d) {
      dialog = d;
    }
    /**
     * Method declaration
     *
     *
     * @param we
     *
     * @see
     */
    public void windowClosing(WindowEvent we) {
	    dialog.dispose();
    }

}



class InfoDialog extends Dialog {
  private Button btnOk;
                private static String extractTitle(Element e) {
                   //     String str=e.getClass().getName();
                        String str = e.elementName();
                        return str.substring(str.lastIndexOf('.')+1);
                }
                private void displayNumber(double x) {
                        if(x==x)
                                add(new Label(String.valueOf(x)));
                        else
                                add(new Label("Unknown"));
                }
                public InfoDialog(Frame parent,Element e) {
                        super(parent,extractTitle(e));
                        WindowListener wl = new WindowCloser(InfoDialog.this);
                        addWindowListener(wl); /*Adapter() {
                                public void windowClosing(WindowEvent evt) {
                                        dispose();
                                }
                        });                               */
                        setLayout(new GridLayout(12,2));
                        add(new Label("Atomic Number"));
                        add(new Label(String.valueOf(e.atomicNumber())));
                        add(new Label("Mass Number"));
                        add(new Label(String.valueOf(e.massNumber())));
                        add(new Label("Density"));
                        displayNumber(e.density());
                        add(new Label("Boiling Point"));
                        displayNumber(e.boilingPoint());
                        add(new Label("Melting Point"));
                        displayNumber(e.meltingPoint());
                        add(new Label("Atomic Radius"));
                        displayNumber(e.atomicRadius());
                        add(new Label("Covalent Radius"));
                        displayNumber(e.covalentRadius());
                        add(new Label("Electronegativity"));
                        displayNumber(e.electronegativity());
                        add(new Label("Specific Heat"));
                        displayNumber(e.specificHeat());
                        add(new Label("Electr. Conductivity"));
                        displayNumber(e.electricalConductivity());
                        add(new Label("Thermal Conductivity"));
                        displayNumber(e.thermalConductivity());
                        add(new Label(""));
                        btnOk = new Button("Ok");
                        add(btnOk);
                        setSize(300,240);
                        setVisible(true);
                }
                public boolean action(Event evt, Object arg)
   {
      if (evt.target.equals(btnOk))
      {
         dispose();
      }
  return true;
      }
        }
