/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package com.hartmath.initial;

import com.hartmath.expression.*;
import com.hartmath.util.*;
import com.hartmath.mapping.*;
import com.hartmath.patternmatching.*;
import com.hartmath.lib.*;

import org.kaffe.java.util.*;

//import java.net.URL;
import java.lang.*;
import java.util.Enumeration;
import java.io.*;
import java.util.*;


class ECheck implements FunctionEvaluator
{
   public ECheck()
   {
   }
   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if ((vect.size() == 1) || (vect.size() == 2))
      {
         if (C.EV(vect.get(0)) != C.True)
         {
            throw new MatchingFailed();
         }

         if (vect.size() == 2)
         {
            return vect.get(1);
         }

         return C.Null;
      }

      throw new MatchingFailed();
   }

}
/**
 * Class Declaration.
 *
 *
 * @see
 * 
 * @author
 * @version   %I%, %G%
 */
class ESet implements FunctionEvaluator, FunctionOpEvaluator
{

   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 2)
      {
         HObject        a0 = (HObject) vect.get(0);
         HObject        arg2 = C.EV((HObject) vect.get(1));

         if (a0 instanceof HSymbol)
         {
            ((HSymbol) a0).putDownRule(HRule.SET, a0, arg2);

            return arg2;
         }

         if (a0 instanceof HFunction)
         {
            HFunction   fun = ((HFunction) a0);
            // special: if lhs, has the form a[i] =...
            if ( fun.head().equals( C.Part )&&
                (fun.get(0) instanceof HSymbol) &&
                (fun.get(1) instanceof HInteger) &&
                 fun.size()==2)
            {
                 //  HObject     v1 = C.EV(fun.get(1));
                   HSymbol     sym = (HSymbol) fun.get(0);
                   HObject     result;
                   Object      temp;
                   if (!sym.isEmptyBlockVariable())
                   {
                      result = sym.popBlockVariable();
                      temp = execute(result, (HInteger)fun.get(1), arg2);
                      if (temp != null)
                      {
                         sym.pushBlockVariable((HObject) temp);
                         return arg2;
                      }
                      sym.pushBlockVariable(result);
                      return null;
                   }
                   result = sym.getDownRule(sym);
                   if (result != null)
                   {
                      temp = execute(result, (HInteger)fun.get(1), arg2);
                      if (temp != null)
                      {
                         sym.putDownRule(HRule.SET, sym, (HObject) temp);
                         return arg2;
                      }
                   }
                   StringBuffer buf = new StringBuffer("index ");
                   buf.append(((HInteger)fun.get(1)).toString());
                   buf.append(" out of range [..] in expression: ");
                   buf.append(fun.get(0).toString());
                   throw new HThrowException(C.OutOfRangeError, C.Part,  
                              new HString(buf.toString()));
            }
            fun = fun.evaluateLHSAttr();
            if (fun == null)
            {
               fun = ((HFunction) a0);
            }
            ((HFunction) a0).head().putDownRule(HRule.SET, fun, arg2);

            return arg2;
         }
      }

      return null;
   }
   public HObject execute(HObject first, HInteger hi, HObject second)
   {
      int sz = 0;
      if (first instanceof HFunction)
      {
        HFunction fun = (HFunction) ((HFunction) first).clone();
        sz = fun.size();
        if (hi.checkRange(1L, fun.size()))
        {
           int    indx = hi.intValue();
           fun.set(indx - 1, second);
           return fun;
        }
      }
      StringBuffer      buf = new StringBuffer("index ");

      buf.append(hi.toString());  
      buf.append(" out of range [1..");  
      buf.append(new Integer(sz).toString());  
      buf.append("] in expression: ");  
      buf.append(first.toString());  

      throw new HThrowException(C.OutOfRangeError, C.Part,  
                              new HString(buf.toString()));
   }
   /**
    * Method Declaration.
    * 
    * 
    * @param fun
    * 
    * @return
    * 
    * @see
    */
   public String toOpString(HFunction fun)
   {
      return E2Arg.operatorString(fun, "=", 20);
   }

   /**
    * Method Declaration.
    * 
    * 
    * @return
    * 
    * @see
    */
   public int precedence()
   {
      return 20;
   }

}

/**
 * Class Declaration.
 * 
 * 
 * @see
 * 
 * @author
 * @version   %I%, %G%
 */
class ESetDelayed implements FunctionEvaluator, FunctionOpEvaluator
{

   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 2)
      {
         HObject        a0 = (HObject) vect.get(0);

         if (a0 instanceof HSymbol)
         {

            // ((HSymbol)a0).setProperties(HSymbol.SETDELAYED);

            ((HSymbol) a0).putDownRule(HRule.SETDELAYED, a0, 
                                       vect.get(1));

            return C.Null;
         }

         if (a0 instanceof HFunction)
         {
            HFunction   fun = ((HFunction) a0).evaluateLHSAttr();

            if (fun == null)
            {
               fun = ((HFunction) a0);
            }

            // fun.setProperties(HSymbol.SETDELAYED);

            ((HFunction) a0).head().putDownRule(HRule.SETDELAYED, fun, 
                                                vect.get(1));

            return C.Null;
         }
      }

      return null;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param fun
    * 
    * @return
    * 
    * @see
    */
   public String toOpString(HFunction fun)
   {
      return E2Arg.operatorString(fun, ":=", 20);
   }

   /**
    * Method Declaration.
    * 
    * 
    * @return
    * 
    * @see
    */
   public int precedence()
   {
      return 20;
   }

}


/**
 * Class Declaration.
 * 
 * 
 * @see
 * 
 * @author
 * @version   %I%, %G%
 */
class EStatement implements FunctionEvaluator, FunctionOpEvaluator
{

   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() > 0)
      {
         for (int i = 0; i < vect.size() - 1; i++)
         {
            C.EV(vect.get(i));
         }

         return C.EV(vect.get(vect.size() - 1));
      }

      return C.Null;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param fun
    * 
    * @return
    * 
    * @see
    */
   public String toOpString(HFunction fun)
   {
      return E2Arg.operatorString(fun, ";", 10);
   }

   /**
    * Method Declaration.
    * 
    * 
    * @return
    * 
    * @see
    */
   public int precedence()
   {
      return 10;
   }

}




/**
 * Class Declaration.
 * 
 * 
 * @see
 * 
 * @author
 * @version   %I%, %G%
 */            /*
class ETraceRule implements FunctionEvaluator
{

   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 1)
      {
         if (vect.get(0).equals(C.True))
         {
            C.traceRuleFlag = true;

            return C.True;
         }

         if (vect.get(0).equals(C.False))
         {
            C.traceRuleFlag = false;

            return C.False;
         }
      }

      return null;
   }

}
 */
/**
 * Class Declaration.
 *
 *
 * @see
 * 
 * @author
 * @version   %I%, %G%
 */
class EUpSet implements FunctionEvaluator, FunctionOpEvaluator
{

   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 2)
      {
         HObject        a0 = (HObject) vect.get(0);
         HObject        arg2 = C.EV((HObject) vect.get(1));

         if (a0 instanceof HSymbol)
         {

            // ((HSymbol)a0).setProperties(HSymbol.UPSET);

            ((HSymbol) a0).putUpRule(HRule.UPSET, a0, arg2);

            return arg2;
         }

         if (a0 instanceof HFunction)
         {
            HFunction   fun = ((HFunction) a0).evaluateLHSAttr();
            if (fun == null)
            {
               fun = ((HFunction) a0);
            }

            // fun.setProperties(HSymbol.UPSET);

            if (fun.size() > 0)
            {
               if (fun.get(0) instanceof HSymbol)
               {
                  ((HSymbol) fun.get(0)).putUpRule(HRule.UPSET, fun, arg2);
               }
               else
               {
                  fun.get(0).head().putUpRule(HRule.UPSET, fun, arg2);
               }
            }
            else
            {
               fun.head().putUpRule(HRule.UPSET, fun, arg2);
            }

            return arg2;
         }
      }

      return null;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param fun
    * 
    * @return
    * 
    * @see
    */
   public String toOpString(HFunction fun)
   {
      return E2Arg.operatorString(fun, "^=", 20);
   }

   /**
    * Method Declaration.
    * 
    * 
    * @return
    * 
    * @see
    */
   public int precedence()
   {
      return 20;
   }

}

/**
 * Class Declaration.
 * 
 * 
 * @see
 * 
 * @author
 * @version   %I%, %G%
 */
class EUpSetDelayed implements FunctionEvaluator, FunctionOpEvaluator
{

   /**
    * @param vect   the function, which should be evaluated
    * @return       <code>null</code> or the evaluated object
    */
   public HObject evaluate(HFunction vect)
   {
      if (vect.size() == 2)
      {
         HObject        a0 = (HObject) vect.get(0);

         if (a0 instanceof HSymbol)
         {

            // ((HSymbol)a0).setProperties(HSymbol.UPSETDELAYED);

            ((HSymbol) a0).putUpRule(HRule.UPSETDELAYED, a0, 
                                     vect.get(1));

            return C.Null;
         }

         if (a0 instanceof HFunction)
         {
            HFunction   fun = ((HFunction) a0).evaluateLHSAttr();

            if (fun == null)
            {
               fun = ((HFunction) a0);
            }

            // fun.setProperties(HSymbol.UPSETDELAYED);

            if (fun.size() > 0)
            {
               if (fun.get(0) instanceof HSymbol)
               {
                  ((HSymbol) fun.get(0)).putUpRule(HRule.UPSETDELAYED, fun, 
                                                  vect.get(1));
               }
               else
               {
                  fun.get(0).head().putUpRule(HRule.UPSETDELAYED, fun, 
                                vect.get(1));
               }
            }
            else
            {
               fun.head().putUpRule(HRule.UPSETDELAYED, fun, 
                                    vect.get(1));
            }

            return C.Null;
         }
      }

      return null;
   }

   /**
    * Method Declaration.
    * 
    * 
    * @param fun
    * 
    * @return
    * 
    * @see
    */
   public String toOpString(HFunction fun)
   {
      return E2Arg.operatorString(fun, "^:=", 20);
   }

   /**
    * Method Declaration.
    * 
    * 
    * @return
    * 
    * @see
    */
   public int precedence()
   {
      return 20;
   }

}

/**
 * Implementation of programming functions
 * 
 * @see M
 * @see C
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 */
public class Programming implements FunctionEvaluator
{

   public HObject evaluate(HFunction vect)
   {
      C.Check.setEval(new ECheck());
      C.Set.setEval(new ESet());
      C.SetDelayed.setEval(new ESetDelayed());
      C.Statement.setEval(new EStatement());
      C.UpSet.setEval(new EUpSet());
      C.UpSetDelayed.setEval(new EUpSetDelayed());
      return C.Null;
   }

}


