/*--- formatted by Jindent 2.0b2, (www.c-lab.de/~jindent) ---*/
package com.hartmath.lib;

import com.hartmath.util.*;
import com.hartmath.expression.*;

import java.lang.*;
import java.io.*;
import java.util.Enumeration;

/**
 * Create an expression of the HObject class-hierarchy from the string representation
 * 
 * @author Klaus Hartlage (khartlage@t-online.de)
 */
public class Scanner {
	final static int  TT_EOF = 0;

	// final static int TT_WORD         = 1;
	// final static int TT_INT_NUMBER   = 2;
	// final static int TT_CHAR         = 4;

	final static int  T_NOT = 31;
	final static int  TT_DOT = 32;
	final static int  TT_POW = 33;
	final static int  TT_DIVIDE = 34;
	final static int  TT_MULTIPLY = 35;
	final static int  TT_SUBTRACT = 36;
	final static int  TT_ADD = 37;
	final static int  TT_EQUAL = 38;
	final static int  TT_UNEQUAL = 39;
	final static int  TT_GREATER = 40;
	final static int  TT_GREATEREQUAL = 41;
	final static int  TT_LESS = 42;
	final static int  TT_LESSEQUAL = 43;
	final static int  TT_AND = 44;
	final static int  TT_OR = 45;
	final static int  TT_RULE = 46;
	final static int  TT_RULEDELAYED = 47;
	final static int  TT_REPLACEALL = 48;
	final static int  TT_SET = 49;
	final static int  TT_SETDELAYED = 50;
	final static int  TT_UPSET = 51;
	final static int  TT_UPSETDELAYED = 52;
	final static int  TT_ARGOPEN = 128;
	final static int  TT_ARGCLOSE = 129;
	final static int  TT_LISTOPEN = 130;
	final static int  TT_LISTCLOSE = 131;
	final static int  TT_PARTOPEN = 132;
	final static int  TT_PARTCLOSE = 133;
	final static int  TT_COMMA = 134;
	final static int  TT_PERCENT = 135;
	final static int  TT_STRING = 136;
	final static int  TT_BLANK = 137;
	final static int  TT_IDENTIFIER = 138;
	final static int  TT_DIGIT = 139;
	final static int  TT_SEMICOLON = 140;
  final static int  TT_SLOT = 141;
  final static int  TT_LAMBDA = 142;
  final static int  TT_DECREMENT = 143;
  final static int  TT_INCREMENT = 144;
  final static int  TT_ADDTO = 145;
  final static int  TT_DIVIDEBY = 146;
  final static int  TT_SUBTRACTFROM = 147;
  final static int  TT_TIMESBY = 148;


	/*
	 * final static int bracketOpen = 3;
	 * final static int bracketClose = 4;
	 * final static int comma = 5;
	 */
	String				str;

	// StreamTokenizer st;

	char					ch;
	int					token;
	int					chIndx;

	/**
	 * Class Constructor.
	 * 
	 * 
	 * @param s
	 *
	 * @see
	 */
	public Scanner(String s) {
		str = s;
		token = TT_EOF;
		chIndx = 0;

		getNextToken();
}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @see
	 */
	void getChar() {
		if (str.length() > chIndx) {
			ch = str.charAt(chIndx++);

			return;
		}

		chIndx = str.length() + 1;
		ch = ' ';
		token = TT_EOF;
	}

	/*
	 * void getToken() {
	 * if ( ch != '\n' && ch != '\t' && ch != '\r' && ch != ' ') {
	 * token = TT_CHAR;
	 * return;
	 * }
	 * while ( str.length() > chIndx ) {
	 * ch = str.charAt(chIndx++);
	 * if ( ch != '\n' && ch != '\t' && ch != '\r' && ch != ' ') {
	 * token = TT_CHAR;
	 * return;
	 * }
	 * }
	 * ch = ' ';
	 * token = TT_EOF;
	 * }
	 */

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @see
	 */
	void getNextToken() {
		while (str.length() > chIndx) {
			ch = str.charAt(chIndx++);
			token = TT_EOF;

			if (ch != '\n' && ch != '\t' && ch != '\r' && ch != ' ') {
				if ((ch >= 'a' && ch <= 'z') || (ch >= 'A' && ch <= 'Z') || (ch=='$')) {
					token = TT_IDENTIFIER;

					return;
				}
				if (ch >= '0' && ch <= '9') {
					token = TT_DIGIT;

					return;
				}
        if (ch == '/' ) {
          if (str.length() > chIndx) {
						if (str.charAt(chIndx) == '/') {
							chIndx++;
              // read comment until end of line:
              while ( (str.length() > chIndx ) && (str.charAt(chIndx) != '\n') ) {
                chIndx++;
              }
              if (str.length() > chIndx ) {
                chIndx++;
              }
							continue;
						}
					}
        }

				switch (ch) {

				case '(': 
					token = TT_ARGOPEN;

					break;

				case ')': 
					token = TT_ARGCLOSE;

					break;

				case '{': 
					token = TT_LISTOPEN;

					break;

				case '}': 
					token = TT_LISTCLOSE;

					break;

				case '[': 
					token = TT_PARTOPEN;

					break;

				case ']': 
					token = TT_PARTCLOSE;

					break;

				case ',': 
					token = TT_COMMA;

					break;

				case '_': 
					token = TT_BLANK;

					break;

				case '.': 
					token = TT_DOT;

					break;

				case '"': 
					token = TT_STRING;

					break;

				case '%': 
					token = TT_PERCENT;

					break;

				case ';': 
					token = TT_SEMICOLON;

					break;

				case '^': 
					token = TT_POW;

					if (str.length() > chIndx) {
						ch = str.charAt(chIndx);

						if (ch == '=') {
							chIndx++;
							token = TT_UPSET;

							break;
						}
						if (ch == ':') {
							chIndx++;

							if (str.length() > chIndx) {
								ch = str.charAt(chIndx);

								if (ch == '=') {
									chIndx++;
									token = TT_UPSETDELAYED;

									break;
								}
							}
						}
					}

					break;

				case '/': 
					token = TT_DIVIDE;

					if (str.length() > chIndx) {
						if (str.charAt(chIndx) == '.') {
							chIndx++;
							token = TT_REPLACEALL;

							break;
						}
            if (str.charAt(chIndx) == '=') {
							chIndx++;
							token = TT_DIVIDEBY;

							break;
            }
					}

					break;

				case '*': 
					token = TT_MULTIPLY;
          if (str.length() > chIndx) {
						if (str.charAt(chIndx) == '*') {
							chIndx++;
							token = TT_POW;

							break;
						}
            if (str.charAt(chIndx) == '=') {
							chIndx++;
							token = TT_TIMESBY;

							break;
            }
					}

					break;

				case '+': 
					token = TT_ADD;
          if (str.length() > chIndx) {
            if (str.charAt(chIndx) == '+') {
							chIndx++;
							token = TT_INCREMENT;

							break;
						}
            if (str.charAt(chIndx) == '=') {
							chIndx++;
							token = TT_ADDTO;

							break;
            }
          }
					break;

				case '-': 
					token = TT_SUBTRACT;

					if (str.length() > chIndx) {
						if (str.charAt(chIndx) == '>') {
							chIndx++;
							token = TT_RULE;

							break;
						}
            if (str.charAt(chIndx) == '-') {
							chIndx++;
							token = TT_DECREMENT;

							break;
						}
            if (str.charAt(chIndx) == '=') {
							chIndx++;
							token = TT_SUBTRACTFROM;

							break;
						}
					}

					break;

				case '=': 
					token = TT_SET;

					if (str.length() > chIndx) {
						ch = str.charAt(chIndx);

						if (ch == '=') {
							chIndx++;
							token = TT_EQUAL;

							break;
						}
					}

					break;

				case '!': 
					token = T_NOT;

					if (str.length() > chIndx) {
						if (str.charAt(chIndx) == '=') {
							chIndx++;
							token = TT_UNEQUAL;

							break;
						}
					}

					break;

				case '>': 
					token = TT_GREATER;

					if (str.length() > chIndx) {
						if (str.charAt(chIndx) == '=') {
							chIndx++;
							token = TT_GREATEREQUAL;

							break;
						}
					}

					break;

				case '<': 
					token = TT_LESS;

					if (str.length() > chIndx) {
						if (str.charAt(chIndx) == '=') {
							chIndx++;
							token = TT_LESSEQUAL;

							break;
						}
					}

					break;

				case '&':
					token = TT_LAMBDA;
					if (str.length() > chIndx) {
						if (str.charAt(chIndx) == '&') {
              chIndx++;
							token = TT_AND;

							break;
						}
					}

					break;

				case '|': 
					if (str.length() > chIndx) {
						if (str.charAt(chIndx++) == '|') {
							token = TT_OR;

							break;
						}
					}

					break;

				case ':': 
					if (str.length() > chIndx) {
						if (str.charAt(chIndx) == '=') {
							chIndx++;
							token = TT_SETDELAYED;

							break;
						}
						if (str.charAt(chIndx) == '>') {
							chIndx++;
							token = TT_RULEDELAYED;

							break;
						}
					}

					break;
        case '#':
					token = TT_SLOT;

					break;
				default:
					throw new SyntaxError("unexpected character: " + ch);
				}

				if (token == TT_EOF) {
					throw new SyntaxError("token not found");
				}

				return;
			}
		}

		chIndx = str.length() + 1;
		ch = ' ';
		token = TT_EOF;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getNumber() {
		StringBuffer	inum = new StringBuffer();
		char dFlag = ' ';
    int numFormat = 10;
    char firstCh = ch;

		inum.append(ch);		// first digit
		getChar();
    if (firstCh=='0') {
      switch (ch) {
        case 'b':
          numFormat = 2;
          getChar();
          break;
        case 'B':
          numFormat = 2;
          getChar();
          break;
        case 'o':
          numFormat = 8;
          getChar();
          break;
        case 'O':
          numFormat = 8;
          getChar();
          break;
        case 'x':
          numFormat = 16;
          getChar();
          break;
        case 'X':
          numFormat = 16;
          getChar();
          break;
      }
    }

    if (numFormat == 16) {
		  while ((ch >= '0' && ch <= '9') ||
             (ch >= 'a' && ch <= 'f') ||
             (ch >= 'A' && ch <= 'F') ) {
			  inum.append(ch);
			  getChar();
		  }
    }
    else {
      while ((ch >= '0' && ch <= '9') ||
             (ch == '.') || (ch=='E') || (ch=='e')) {
		   	if ((ch == '.') || (ch=='E') || (ch=='e')) {
				  if (ch=='.' && dFlag!=' ') {
					  break;
				  }
          if ((dFlag=='E') || (dFlag=='e')) {
					  break;
				  }
          dFlag = ch;
          inum.append(ch);
          getChar();
          if ((ch=='-')||(ch=='+')) {
            inum.append(ch);
            getChar();
          }
			  }
			  else {
          inum.append(ch);
          getChar();
        }
		  }
    }
		chIndx--;

		getNextToken();

		// token = TT_INT_NUMBER;
		// getToken();

    try {
		  if (dFlag!=' ') {
			  return new HDouble(inum.toString());
		  }

		  return new HInteger(inum.toString(), numFormat);
    }
    catch (Throwable e) {
      throw new SyntaxError("Number format error: " + inum.toString());
    }
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HSymbol getIdentifier() {
		StringBuffer	ident = new StringBuffer();

		ident.append(ch);
		getChar();

		while ((ch >= 'a' && ch <= 'z') || (ch >= 'A' && ch <= 'Z') 
				 || (ch >= '0' && ch <= '9')) {
			ident.append(ch);
			getChar();
		}

		chIndx--;

		getNextToken();

		// token = TT_WORD;
		// getToken();
    HSymbol  sym;
    if (ident.charAt(0)>='A' &&  ident.charAt(0)<='Z')
    {
		  sym = new HSymbol(ident, C.loadScript );
    }
    else
    {
      sym = new HSymbol(ident);
    }
		/*
		 * if ( HSymbol.HT.get(sym) == null ) {
		 * return (HSymbol) HSymbol.HT.get(sym);
		 * }
		 * HSymbol.HT.put(sym);
		 * return sym;
		 */
		HSymbol  res = sym.addSymbol();

		if (res != null) {
			return res;
		}

		return sym;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getString() {
		StringBuffer	ident = new StringBuffer();

		getChar();

		if ((ch == '\n') || (token == TT_EOF)) {
			throw new SyntaxError("string -" + ident.toString() 
										 + "- contains no character.");
		}

		while (ch != '"') {
			if ((ch == '\\')) {
				getChar();

				switch (ch) {

				case '\\': 
					ident.append(ch);

					break;

				case 'n': 
					ident.append("\n");

					break;

				case 't': 
					ident.append("\t");

					break;

				default: 
					throw new SyntaxError("string - unknown character after back-slash.");
				}

				getChar();
			} else {
				if ((ch != '"') && ((ch == '\n') || (token == TT_EOF))) {
					throw new SyntaxError("string -" + ident.toString() 
												 + "- not closed.");
				}

				ident.append(ch);
				getChar();
			}
		}

		getNextToken();

		return new HString(ident);
	}

  public void getArguments(HFunction function) {
    do {
			function.add(getStatement());

			if (token != TT_COMMA) {
				break;
			}

			getNextToken();
		} while (true);
  }
	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getList() {
		HFunction	function = new HFunction(C.List);

		getNextToken();

		if (token == TT_LISTCLOSE) {
			getNextToken();

			return function;
		}

    getArguments( function );

		if (token == TT_LISTCLOSE) {
			getNextToken();

			return function;
		}

		throw new SyntaxError("expecting: }");
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @param symbol
	 *
	 * @return
	 *
	 * @see
	 */
	HObject getFunction(HSymbol symbol) {
		HFunction	function = new HFunction(symbol);

		getNextToken();

		if (token == TT_ARGCLOSE) {
			getNextToken();

			return function;
		}

    getArguments( function );

		if (token == TT_ARGCLOSE) {
			getNextToken();

			return function;
		}

		throw new SyntaxError("expecting: )");
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getFactor() {
		HObject  temp;

		if (token == TT_IDENTIFIER) {
			HSymbol  obj = getIdentifier();

			if (token == TT_BLANK) {
				getNextToken();
				if (token == TT_IDENTIFIER) {
					HSymbol  check = getIdentifier();

					return new HPattern(obj, check);
				} else {
					return new HPattern(obj);
				}
			}
			if (token == TT_ARGOPEN) {
				return getFunction(obj);
			}

			return obj;
		}
		if (token == TT_DIGIT) {
			return getNumber();
		}
		if (token == TT_ARGOPEN) {
			getNextToken();

			temp = getStatement();

			if (token != TT_ARGCLOSE) {
				throw new SyntaxError("expecting: )");
			}

			getNextToken();

			return temp;
		}
		if (token == TT_LISTOPEN) {
			return getList();
		}
		if (token == TT_STRING) {
			return getString();
		}
		if (token == TT_PERCENT) {
			int	countPercent = 1;

			do {
				countPercent++;

				getNextToken();
			} while (token == TT_PERCENT);

      //Context ct = ((ContextThread) Thread.currentThread()).getContext();
			if (C.count < countPercent) {
				throw new SyntaxError("too much % characters in factor.");
			}

			return (HObject) C.OutArray.get(C.count - 2);
		}
    if (token == TT_SLOT) {
      getNextToken();
      if (token == TT_DIGIT) {
			  return C.Slot.f(getNumber());
		  }
      else {
        return C.Slot.f(C.C1);
      }
		}

		switch (token) {

		case TT_ARGCLOSE: 
			throw new SyntaxError("too much open ) in factor.");

		case TT_LISTCLOSE: 
			throw new SyntaxError("too much open } in factor.");

		case TT_PARTCLOSE: 
			throw new SyntaxError("too much open ] in factor.");
		}

		throw new SyntaxError("error in factor at character:" + ch);
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getPart() {
		HObject  temp = getFactor();

		if (token != TT_PARTOPEN) {
			return temp;
		}

		HFunction	function = null;

		do {
			if (function == null) {
				function = new HFunction(C.Part, temp);
			} else {
				function = new HFunction(C.Part, (HObject) function);
			}

			getNextToken();

			if (token == TT_PARTCLOSE) {
				throw new SyntaxError("statement (index) expected in []");
			}

			function.add(getStatement());

			if (token == TT_PARTCLOSE) {
				getNextToken();
			} else {
				throw new SyntaxError("expecting: ]");
			}
		} while (token == TT_PARTOPEN);

		return function;
	}

  HObject getDecInc() {
    if (token == TT_DECREMENT) {
			getNextToken();
			return C.PreDecrement.f(getPart());
		}
    if (token == TT_INCREMENT) {
			getNextToken();
			return C.PreIncrement.f(getPart());
		}
		HObject  temp = getPart();
		if (token == TT_DECREMENT) {
			getNextToken();
			return C.Decrement.f(temp);
		}
    if (token == TT_INCREMENT) {
			getNextToken();
			return C.Increment.f(temp);
		}

		return temp;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getFactorial() {
		HObject  temp = getDecInc();

		while (token == T_NOT) {
			getNextToken();

			temp = new HFunction(C.Factorial, temp);
		}

		return temp;
	}

	// matrix multiplication M0.M1

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getDot() {
		HObject  temp = getFactorial();

		if (token != TT_DOT) {
			return temp;
		}

		HFunction	fDots = new HFunction(C.Dot, temp);

		do {
			getNextToken();
			fDots.add(getFactorial());
		} while (token == TT_DOT);		// end do

		return fDots;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getPower() {		// order: e1^(e2^e3)
		HObject  temp = getDot();

		if (token != TT_POW) {
			return temp;
		}

		do {
			getNextToken();

			HFunction	f = new HFunction(C.Pow, temp);

			f.add(getDot());

			temp = f;
		} while (token == TT_POW);		// end do

		return temp;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getDivision() {
		HObject  temp0 = getPower();
		HObject  temp1;

		if (token != TT_DIVIDE) {
			return temp0;
		}

		getNextToken();

		temp1 = getPower();

		if (token != TT_DIVIDE) {
			if ((temp0 instanceof HInteger) && (temp1 instanceof HInteger)) {
				if (temp1.equals(C.C0)) {
					throw new HThrowException(C.ArithmeticError, C.Divide, new HString("division by zero"));
				}

				return new HFraction((HInteger) temp0, (HInteger) temp1);
			}

			return new HFunction(C.Multiply, temp0, C.Pow.f(temp1, C.CN1));
		}

		HFunction	f = new HFunction(C.Multiply, temp0, C.Pow.f(temp1, C.CN1));

		do {
			getNextToken();
			f.add(C.Pow.f(getPower(), C.CN1));
		} while (token == TT_DIVIDE);		// end do

		return f;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @param negSign
	 *
	 * @return
	 *
	 * @see
	 */
	HObject getMultiplication(boolean negSign) {
		HObject  temp = getDivision();

		if (negSign == true) {
			if (temp instanceof HInteger) {
				temp = ((HInteger) temp).multiply(C.CN1);
			} else {
				if (temp instanceof HFraction) {
					temp = ((HFraction) temp).multiply(C.CN1);
				} else {
					temp = C.Multiply.f(C.CN1, temp);
				}
			}
		}
		if (token != TT_MULTIPLY) {
			return temp;
		}

		HFunction	f = new HFunction(C.Multiply, temp);

		do {
			getNextToken();
			f.add(getDivision());
		} while (token == TT_MULTIPLY);		// end do

		return f;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getExpression() {
		int		tokenTemp;
		HObject  temp;

		if (token == TT_ADD || token == TT_SUBTRACT) {
			tokenTemp = token;

			getNextToken();

			if (tokenTemp == TT_SUBTRACT) {
				temp = getMultiplication(true);
			} else {
				temp = getMultiplication(false);
			}
		} else {
			temp = getMultiplication(false);
		}
		if (token == TT_ADD || token == TT_SUBTRACT) {
			HFunction	f = C.Add.f(temp);

			do {
				if (token == TT_ADD) {
					getNextToken();
					f.add(getMultiplication(false));
				} else {
					getNextToken();

					// f.add( C.Multiply.f(C.CN1, getMultiplication(true) ) );

					f.add(getMultiplication(true));
				}
			} while (token == TT_ADD || token == TT_SUBTRACT);		// end do

			return f;
		} else {
			return temp;
		}
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getCondition() {												// == <= >= !=  < >
		HObject  temp = getExpression();
    int tmp_token;
		while (token == TT_EQUAL || token == TT_UNEQUAL || token == TT_LESS
				 || token == TT_LESSEQUAL || token == TT_GREATER
				 || token == TT_GREATEREQUAL) {
      tmp_token = token;
      getNextToken();
			switch (tmp_token) {

			case TT_EQUAL:
				temp = C.Equal.f(temp, getExpression());
				break;

			case TT_UNEQUAL:
				temp = C.Unequal.f(temp, getExpression());
				break;

			case TT_LESS:
				temp = C.Less.f(temp, getExpression());
				break;

			case TT_LESSEQUAL:
				temp = C.LessEqual.f(temp, getExpression());
				break;

			case TT_GREATER:
				temp = C.Greater.f(temp, getExpression());
				break;

			case TT_GREATEREQUAL:
				temp = C.GreaterEqual.f(temp, getExpression());
				break;
			}
		}

		return temp;
	}

  HObject getNot() {
    if (token != T_NOT) {
		  return getCondition();
    }
    getNextToken();
		return new HFunction(C.Not, getNot());
	}
	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getAnd() {		// a && b
		HObject  temp = getNot();

		while (token == TT_AND) {
			getNextToken();

			temp = C.And.f(temp, getCondition());
		}

		return temp;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getOr() {		// a || b
		HObject  temp = getAnd();

		while (token == TT_OR) {
			getNextToken();

			temp = C.Or.f(temp, getCondition());
		}

		return temp;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getRule() {		// ->   :>
		HObject  temp = getOr();

		if (token != TT_RULE && token != TT_RULEDELAYED) {
			return temp;
		}

		do {
			if (token == TT_RULE) {
				getNextToken();

				temp = C.Rule.f(temp, getOr());

				continue;
			}
			if (token == TT_RULEDELAYED) {
				getNextToken();

				temp = C.RuleDelayed.f(temp, getOr());

				continue;
			}
		} while (token == TT_RULE && token == TT_RULEDELAYED);		// end do

		return temp;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getReplace() {		// /.
		HObject  temp = getRule();

		if (token != TT_REPLACEALL) {
			return temp;
		}

		do {
			getNextToken();

			temp = C.ReplaceAll.f(temp, getRule());
		} while (token == TT_REPLACEALL);		// end do

		return temp;
	}

  HObject getSymbolArith() {
    HObject  temp = getReplace();
    if (token == TT_ADDTO) {
      getNextToken();
      return C.AddTo.f(temp, getReplace());
    }
    if (token == TT_DIVIDEBY) {
      getNextToken();
      return C.DivideBy.f(temp, getReplace());
    }
    if (token == TT_SUBTRACTFROM) {
      getNextToken();
      return C.SubtractFrom.f(temp, getReplace());
    }
    if (token == TT_TIMESBY) {
      getNextToken();
      return C.TimesBy.f(temp, getReplace());
    }
    return temp;
  }

  HObject getLambda() {
    HObject  temp = getSymbolArith();
    if (token == TT_LAMBDA) {
      getNextToken();
      if (token != TT_ARGOPEN) {
        return C.Lambda.f(C.Null, temp);
		  }
      getNextToken();
      if (token == TT_ARGCLOSE) {
        getNextToken();
        return C.Lambda.f(C.Null, temp);
		  }
      HFunction function = C.Lambda.f(C.Null, temp);
      getArguments( function );

		  if (token == TT_ARGCLOSE) {
		  	getNextToken();

		  	return function;
		  }

      throw new SyntaxError("expecting: )");
    }
    return temp;
  }

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getAssign() {		// a = 1+1; f(x):=g(x,y)
		HObject  temp = getLambda();
    int tmp_token;
		while (token == TT_SET || token == TT_SETDELAYED || token == TT_UPSET
				 || token == TT_UPSETDELAYED) {
      tmp_token = token;
      getNextToken();
			switch (tmp_token) {

			case TT_SET:
				temp = C.Set.f(temp, getAssign());
				break;
			case TT_SETDELAYED:
				temp = C.SetDelayed.f(temp, getAssign());
				break;
			case TT_UPSET:
				temp = C.UpSet.f(temp, getAssign());
        break;
			case TT_UPSETDELAYED:
				temp = C.UpSetDelayed.f(temp, getAssign());
				break;
			}
		}

		return temp;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @see
	 */
	HObject getStatement() {
		HObject  temp = getAssign();

		// C.resultOut.appendLine( temp.toString() );

		if (token != TT_SEMICOLON) {
			return temp;
		}

		HFunction	f = C.Statement.f(temp);

		do {
			getNextToken();

			if (token == TT_EOF || token == TT_ARGCLOSE || token == TT_LISTCLOSE 
					  || token == TT_PARTCLOSE) {
				f.add(C.Null);

				return f;
			}

			temp = getAssign();

			// C.resultOut.appendLine( temp.toString() );

			f.add(temp);
		} while (token == TT_SEMICOLON);		// end do

		return f;
	}

	/**
	 * Method Declaration.
	 * 
	 * 
	 * @return
	 *
	 * @exception SyntaxError
	 *
	 * @see
	 */
	public HObject start() throws SyntaxError {
		HObject  temp = getStatement();

		if (token != TT_EOF) {
			if (token == TT_ARGCLOSE) {
				throw new SyntaxError("too many closing );end-of-file not reached; read until:\n" 
											 + temp.toString());
			}
			if (token == TT_LISTCLOSE) {
				throw new SyntaxError("too many closing };end-of-file not reached; read until:\n" 
											 + temp.toString());
			}
			if (token == TT_PARTCLOSE) {
				throw new SyntaxError("too many closing ];end-of-file not reached; read until:\n" 
											 + temp.toString());
			}

			throw new SyntaxError("end-of-file not reached; read until:\n" 
										 + temp.toString());
		}

		return temp;
	}
}



/*--- formatting done in "Sun Java Convention" style on 06-18-1999 ---*/
