/*--- formatted by Jindent 2.0b2, (www.c-lab.de/~jindent) ---*/

package com.hartmath.mapping;

import com.hartmath.expression.*;

/**
 * Class that represents a function evaluation object.
 * FunctionMapper is used as an interface for built-in functions,
 * which are associated with a symbol.
 * 
 * @see HSymbol
 * @author Klaus Hartlage  <A HREF="mailto:khartlage@t-online.de">khartlage@t-online.de</A>
 * @version   %I%, %G%
 */
public class Size1Function extends FunctionMapper {

  public Size1Function(UnaryFunction  uFun)
  {
    super( Size1TypeX.FUNCTION, uFun );
  }

  /**
	 * Evaluate the given function if possible.
	 * 
	 * @param fun the function, which should be evaluated
	 * @return <c>null</c> if the function could not be evaluated; the evaluated object otherwise
	 */
	public HObject evaluate(HFunction fun)
  {
    if ( uPredicate.execute(fun) ) {
      return uFunction.execute((HFunction) fun.get(0));
    }
    return null;
  }
}



/*--- formatting done in "Sun Java Convention" style on 06-18-1999 ---*/
