package com.hartmath.mapping;

import com.hartmath.expression.*;


public class Size1TypeX implements UnaryPredicate
{
  private int x;

  final public static Size1TypeX DOUBLE        = new Size1TypeX(HObject.DOUBLEID);
  final public static Size1TypeX DOUBLECOMPLEX = new Size1TypeX(HObject.DOUBLECOMPLEXID);
  final public static Size1TypeX INTEGER       = new Size1TypeX(HObject.INTEGERID);
  final public static Size1TypeX FRACTION      = new Size1TypeX(HObject.FRACTIONID);
  final public static Size1TypeX COMPLEX       = new Size1TypeX(HObject.COMPLEXID);
  final public static Size1TypeX STRING        = new Size1TypeX(HObject.STRINGID);
  final public static Size1TypeX SYMBOL        = new Size1TypeX(HObject.SYMBOLID);
  final public static Size1TypeX FUNCTION      = new Size1TypeX(HObject.FUNCTIONID);

  public Size1TypeX(int t)
  {
    x = t;
  }
  /**
    * checks if the function has size()==1 and
    * and the first argument has the given hierarchy()
    */
	public boolean execute(HFunction f)
  {
    return (f.size()==1)&&
           ( (f.get(0).hierarchy()&x) == x);    //check if x is in the given set
  }
}
