package com.hartmath.mapping;

import com.hartmath.expression.*;

public class Size2TypeX implements UnaryPredicate
{
  private int x1;

  final public static Size2TypeX DOUBLE        = new Size2TypeX(HObject.DOUBLEID);
  final public static Size2TypeX DOUBLECOMPLEX = new Size2TypeX(HObject.DOUBLECOMPLEXID);
  final public static Size2TypeX INTEGER       = new Size2TypeX(HObject.INTEGERID);
  final public static Size2TypeX FRACTION      = new Size2TypeX(HObject.FRACTIONID);
  final public static Size2TypeX COMPLEX       = new Size2TypeX(HObject.COMPLEXID);
  final public static Size2TypeX STRING        = new Size2TypeX(HObject.STRINGID);
  final public static Size2TypeX SYMBOL        = new Size2TypeX(HObject.SYMBOLID);
  final public static Size2TypeX FUNCTION      = new Size2TypeX(HObject.FUNCTIONID);

  public Size2TypeX(int x)
  {
    x1 = x;
  }
  /**
    * checks if the function has size()==1 and
    * and the first argument has the given hierarchy()
    */
	public boolean execute(HFunction f)
  {
    return (f.size()==2)&&
           ((f.get(0).hierarchy()&x1)==x1);
  }
}
